"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.find-index.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.array.reverse.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.match.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("regenerator-runtime/runtime.js");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _addDays = _interopRequireDefault(require("date-fns/addDays"));

var _addMonths = _interopRequireDefault(require("date-fns/addMonths"));

var _addYears = _interopRequireDefault(require("date-fns/addYears"));

var _isValid = _interopRequireDefault(require("date-fns/isValid"));

var _parseISO = _interopRequireDefault(require("date-fns/parseISO"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactTextMask = _interopRequireDefault(require("react-text-mask"));

var _Input2 = _interopRequireWildcard(require("../input/Input"));

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../../shared/component-helper");

var _DatePickerCalc = require("./DatePickerCalc");

var _DatePickerContext = _interopRequireDefault(require("./DatePickerContext"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref8 = _react.default.createElement("span", {
  className: "dnb-date-picker--separator",
  "aria-hidden": true
}, ' – ');

var DatePickerInput = function (_React$PureComponent) {
  _inherits(DatePickerInput, _React$PureComponent);

  var _super = _createSuper(DatePickerInput);

  function DatePickerInput(props) {
    var _this;

    _classCallCheck(this, DatePickerInput);

    _this = _super.call(this, props);
    _this.state = {
      _listenForPropChanges: true,
      focusState: 'virgin'
    };

    _this.shortcutHandler = function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(e) {
        var _window, success, separators, possibleFormats, date, i, l, mode;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!_this.focusMode) {
                  _context.next = 24;
                  break;
                }

                success = (e.clipboardData || ((_window = window) === null || _window === void 0 ? void 0 : _window.clipboardData)).getData('text');

                if (!success) {
                  _context.next = 24;
                  break;
                }

                e.preventDefault();
                _context.prev = 4;
                separators = ['.', '/'];
                possibleFormats = ['yyyy-MM-dd'];
                possibleFormats.forEach(function (date) {
                  separators.forEach(function (sep) {
                    possibleFormats.push(date.replace(/-/g, sep));
                  });
                });
                possibleFormats.forEach(function (date) {
                  possibleFormats.push(date.split('').reverse().join(''));
                });
                i = 0, l = possibleFormats.length;

              case 10:
                if (!(i < l)) {
                  _context.next = 17;
                  break;
                }

                date = (0, _DatePickerCalc.convertStringToDate)(success, {
                  date_format: possibleFormats[i]
                });

                if (!date) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt("break", 17);

              case 14:
                ++i;
                _context.next = 10;
                break;

              case 17:
                mode = _this.focusMode === 'start' ? 'startDate' : 'endDate';

                if (date && !_this.state[mode]) {
                  _this.context.setState(_defineProperty({}, mode, date));
                }

                _context.next = 24;
                break;

              case 21:
                _context.prev = 21;
                _context.t0 = _context["catch"](4);
                (0, _componentHelper.warn)(_context.t0);

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[4, 21]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    _this.callOnChangeAsInvalid = function (state) {
      var _this$context$state = _extends({}, _this.context, state),
          startDate = _this$context$state.startDate,
          endDate = _this$context$state.endDate,
          event = _this$context$state.event;

      _this.context.updateState({
        hoverDate: null
      });

      if (_this.context.hasHadValidDate) {
        _this.context.callOnChangeHandler({
          startDate: startDate,
          endDate: endDate,
          event: event
        });

        _this.context.updateState({
          hasHadValidDate: false
        });
      }
    };

    _this.callOnChange = function (_ref2) {
      var startDate = _ref2.startDate,
          endDate = _ref2.endDate,
          event = _ref2.event;
      var state = {
        changeMonthViews: true,
        hasHadValidDate: false
      };

      if (typeof startDate !== 'undefined' && (0, _isValid.default)(startDate)) {
        state.startDate = startDate;
      }

      if (!_this.props.isRange) {
        endDate = startDate;
      }

      if (typeof endDate !== 'undefined' && (0, _isValid.default)(endDate)) {
        state.endDate = endDate;
      }

      _this.context.setDate(state, function () {
        if (typeof startDate !== 'undefined' && (0, _isValid.default)(startDate) || typeof endDate !== 'undefined' && (0, _isValid.default)(endDate)) {
          _this.context.callOnChangeHandler({
            event: event
          });
        }
      });
    };

    _this.callOnType = function (_ref3) {
      var event = _ref3.event;

      var getDates = function getDates() {
        return ['start', 'end'].reduce(function (acc, mode) {
          acc["".concat(mode, "Date")] = [_this["_".concat(mode, "Year")] || _this.context["__".concat(mode, "Year")] || 'yyyy', _this["_".concat(mode, "Month")] || _this.context["__".concat(mode, "Month")] || 'mm', _this["_".concat(mode, "Day")] || _this.context["__".concat(mode, "Day")] || 'dd'].join('-');
          return acc;
        }, {});
      };

      var _getDates = getDates(),
          startDate = _getDates.startDate,
          endDate = _getDates.endDate;

      startDate = (0, _parseISO.default)(startDate);
      endDate = (0, _parseISO.default)(endDate);

      if (!(0, _isValid.default)(startDate)) {
        startDate = null;
      }

      if (!(0, _isValid.default)(endDate)) {
        endDate = null;
      }

      var returnObject = _this.context.getReturnObject({
        startDate: startDate,
        endDate: endDate,
        event: event
      });

      if (returnObject.is_valid === false || returnObject.is_valid_start_date === false || returnObject.is_valid_end_date === false) {
        var _getDates2 = getDates(),
            _startDate = _getDates2.startDate,
            _endDate = _getDates2.endDate;

        var typedDates = _this.props.isRange ? {
          start_date: _startDate,
          end_date: _endDate
        } : {
          date: _startDate
        };
        returnObject = _extends({}, returnObject, typedDates);
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_this.context, 'on_type', returnObject);
    };

    _this.prepareCounting = function () {
      var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(_ref4) {
        var _this$callOnChange;

        var keyCode, target, event, isDate, isInRange, date, count, endPos;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                keyCode = _ref4.keyCode, target = _ref4.target, event = _ref4.event;
                isDate = target.getAttribute('class').match(/__input--([day|month|year]+)($|\s)/)[1];
                isInRange = target.getAttribute('id').match(/[0-9]-([start|end]+)-/)[1];
                date = isInRange === 'start' ? _this.context.startDate : _this.context.endDate;

                if (date) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt("return");

              case 6:
                count = keyCode === 'up' ? 1 : -1;

                if (!(keyCode === 'up' || keyCode === 'down')) {
                  _context2.next = 17;
                  break;
                }

                _context2.t0 = isDate;
                _context2.next = _context2.t0 === 'day' ? 11 : _context2.t0 === 'month' ? 13 : _context2.t0 === 'year' ? 15 : 17;
                break;

              case 11:
                date = (0, _addDays.default)(date, count);
                return _context2.abrupt("break", 17);

              case 13:
                date = (0, _addMonths.default)(date, count);
                return _context2.abrupt("break", 17);

              case 15:
                date = (0, _addYears.default)(date, count);
                return _context2.abrupt("break", 17);

              case 17:
                _this.callOnChange((_this$callOnChange = {}, _defineProperty(_this$callOnChange, isInRange === 'start' ? 'startDate' : 'endDate', date), _defineProperty(_this$callOnChange, "event", event), _this$callOnChange));

                _context2.next = 20;
                return wait(1);

              case 20:
                endPos = target.value.length;
                target.focus();
                target.setSelectionRange(0, endPos);

              case 23:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x2) {
        return _ref5.apply(this, arguments);
      };
    }();

    _this.onFocusHandler = function (event) {
      try {
        var target = event.target;
        var endPos = target.value.length;
        target.focus();
        target.setSelectionRange(0, endPos);
      } catch (e) {
        (0, _componentHelper.warn)(e);
      }

      _this.setState({
        focusState: 'focus',
        _listenForPropChanges: false
      });
    };

    _this.onBlurHandler = function () {
      _this.focusMode = null;

      _this.setState({
        focusState: 'blur',
        _listenForPropChanges: false
      });
    };

    _this.onKeyDownHandler = function () {
      var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(event) {
        var keyCode, target, size, firstSelectionStart, secondSelectionStart, isValid, index, nextSibling, prevSibling, endPos;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                keyCode = (0, _keycode.default)(event);
                target = event.target;
                _context3.t0 = keyCode;
                _context3.next = _context3.t0 === 'up' ? 5 : _context3.t0 === 'down' ? 5 : _context3.t0 === 'tab' ? 9 : 10;
                break;

              case 5:
                event.persist();
                event.preventDefault();

                _this.prepareCounting({
                  event: event,
                  keyCode: keyCode,
                  target: target
                });

                return _context3.abrupt("return", false);

              case 9:
                return _context3.abrupt("return", false);

              case 10:
                size = parseFloat(target.getAttribute('size'));
                firstSelectionStart = target.selectionStart;
                _context3.next = 14;
                return wait(1);

              case 14:
                secondSelectionStart = target.selectionStart;
                isValid = /[0-9]/.test(keyCode);
                index = _this.refList.findIndex(function (_ref7) {
                  var current = _ref7.current;
                  return current.inputElement === target;
                });

                if (!(index < _this.refList.length - 1 && (secondSelectionStart === size && isValid && keyCode !== 'left' && keyCode !== 'backspace' || firstSelectionStart === size && keyCode === 'right'))) {
                  _context3.next = 30;
                  break;
                }

                _context3.prev = 18;

                if (_this.refList[index + 1].current) {
                  _context3.next = 21;
                  break;
                }

                return _context3.abrupt("return");

              case 21:
                nextSibling = _this.refList[index + 1].current.inputElement;

                if (nextSibling) {
                  nextSibling.focus();
                  nextSibling.setSelectionRange(0, 0);
                }

                _context3.next = 28;
                break;

              case 25:
                _context3.prev = 25;
                _context3.t1 = _context3["catch"](18);
                (0, _componentHelper.warn)(_context3.t1);

              case 28:
                _context3.next = 36;
                break;

              case 30:
                if (!(firstSelectionStart === 0 && index > 0)) {
                  _context3.next = 36;
                  break;
                }

                _context3.t2 = keyCode;
                _context3.next = _context3.t2 === 'left' ? 34 : _context3.t2 === 'backspace' ? 34 : 36;
                break;

              case 34:
                try {
                  prevSibling = _this.refList[index - 1].current.inputElement;

                  if (prevSibling) {
                    endPos = prevSibling.value.length;
                    prevSibling.focus();
                    prevSibling.setSelectionRange(endPos, endPos);
                  }
                } catch (e) {
                  (0, _componentHelper.warn)(e);
                }

                return _context3.abrupt("break", 36);

              case 36:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[18, 25]]);
      }));

      return function (_x3) {
        return _ref6.apply(this, arguments);
      };
    }();

    _this.set_startDay = function (event) {
      _this.setDate(event, 'start', 'Day');
    };

    _this.set_startMonth = function (event) {
      _this.setDate(event, 'start', 'Month');
    };

    _this.set_startYear = function (event) {
      _this.setDate(event, 'start', 'Year');
    };

    _this.set_endDay = function (event) {
      _this.setDate(event, 'end', 'Day');
    };

    _this.set_endMonth = function (event) {
      _this.setDate(event, 'end', 'Month');
    };

    _this.set_endYear = function (event) {
      _this.setDate(event, 'end', 'Year');
    };

    _this.setDate = function (event, mode, type) {
      event.persist();
      var value = event.target.value;
      _this["_".concat(mode).concat(type)] = value;

      if (_this.context["".concat(mode, "Date")]) {
        _this["tmp_".concat(mode, "Date")] = _this.context["".concat(mode, "Date")];
      }

      var fallback = _this["tmp_".concat(mode, "Date")];

      var year = _this["_".concat(mode, "Year")] || fallback && fallback.getFullYear();
      var month = _this["_".concat(mode, "Month")] || fallback && fallback.getMonth() + 1;
      var day = _this["_".concat(mode, "Day")] || fallback && fallback.getDate();
      var date = new Date(parseFloat(year), parseFloat(month) - 1, parseFloat(day));
      var isValidDate = !/[^0-9]/.test(day) && !/[^0-9]/.test(month) && !/[^0-9]/.test(year) && (0, _isValid.default)(date) && date.getDate() == parseFloat(day) && date.getMonth() + 1 == parseFloat(month) && date.getFullYear() == parseFloat(year);

      if (isValidDate) {
        var _this$callOnChange2;

        _this.callOnChange((_this$callOnChange2 = {}, _defineProperty(_this$callOnChange2, "".concat(mode, "Date"), date), _defineProperty(_this$callOnChange2, "event", event), _this$callOnChange2));
      } else {
        var _this$callOnChangeAsI;

        _this.context.setDate(_defineProperty({}, "".concat(mode, "Date"), null));

        _this.context.updateState(_defineProperty({}, "__".concat(mode).concat(type), value));

        _this.callOnChangeAsInvalid((_this$callOnChangeAsI = {}, _defineProperty(_this$callOnChangeAsI, "".concat(mode, "Date"), null), _defineProperty(_this$callOnChangeAsI, "event", event), _this$callOnChangeAsI));
      }

      _this.callOnType({
        event: event
      });
    };

    _this.renderInputElement = function (params) {
      var _this$props = _this.props,
          id = _this$props.id,
          isRange = _this$props.isRange;
      _this.refList = [];

      var startDateList = _this.generateDateList(params, 'start');

      var endDateList = _this.generateDateList(params, 'end');

      return _react.default.createElement("span", {
        id: "".concat(id, "-input"),
        className: "dnb-date-picker__input__wrapper"
      }, startDateList, isRange && _ref8, isRange && endDateList);
    };

    var _separators = props.maskOrder.match(props.separatorRexExp);

    _this.maskList = props.maskOrder.split(props.separatorRexExp).reduce(function (acc, cur) {
      if (cur) {
        acc.push(cur);

        if (_separators.length > 0) {
          acc.push(_separators.shift());
        }
      }

      return acc;
    }, []);
    _this._startDayRef = _react.default.createRef();
    _this._startMonthRef = _react.default.createRef();
    _this._startYearRef = _react.default.createRef();
    _this._endDayRef = _react.default.createRef();
    _this._endMonthRef = _react.default.createRef();
    _this._endYearRef = _react.default.createRef();
    return _this;
  }

  _createClass(DatePickerInput, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this._shortcuts) {
        this._shortcuts.remove(this.osShortcut);
      }
    }
  }, {
    key: "getPlaceholderChar",
    value: function getPlaceholderChar(value) {
      var index = this.props.maskOrder.indexOf(value);
      return this.props.maskPlaceholder[index];
    }
  }, {
    key: "generateDateList",
    value: function generateDateList(params, mode) {
      var _this2 = this;

      return this.maskList.map(function (value, i) {
        var state = value.slice(0, 1);

        var placeholderChar = _this2.getPlaceholderChar(value);

        var _this2$props = _this2.props,
            input_element = _this2$props.input_element,
            separatorRexExp = _this2$props.separatorRexExp,
            isRange = _this2$props.isRange;
        var _this2$context$transl = _this2.context.translation.DatePicker,
            day = _this2$context$transl.day,
            month = _this2$context$transl.month,
            year = _this2$context$transl.year;
        var isRangeLabe = isRange ? "".concat(_this2.context.translation.DatePicker[mode], " ") : '';

        if (!separatorRexExp.test(value)) {
          if (!input_element) {
            params = _extends({}, params, {
              onKeyDown: _this2.onKeyDownHandler,
              onMouseUp: selectInput,
              onPaste: _this2.shortcutHandler,
              onFocus: function onFocus(e) {
                _this2.focusMode = mode;

                _this2.onFocusHandler(e);
              },
              onBlur: _this2.onBlurHandler,
              placeholderChar: placeholderChar
            });
          }

          var _Input = typeof input_element === 'string' ? input_element : InputElement;

          switch (state) {
            case 'd':
              _this2.refList.push(_this2["_".concat(mode, "DayRef")]);

              return _react.default.createElement(_react.default.Fragment, {
                key: 'dd' + i
              }, _react.default.createElement(_Input, _extends({}, params, {
                id: "".concat(_this2.props.id, "-").concat(mode, "-day"),
                key: 'di' + i,
                className: (0, _classnames.default)("dnb-date-picker__input dnb-date-picker__input--day", params.className),
                size: "2",
                mask: [/[0-3]/, /[0-9]/],
                ref: _this2["_".concat(mode, "DayRef")],
                onChange: _this2["set_".concat(mode, "Day")],
                value: _this2.context["__".concat(mode, "Day")],
                "aria-labelledby": "".concat(_this2.props.id, "-").concat(mode, "-day-label")
              })), _react.default.createElement("label", {
                key: 'dl' + i,
                hidden: true,
                id: "".concat(_this2.props.id, "-").concat(mode, "-day-label")
              }, isRangeLabe + day));

            case 'm':
              _this2.refList.push(_this2["_".concat(mode, "MonthRef")]);

              return _react.default.createElement(_react.default.Fragment, {
                key: 'mm' + i
              }, _react.default.createElement(_Input, _extends({}, params, {
                id: "".concat(_this2.props.id, "-").concat(mode, "-month"),
                key: 'mi' + i,
                className: (0, _classnames.default)("dnb-date-picker__input dnb-date-picker__input--month", params.className),
                size: "2",
                mask: [/[0-1]/, /[0-9]/],
                ref: _this2["_".concat(mode, "MonthRef")],
                onChange: _this2["set_".concat(mode, "Month")],
                value: _this2.context["__".concat(mode, "Month")],
                "aria-labelledby": "".concat(_this2.props.id, "-").concat(mode, "-month-label")
              })), _react.default.createElement("label", {
                key: 'ml' + i,
                hidden: true,
                id: "".concat(_this2.props.id, "-").concat(mode, "-month-label")
              }, isRangeLabe + month));

            case 'y':
              _this2.refList.push(_this2["_".concat(mode, "YearRef")]);

              return _react.default.createElement(_react.default.Fragment, {
                key: 'yy' + i
              }, _react.default.createElement(_Input, _extends({}, params, {
                id: "".concat(_this2.props.id, "-").concat(mode, "-year"),
                key: 'yi' + i,
                className: (0, _classnames.default)("dnb-date-picker__input dnb-date-picker__input--year", params.className),
                size: "4",
                mask: [/[1-2]/, /[0-9]/, /[0-9]/, /[0-9]/],
                ref: _this2["_".concat(mode, "YearRef")],
                onChange: _this2["set_".concat(mode, "Year")],
                value: _this2.context["__".concat(mode, "Year")],
                "aria-labelledby": "".concat(_this2.props.id, "-").concat(mode, "-year-label")
              })), _react.default.createElement("label", {
                key: 'yl' + i,
                hidden: true,
                id: "".concat(_this2.props.id, "-").concat(mode, "-year-label")
              }, isRangeLabe + year));
          }
        }

        return _react.default.createElement("span", {
          key: 's' + i,
          className: "dnb-date-picker--separator",
          "aria-hidden": true
        }, placeholderChar);
      });
    }
  }, {
    key: "formatDate",
    value: function formatDate() {
      var open_picker_text = this.context.translation.DatePicker.open_picker_text;
      var selectedDateTitle = this.props.selectedDateTitle;
      return selectedDateTitle ? "".concat(selectedDateTitle, ", ").concat(open_picker_text) : open_picker_text;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          id = _this$props2.id,
          title = _this$props2.title,
          submitAttributes = _this$props2.submitAttributes,
          isRange = _this$props2.isRange,
          maskOrder = _this$props2.maskOrder,
          maskPlaceholder = _this$props2.maskPlaceholder,
          separatorRexExp = _this$props2.separatorRexExp,
          onChange = _this$props2.onChange,
          onFocus = _this$props2.onFocus,
          onSubmit = _this$props2.onSubmit,
          selectedDateTitle = _this$props2.selectedDateTitle,
          showInput = _this$props2.showInput,
          input_element = _this$props2.input_element,
          locale = _this$props2.locale,
          disabled = _this$props2.disabled,
          skeleton = _this$props2.skeleton,
          opened = _this$props2.opened,
          status = _this$props2.status,
          status_state = _this$props2.status_state,
          attributes = _objectWithoutProperties(_this$props2, ["id", "title", "submitAttributes", "isRange", "maskOrder", "maskPlaceholder", "separatorRexExp", "onChange", "onFocus", "onSubmit", "selectedDateTitle", "showInput", "input_element", "locale", "disabled", "skeleton", "opened", "status", "status_state"]);

      var focusState = this.state.focusState;
      (0, _componentHelper.validateDOMAttributes)(this.props, attributes);
      (0, _componentHelper.validateDOMAttributes)(null, submitAttributes);
      return _react.default.createElement("fieldset", {
        className: "dnb-date-picker__fieldset",
        lang: locale === null || locale === void 0 ? void 0 : locale.code
      }, this.context.props.label && _react.default.createElement("legend", {
        className: "dnb-sr-only"
      }, this.context.props.label), _react.default.createElement(_Input2.default, _extends({
        id: "".concat(id, "__input"),
        input_state: disabled ? 'disabled' : focusState,
        input_element: input_element && typeof input_element !== 'string' ? typeof input_element === 'function' ? input_element(this.props) : input_element : this.renderInputElement,
        disabled: disabled || skeleton,
        skeleton: skeleton,
        status: !opened ? status : null,
        status_state: status_state,
        submit_element: _react.default.createElement(_Input2.SubmitButton, _extends({
          id: id,
          disabled: disabled,
          skeleton: skeleton,
          className: opened ? 'dnb-button--active' : null,
          "aria-label": this.formatDate(),
          title: title,
          type: "button",
          icon: "calendar",
          variant: "secondary",
          on_submit: onSubmit
        }, submitAttributes)),
        lang: locale === null || locale === void 0 ? void 0 : locale.code
      }, attributes)), ' ');
    }
  }]);

  return DatePickerInput;
}(_react.default.PureComponent);

exports.default = DatePickerInput;
DatePickerInput.contextType = _DatePickerContext.default;
DatePickerInput.defaultProps = {
  id: null,
  title: null,
  selectedDateTitle: null,
  maskOrder: 'dd/mm/yyyy',
  maskPlaceholder: 'dd/mm/åååå',
  separatorRexExp: /[-/ ]/g,
  submitAttributes: null,
  isRange: null,
  status: null,
  status_state: 'error',
  input_element: null,
  disabled: null,
  locale: null,
  skeleton: null,
  opened: false,
  showInput: null,
  onChange: null,
  onSubmit: null,
  onFocus: null
};
process.env.NODE_ENV !== "production" ? DatePickerInput.propTypes = {
  id: _propTypes.default.string,
  title: _propTypes.default.string,
  selectedDateTitle: _propTypes.default.string,
  maskOrder: _propTypes.default.string,
  maskPlaceholder: _propTypes.default.string,
  separatorRexExp: _propTypes.default.instanceOf(RegExp),
  submitAttributes: _propTypes.default.object,
  isRange: _propTypes.default.bool,
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  input_element: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  locale: _propTypes.default.object,
  disabled: _propTypes.default.bool,
  skeleton: _propTypes.default.bool,
  opened: _propTypes.default.bool,
  showInput: _propTypes.default.bool,
  onChange: _propTypes.default.func,
  onSubmit: _propTypes.default.func,
  onFocus: _propTypes.default.func
} : void 0;

var selectInput = function selectInput(e) {
  e.target.focus();
  e.target.select();
};

var InputElement = _react.default.forwardRef(function (props, innerRef) {
  return _react.default.createElement(_reactTextMask.default, _extends({
    guide: true,
    showMask: true,
    keepCharPositions: false,
    autoComplete: "off",
    autoCapitalize: "none",
    spellCheck: false,
    autoCorrect: "off",
    ref: innerRef
  }, props));
});

var wait = function wait(t) {
  return new Promise(function (r) {
    return setTimeout(r, t);
  });
};