"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareFormRowContext = exports.default = exports.formRowDefaultProps = exports.formRowPropTypes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _HashSum = _interopRequireDefault(require("../../shared/libs/HashSum"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _SpacingHelper = require("../space/SpacingHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var formRowPropTypes = _extends({
  id: _propTypes.default.string,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['vertical', 'horizontal']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  label_id: _propTypes.default.string,
  label_class: _propTypes.default.string,
  no_label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_fieldset: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  indent: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  wrap: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  direction: _propTypes.default.oneOf(['vertical', 'horizontal']),
  vertical: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  centered: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  indent_offset: _propTypes.default.string,
  section_style: _propTypes.default.string,
  section_spacing: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  global_status_id: _propTypes.default.string,
  responsive: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  class: _propTypes.default.string,
  skipContentWrapperIfNested: _propTypes.default.bool
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func
});

exports.formRowPropTypes = formRowPropTypes;
var formRowDefaultProps = {
  id: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  label_id: null,
  label_class: null,
  no_label: false,
  no_fieldset: null,
  indent: null,
  wrap: null,
  direction: null,
  vertical: null,
  centered: null,
  indent_offset: null,
  section_style: null,
  section_spacing: null,
  global_status_id: null,
  responsive: null,
  disabled: null,
  skeleton: null,
  class: null,
  skipContentWrapperIfNested: false,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null
};
exports.formRowDefaultProps = formRowDefaultProps;

var _ref = _react.default.createElement(_AlignmentHelper.default, null);

var _ref2 = _react.default.createElement("span", {
  className: "dnb-form-label dnb-form-row__label-dummy",
  "aria-hidden": true
});

var FormRow = function (_React$PureComponent) {
  _inherits(FormRow, _React$PureComponent);

  var _super = _createSuper(FormRow);

  function FormRow(props) {
    var _this;

    _classCallCheck(this, FormRow);

    _this = _super.call(this, props);
    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    return _this;
  }

  _createClass(FormRow, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, FormRow.defaultProps, this.context.FormRow);

      var label = props.label,
          label_direction = props.label_direction,
          label_sr_only = props.label_sr_only,
          label_id = props.label_id,
          label_class = props.label_class,
          no_fieldset = props.no_fieldset,
          no_label = props.no_label,
          indent = props.indent,
          direction = props.direction,
          vertical = props.vertical,
          centered = props.centered,
          indent_offset = props.indent_offset,
          section_style = props.section_style,
          section_spacing = props.section_spacing,
          global_status_id = props.global_status_id,
          responsive = props.responsive,
          disabled = props.disabled,
          skeleton = props.skeleton,
          wrap = props.wrap,
          _id = props.id,
          className = props.className,
          _className = props.class,
          skipContentWrapperIfNested = props.skipContentWrapperIfNested,
          attributes = _objectWithoutProperties(props, ["label", "label_direction", "label_sr_only", "label_id", "label_class", "no_fieldset", "no_label", "indent", "direction", "vertical", "centered", "indent_offset", "section_style", "section_spacing", "global_status_id", "responsive", "disabled", "skeleton", "wrap", "id", "className", "class", "skipContentWrapperIfNested"]);

      var isNested = this.context.FormRow && this.context.FormRow.itsMeAgain;

      var _FormRow$getContent = FormRow.getContent(this.props),
          nestedLabel = _FormRow$getContent.label,
          children = _FormRow$getContent.children;

      if (!label && nestedLabel) {
        label = nestedLabel;
      }

      var hasLabel = typeof label === 'string' && label.length > 0 || label ? true : false;
      var id = this._id;

      var params = _extends({
        className: (0, _classnames.default)('dnb-form-row', ((0, _componentHelper.isTrue)(vertical) || direction) && "dnb-form-row--".concat((0, _componentHelper.isTrue)(vertical) ? 'vertical' : direction), ((0, _componentHelper.isTrue)(vertical) || label_direction) && "dnb-form-row--".concat((0, _componentHelper.isTrue)(vertical) ? 'vertical' : label_direction, "-label"), (0, _SpacingHelper.createSpacingClasses)(props), className, _className, indent && !(isNested && this.context.FormRow.hasLabel && this.context.FormRow.indent) && "dnb-form-row__indent--".concat((0, _componentHelper.isTrue)(indent) ? 'default' : indent), centered && 'dnb-form-row--centered', isNested && 'dnb-form-row--nested', section_style && "dnb-section dnb-section--".concat(section_style), section_spacing && "dnb-section--spacing-".concat((0, _componentHelper.isTrue)(section_spacing) ? 'default' : section_spacing))
      }, attributes);

      (0, _componentHelper.validateDOMAttributes)(this.props, params);

      if (this._cachedContext !== (0, _HashSum.default)(this.context, false) || this._cachedProps !== (0, _HashSum.default)(this.props, false)) {
        this._cachedContext = (0, _HashSum.default)(this.context, false);
        this._cachedProps = (0, _HashSum.default)(this.props, false);
        var _FormRow2 = {
          useId: function useId() {
            if (_this2.isIsUsed) {
              return (0, _componentHelper.makeUniqueId)();
            }

            _this2.isIsUsed = true;
            return id;
          },
          itsMeAgain: true,
          hasLabel: hasLabel,
          indent: indent,
          global_status_id: global_status_id,
          direction: direction,
          vertical: vertical,
          label_direction: (0, _componentHelper.isTrue)(vertical) ? 'vertical' : label_direction,
          responsive: responsive,
          disabled: disabled,
          skeleton: skeleton
        };
        this._contextWeUse = (0, _componentHelper.extend)(this.context, {
          FormRow: _FormRow2
        });
      }

      var useFieldset = !(0, _componentHelper.isTrue)(no_fieldset) && hasLabel;
      return _react.default.createElement(_Context.default.Provider, {
        value: this._contextWeUse
      }, _react.default.createElement(Fieldset, {
        useFieldset: useFieldset
      }, _react.default.createElement("div", params, _ref, label && _react.default.createElement(_FormLabel.default, {
        className: (0, _classnames.default)('dnb-form-row__label', label_class),
        id: label_id ? label_id : id + '-label',
        for_id: useFieldset ? null : id,
        text: label,
        element: useFieldset ? 'legend' : 'label',
        label_direction: label_direction,
        sr_only: label_sr_only,
        disabled: disabled,
        skeleton: skeleton
      }), (0, _componentHelper.isTrue)(no_label) && _ref2, isNested && skipContentWrapperIfNested ? children : _react.default.createElement("div", {
        className: (0, _classnames.default)('dnb-form-row__content', (0, _componentHelper.isTrue)(wrap) && 'dnb-form-row__content--wrap', label && !(0, _componentHelper.isTrue)(vertical) && direction !== 'vertical' && "dnb-form-row__content--".concat(indent_offset || 'default'), responsive && 'dnb-responsive-component'),
        ref: this._contentRef
      }, children))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(FormRow.tagName, FormRow, FormRow.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      var label = null;
      var children = typeof props.children === 'function' ? props.children(props) : props.children;

      if (Array.isArray(props.children)) {
        children = children.reduce(function (pV, cV) {
          if (cV && cV.type && cV.type.name === 'FormLabel') {
            label = cV.props.children;
          } else {
            pV.push(cV);
          }

          return pV;
        }, []);
      }

      return {
        label: label,
        children: children
      };
    }
  }]);

  return FormRow;
}(_react.default.PureComponent);

exports.default = FormRow;
FormRow.tagName = 'dnb-form-row';
FormRow.contextType = _Context.default;
FormRow.defaultProps = _extends({}, formRowDefaultProps);
process.env.NODE_ENV !== "production" ? FormRow.propTypes = _extends({}, formRowPropTypes) : void 0;

var Fieldset = function Fieldset(_ref3) {
  var useFieldset = _ref3.useFieldset,
      className = _ref3.className,
      children = _ref3.children,
      props = _objectWithoutProperties(_ref3, ["useFieldset", "className", "children"]);

  if (useFieldset) {
    return _react.default.createElement("fieldset", _extends({
      className: (0, _classnames.default)('dnb-form-row__fieldset', className)
    }, props), children);
  }

  return _react.default.createElement("div", _extends({
    className: (0, _classnames.default)('dnb-form-row__fieldset', className)
  }, props), children);
};

process.env.NODE_ENV !== "production" ? Fieldset.propTypes = {
  children: _propTypes.default.node,
  useFieldset: _propTypes.default.bool,
  className: _propTypes.default.string
} : void 0;
Fieldset.defaultProps = {
  children: null,
  useFieldset: false,
  className: null
};

var prepareFormRowContext = function prepareFormRowContext(props) {
  if (typeof props.label_direction === 'undefined') {
    props.label_direction = (0, _componentHelper.isTrue)(props.vertical) ? 'vertical' : props.label_direction;
  }

  return props;
};

exports.prepareFormRowContext = prepareFormRowContext;