"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _HashSum = _interopRequireDefault(require("../../shared/libs/HashSum"));

var _FormRow = require("../form-row/FormRow");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var FormSet = function (_React$PureComponent) {
  _inherits(FormSet, _React$PureComponent);

  var _super = _createSuper(FormSet);

  function FormSet(props) {
    var _this;

    _classCallCheck(this, FormSet);

    _this = _super.call(this, props);

    _this.onSubmitHandler = function (event) {
      var prevent_submit = _this.props.prevent_submit;

      if ((0, _componentHelper.isTrue)(prevent_submit)) {
        event.preventDefault();
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_submit', {
        event: event
      });
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    return _this;
  }

  _createClass(FormSet, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          element = _this$props.element,
          no_form = _this$props.no_form,
          prevent_submit = _this$props.prevent_submit,
          disabled = _this$props.disabled,
          id = _this$props.id,
          className = _this$props.className,
          _className = _this$props.class,
          rest = _objectWithoutProperties(_this$props, ["element", "no_form", "prevent_submit", "disabled", "id", "className", "class"]);

      var formRowProps = Object.entries(rest).reduce(function (acc, _ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            k = _ref2[0],
            v = _ref2[1];

        if (typeof _FormRow.formRowDefaultProps[k] !== 'undefined' && k !== 'id' && k !== 'children' && k !== 'label') {
          acc[k] = v;
        }

        return acc;
      }, {});
      var attributes = Object.entries(rest).reduce(function (acc, _ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            k = _ref4[0],
            v = _ref4[1];

        if (typeof formRowProps[k] === 'undefined') {
          acc[k] = v;
        }

        return acc;
      }, {});

      var params = _extends({
        className: (0, _classnames.default)('dnb-form-set', (0, _SpacingHelper.createSpacingClasses)(this.props), className, _className)
      }, attributes);

      if (!(0, _componentHelper.isTrue)(no_form)) {
        params.onSubmit = this.onSubmitHandler;
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      var content = FormSet.getContent(this.props);

      if ((0, _HashSum.default)(this._cachedContext) !== (0, _HashSum.default)(this.context)) {
        this._cachedContext = this.context;

        var FormRow = _extends({}, formRowProps, {
          disabled: disabled
        });

        this._contextWeUse = (0, _componentHelper.extend)(this.context, {
          FormRow: FormRow
        });
      }

      var Element = (0, _componentHelper.isTrue)(no_form) ? 'div' : element;
      return _react.default.createElement(_Context.default.Provider, {
        value: this._contextWeUse
      }, _react.default.createElement(Element, params, content));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(FormSet.tagName, FormSet, FormSet.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return FormSet;
}(_react.default.PureComponent);

exports.default = FormSet;
FormSet.tagName = 'dnb-form-set';
FormSet.contextType = _Context.default;
FormSet.defaultProps = {
  element: 'form',
  no_form: false,
  prevent_submit: false,
  on_submit: null,
  custom_element: null,
  custom_method: null
};
process.env.NODE_ENV !== "production" ? FormSet.propTypes = _extends({
  element: _propTypes.default.string,
  no_form: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_submit: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _FormRow.formRowPropTypes, {
  on_submit: _propTypes.default.func,
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func
}) : void 0;