"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _SpacingHelper = require("../space/SpacingHelper");

var _GlobalStatusController = _interopRequireWildcard(require("./GlobalStatusController"));

var _GlobalStatusProvider = _interopRequireDefault(require("./GlobalStatusProvider"));

var _Icon = _interopRequireDefault(require("../icon/Icon"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _Section = _interopRequireDefault(require("../section/Section"));

var _helpers = require("../../shared/helpers");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var GlobalStatus = function (_React$PureComponent) {
  _inherits(GlobalStatus, _React$PureComponent);

  var _super = _createSuper(GlobalStatus);

  function GlobalStatus(props) {
    var _this;

    _classCallCheck(this, GlobalStatus);

    _this = _super.call(this, props);
    _this.state = {
      globalStatus: null,
      isActive: false,
      isAnimating: false,
      keepContentVisible: false,
      _listenForPropChanges: false
    };

    _this.setVisible = function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$delay = _ref.delay,
          delay = _ref$delay === void 0 ? parseFloat(_this.props.delay) : _ref$delay;

      var _this$state = _this.state,
          isActive = _this$state.isActive,
          initialOpened = _this$state.initialOpened;

      if (isActive === true && initialOpened) {
        if (!_this.adjustHeight) {
          _this.adjustHeight = _this.anim.adjustFrom();
        }

        _this.setState({
          keepContentVisible: true,
          _listenForPropChanges: false
        }, function () {
          _this.anim.adjustTo(_this.adjustHeight);

          _this.adjustHeight = null;
        });

        return;
      }

      var run = function run() {
        _this.setState({
          isActive: true,
          initialOpened: true,
          _listenForPropChanges: false
        }, function () {
          _this.anim.open();
        });
      };

      if (delay > 0) {
        clearTimeout(_this._visibleTimeout);
        _this._visibleTimeout = setTimeout(function () {
          run();
        }, delay);
      } else {
        run();
      }
    };

    _this.setHidden = function () {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$delay = _ref2.delay,
          delay = _ref2$delay === void 0 ? parseFloat(_this.props.delay) : _ref2$delay;

      var isActive = _this.state.isActive;

      if (isActive === false) {
        return;
      }

      var run = function run() {
        _this.setState({
          isActive: false,
          initialOpened: false,
          _listenForPropChanges: false
        }, function () {
          _this.anim.close();
        });
      };

      if (delay > 0) {
        clearTimeout(_this._hiddenTimeout);
        _this._hiddenTimeout = setTimeout(function () {
          run();
        }, delay);
      } else {
        run();
      }
    };

    _this.onKeyDownHandler = function (e) {
      switch ((0, _keycode.default)(e)) {
        case 'esc':
          e.preventDefault();

          _this.closeHandler();

          break;
      }
    };

    _this.closeHandler = function () {
      _this.provider.add({
        status_id: 'internal-close',
        show: false
      });

      if (_this.initialActiveElement) {
        try {
          _this.initialActiveElement.focus();

          _this.initialActiveElement = null;
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_this._globalStatus, 'on_hide', _this._globalStatus);
    };

    _this.gotoItem = function (event, item) {
      event.persist();
      var keyCode = (0, _keycode.default)(event);

      if (item.status_id && typeof document !== 'undefined' && typeof window !== 'undefined' && keyCode === 'space' || keyCode === 'enter' || typeof keyCode === 'undefined') {
        event.preventDefault();

        try {
          var element = document.getElementById(item.status_id);

          if (!element) {
            return;
          }

          isElementVisible(element, function (elem) {
            try {
              elem.addEventListener('blur', function (e) {
                if (e.target.classList) {
                  e.target.removeAttribute('tabindex');
                }
              });
              elem.classList.add('dnb-no-focus');
              elem.setAttribute('tabindex', '-1');
              elem.focus({
                preventScroll: true
              });
            } catch (e) {
              (0, _componentHelper.warn)(e);
            }
          });

          if (_helpers.IS_IE11) {
            window.scrollTop = element.offsetTop;
          } else if (typeof element.scrollIntoView === 'function') {
            element.scrollIntoView({
              block: 'center',
              behavior: 'smooth'
            });
          }
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    };

    _this._mainRef = _react.default.createRef();
    _this._wrapperRef = _react.default.createRef();
    _this._shellRef = _react.default.createRef();
    _this.anim = new _componentHelper.AnimateHeight({
      animate: !(0, _componentHelper.isTrue)(props.no_animation)
    });

    _this.anim.onStart(function (state) {
      _this.setState({
        isAnimating: true,
        _listenForPropChanges: false
      });

      if (state === 'opening') {
        _this.scrollToStatus();
      }
    });

    _this.anim.onEnd(function (state) {
      _this.setState({
        isAnimating: false,
        _listenForPropChanges: false
      });

      if (_this.state.isActive) {
        _this.setState({
          keepContentVisible: true,
          _listenForPropChanges: false
        });

        (0, _componentHelper.dispatchCustomElementEvent)(_this._globalStatus, 'on_show', _this._globalStatus);

        if (state === 'opened') {
          _this.setFocus();

          (0, _componentHelper.dispatchCustomElementEvent)(_this._globalStatus, 'on_open', _this._globalStatus);
        }

        if (state === 'adjusted') {
          if (!(0, _componentHelper.isTrue)(_this.props.omit_set_focus_on_update)) {
            _this.setFocus();
          }

          (0, _componentHelper.dispatchCustomElementEvent)(_this._globalStatus, 'on_adjust', _this._globalStatus);
        }
      } else {
        _this.setState({
          keepContentVisible: false,
          _listenForPropChanges: false
        });

        (0, _componentHelper.dispatchCustomElementEvent)(_this._globalStatus, 'on_close', _this._globalStatus);
      }
    });

    _this.provider = _GlobalStatusProvider.default.create(props.id);
    _this.state.globalStatus = _this._globalStatus = _this.provider.init(props);

    if ((0, _componentHelper.isTrue)(props.show)) {
      if ((0, _componentHelper.isTrue)(props.no_animation)) {
        _this.state.isActive = true;
      }
    }

    _this.provider.onUpdate(function (globalStatus) {
      if (globalStatus.on_close) {
        _this._globalStatus = globalStatus;
      }

      _this.adjustHeight = _this.anim.adjustFrom();

      _this.setState({
        globalStatus: globalStatus,
        _listenForPropChanges: false
      });

      var isActive = (0, _componentHelper.isTrue)(globalStatus.show);

      if (isActive) {
        _this.setState({
          isActive: isActive,
          _listenForPropChanges: false
        });
      }

      if ((0, _componentHelper.isTrue)(_this.props.autoclose) && _this.hadContent && !_this.hasContent(globalStatus) && !(0, _componentHelper.isTrue)(_this.props.show) || typeof globalStatus.show !== 'undefined' && !(0, _componentHelper.isTrue)(globalStatus.show)) {
        _this.setHidden({
          delay: 0
        });
      } else if ((0, _componentHelper.isTrue)(_this.props.show) || typeof globalStatus.show !== 'undefined' && (0, _componentHelper.isTrue)(globalStatus.show)) {
        _this.hadContent = _this.hasContent(globalStatus);

        _this.setVisible({
          delay: 0
        });
      }
    });

    _this.initialActiveElement = null;
    return _this;
  }

  _createClass(GlobalStatus, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.anim.setElem(this._shellRef.current);

      if ((0, _componentHelper.isTrue)(this.props.show)) {
        var isActive = (0, _componentHelper.isTrue)(this.props.show);

        if (isActive) {
          this.setVisible();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.anim.remove();
      clearTimeout(this._scrollToStatusTimeout);
      clearTimeout(this._visibleTimeout);
      clearTimeout(this._hiddenTimeout);
      this.provider.empty();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        var globalStatus = (0, _componentHelper.extendPropsWithContext)(this.props, GlobalStatus.defaultProps, this.state.globalStatus);
        this.setState({
          globalStatus: globalStatus
        });
      }

      if (prevProps.show !== this.props.show) {
        var isActive = (0, _componentHelper.isTrue)(this.props.show);

        if (isActive) {
          this.setVisible();
        } else {
          this.setHidden();
        }
      }
    }
  }, {
    key: "hasContent",
    value: function hasContent(globalStatus) {
      var _globalStatus$items;

      return ((_globalStatus$items = globalStatus.items) === null || _globalStatus$items === void 0 ? void 0 : _globalStatus$items.length) > 0 || globalStatus.text;
    }
  }, {
    key: "correctStatus",
    value: function correctStatus(state) {
      switch (state) {
        case 'information':
          state = 'info';
          break;
      }

      return state;
    }
  }, {
    key: "setFocus",
    value: function setFocus() {
      if (typeof document !== 'undefined' && document.activeElement !== this._wrapperRef.current) {
        this.initialActiveElement = document.activeElement;
      }

      if (this._wrapperRef.current && !(0, _componentHelper.isTrue)(this.props.omit_set_focus)) {
        this._wrapperRef.current.focus({
          preventScroll: true
        });
      }
    }
  }, {
    key: "scrollToStatus",
    value: function scrollToStatus() {
      var isDone = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (typeof window === 'undefined' || (0, _componentHelper.isTrue)(this.state.globalStatus.autoscroll) === false) {
        return;
      }

      try {
        var element = this._wrapperRef.current;
        this._scrollToStatusTimeout = isElementVisible(element, isDone);

        if (element && !_helpers.IS_IE11 && typeof element.scrollIntoView === 'function') {
          element.scrollIntoView({
            block: 'center',
            behavior: 'smooth'
          });
        } else {
          var top = element.offsetTop;

          if (window.scrollTo) {
            window.scrollTo({
              top: top,
              behavior: 'smooth'
            });
          } else {
            window.scrollTop = top;
          }
        }
      } catch (e) {
        (0, _componentHelper.warn)('GlobalStatus: Could not scroll into view!', e);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state2 = this.state,
          isActive = _this$state2.isActive,
          isAnimating = _this$state2.isAnimating,
          keepContentVisible = _this$state2.keepContentVisible;
      var fallbackProps = (0, _componentHelper.extendPropsWithContext)(this.props, GlobalStatus.defaultProps, this.context.getTranslation(this.props).GlobalStatus);
      var props = (0, _componentHelper.extendPropsWithContext)(_GlobalStatusProvider.default.combineMessages([this.context.globalStatus, this.state.globalStatus]), GlobalStatus.defaultProps, fallbackProps);
      var lang = this.context.locale;

      var title = props.title,
          default_title = props.default_title,
          rawState = props.state,
          className = props.className,
          no_animation = props.no_animation,
          hide_close_button = props.hide_close_button,
          close_text = props.close_text,
          _className = props.class,
          status_anchor_text = props.status_anchor_text,
          skeleton = props.skeleton,
          id = props.id,
          item = props.item,
          items = props.items,
          autoclose = props.autoclose,
          show = props.show,
          delay = props.delay,
          autoscroll = props.autoscroll,
          text = props.text,
          icon = props.icon,
          icon_size = props.icon_size,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["title", "default_title", "state", "className", "no_animation", "hide_close_button", "close_text", "class", "status_anchor_text", "skeleton", "id", "item", "items", "autoclose", "show", "delay", "autoscroll", "text", "icon", "icon_size", "children"]);

      var wrapperParams = {
        key: 'global-status',
        className: (0, _classnames.default)("dnb-global-status__wrapper dnb-no-focus", (0, _SkeletonHelper.createSkeletonClass)('font', skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(props), className, _className),
        'aria-live': isActive ? 'assertive' : 'off',
        onKeyDown: this.onKeyDownHandler,
        tabIndex: '-1'
      };
      var state = this.correctStatus(rawState);
      var iconToRender = GlobalStatus.getIcon({
        state: state,
        icon: icon || fallbackProps.icon,
        icon_size: icon_size || fallbackProps.icon_size
      });
      var titleToRender = title || fallbackProps.title || fallbackProps.default_title;
      var noAnimation = (0, _componentHelper.isTrue)(no_animation);
      var itemsToRender = props.items || [];
      var contentToRender = GlobalStatus.getContent(props);
      var style = state === 'info' ? null : 'fire-red';

      var params = _extends({
        element: 'div',
        className: (0, _classnames.default)("dnb-global-status dnb-global-status--".concat(state), isActive ? keepContentVisible && 'dnb-global-status--visible' : 'dnb-global-status--hidden', isAnimating && 'dnb-global-status--is-animating', noAnimation && 'dnb-global-status--no-animation')
      }, attributes);

      (0, _SkeletonHelper.skeletonDOMAttributes)(params, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);

      var renderedItems = itemsToRender.length > 0 && _react.default.createElement("ul", {
        className: "dnb-ul"
      }, itemsToRender.map(function (item, i) {
        var id = item.id || item.status_id ? "".concat(item.status_id, "-").concat(i) : (0, _componentHelper.makeUniqueId)();
        var text = item && item.text || item;
        var label = _react.default.isValidElement(item.status_anchor_label) ? (0, _componentHelper.convertJsxToString)(item.status_anchor_label) : item.status_anchor_label || '';
        var anchorText = String(item.status_anchor_text || status_anchor_text).replace('%s', label).replace(/[: ]$/g, '');
        var useAutolink = item.status_id && (0, _componentHelper.isTrue)(item.status_anchor_url);
        return _react.default.createElement("li", {
          key: i
        }, _react.default.createElement("p", {
          id: id,
          className: "dnb-p"
        }, text), item && (useAutolink || item.status_anchor_url) && _react.default.createElement("a", {
          className: "dnb-anchor",
          "aria-describedby": id,
          lang: lang,
          href: useAutolink ? "#".concat(item.status_id) : item.status_anchor_url,
          onClick: function onClick(e) {
            return _this2.gotoItem(e, item);
          },
          onKeyDown: function onKeyDown(e) {
            return _this2.gotoItem(e, item);
          }
        }, anchorText));
      }));

      var hasContent = renderedItems || contentToRender;

      var renderedContent = _react.default.createElement("div", {
        className: "dnb-global-status__content"
      }, title !== false && _react.default.createElement("p", {
        className: "dnb-p dnb-global-status__title",
        lang: lang
      }, _react.default.createElement("span", {
        className: "dnb-global-status__icon"
      }, iconToRender), titleToRender, !(0, _componentHelper.isTrue)(hide_close_button) && _react.default.createElement(CloseButton, {
        on_click: this.closeHandler,
        text: close_text,
        title: close_text
      })), hasContent && _react.default.createElement(_Section.default, {
        element: "div",
        style_type: "white",
        className: "dnb-global-status__message"
      }, _react.default.createElement("div", {
        className: "dnb-global-status__message__content"
      }, typeof contentToRender === 'string' ? _react.default.createElement("p", {
        className: "dnb-p"
      }, contentToRender) : contentToRender, renderedItems)));

      return _react.default.createElement("div", _extends({}, wrapperParams, {
        ref: this._wrapperRef
      }), _react.default.createElement(_Section.default, _extends({
        style_type: style
      }, params, {
        ref: this._mainRef
      }), _react.default.createElement("div", {
        className: "dnb-global-status__shell",
        ref: this._shellRef
      }, (isAnimating || keepContentVisible || isActive) && renderedContent)));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(GlobalStatus.tagName, GlobalStatus, GlobalStatus.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (props.text) return props.text;
      return (0, _componentHelper.processChildren)(props);
    }
  }, {
    key: "getIcon",
    value: function getIcon(_ref3) {
      var state = _ref3.state,
          icon = _ref3.icon,
          icon_size = _ref3.icon_size;

      if (typeof icon === 'string') {
        var IconToLoad = icon;

        switch (state) {
          case 'info':
          case 'information':
            IconToLoad = InfoIcon;
            break;

          case 'error':
          default:
            IconToLoad = ErrorIcon;
        }

        icon = _react.default.createElement(_Icon.default, {
          icon: _react.default.createElement(IconToLoad, {
            title: null
          }),
          size: icon_size
        });
      }

      return icon;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (state._items !== props.items) {
          state.globalStatus = _GlobalStatusProvider.default.combineMessages([state.globalStatus, props]);
        }
      }

      state._items = props.items;
      state._listenForPropChanges = true;
      return state;
    }
  }]);

  return GlobalStatus;
}(_react.default.PureComponent);

exports.default = GlobalStatus;
GlobalStatus.tagName = 'dnb-global-status';
GlobalStatus.contextType = _Context.default;
GlobalStatus.defaultProps = {
  id: 'main',
  status_id: 'status-main',
  title: null,
  default_title: null,
  text: null,
  items: [],
  icon: 'error',
  icon_size: 'large',
  state: 'error',
  show: null,
  autoscroll: true,
  autoclose: true,
  no_animation: false,
  close_text: 'Lukk',
  hide_close_button: false,
  omit_set_focus: false,
  omit_set_focus_on_update: true,
  delay: 0,
  status_anchor_text: null,
  skeleton: null,
  class: null,
  className: null,
  children: null,
  on_adjust: null,
  on_open: null,
  on_show: null,
  on_close: null,
  on_hide: null
};
process.env.NODE_ENV !== "production" ? GlobalStatus.propTypes = _extends({
  id: _propTypes.default.string,
  status_id: _propTypes.default.string,
  title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  default_title: _propTypes.default.string,
  text: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  items: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.array]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  icon_size: _propTypes.default.string,
  state: _propTypes.default.oneOf(['error', 'info']),
  show: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  autoscroll: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  autoclose: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  delay: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  close_text: _propTypes.default.string,
  hide_close_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  omit_set_focus: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  omit_set_focus_on_update: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  status_anchor_text: _propTypes.default.string,
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  on_adjust: _propTypes.default.func,
  on_open: _propTypes.default.func,
  on_show: _propTypes.default.func,
  on_close: _propTypes.default.func,
  on_hide: _propTypes.default.func
}) : void 0;

var CloseButton = function CloseButton(_ref4) {
  var on_click = _ref4.on_click,
      text = _ref4.text,
      _ref4$className = _ref4.className,
      className = _ref4$className === void 0 ? null : _ref4$className;
  return _react.default.createElement(_Button.default, {
    type: "button",
    variant: "tertiary",
    size: "medium",
    className: (0, _classnames.default)('dnb-global-status__close-button', className),
    icon: "close",
    icon_size: "medium",
    icon_position: "left",
    "aria-label": text,
    text: text,
    on_click: on_click
  });
};

process.env.NODE_ENV !== "production" ? CloseButton.propTypes = {
  on_click: _propTypes.default.func.isRequired,
  className: _propTypes.default.string,
  text: _propTypes.default.string
} : void 0;
CloseButton.defaultProps = {
  className: null,
  text: GlobalStatus.defaultProps.close_text
};

GlobalStatus.create = function () {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return _construct(_GlobalStatusController.GlobalStatusInterceptor, args);
};

GlobalStatus.Set = GlobalStatus.create;
GlobalStatus.AddStatus = GlobalStatus.create;
GlobalStatus.Update = GlobalStatus.create;
GlobalStatus.Add = _GlobalStatusController.default;
GlobalStatus.Remove = _GlobalStatusController.default.Remove;

var isElementVisible = function isElementVisible(elem, callback) {
  var delayFallback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1e3;

  if (typeof IntersectionObserver !== 'undefined') {
    var intersectionObserver = new IntersectionObserver(function (entries) {
      var _entries = _slicedToArray(entries, 1),
          entry = _entries[0];

      if (entry.isIntersecting) {
        intersectionObserver.unobserve(elem);

        if (typeof callback === 'function') {
          callback(elem);
        }
      }
    });
    intersectionObserver.observe(elem);
  } else {
    if (typeof callback === 'function') {
      return setTimeout(function () {
        return callback(elem);
      }, delayFallback);
    }
  }

  return null;
};

var _ref5 = _react.default.createElement("path", {
  d: "M16 25a.5.5 0 100 1 .5.5 0 000-1v0",
  stroke: "#000",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

var _ref6 = _react.default.createElement("path", {
  d: "M16 21V11",
  stroke: "#000",
  strokeWidth: "1.5",
  strokeLinecap: "round"
});

var _ref7 = _react.default.createElement("path", {
  clipRule: "evenodd",
  d: "M18.161 2.347a2.408 2.408 0 00-4.322 0L1.208 28.077A2.028 2.028 0 003.029 31h25.942a2.028 2.028 0 001.821-2.923l-12.63-25.73z",
  stroke: "#000",
  strokeWidth: "1.5",
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

var ErrorIcon = function ErrorIcon(props) {
  return _react.default.createElement("svg", _extends({
    width: "32",
    height: "32",
    viewBox: "0 0 32 32",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg",
    role: "presentation"
  }, props), props && props.title && _react.default.createElement("title", null, props.title), _ref5, _ref6, _ref7);
};

process.env.NODE_ENV !== "production" ? ErrorIcon.propTypes = {
  title: _propTypes.default.string
} : void 0;
ErrorIcon.defaultProps = {
  title: 'error'
};

var _ref8 = _react.default.createElement("path", {
  fillRule: "evenodd",
  clipRule: "evenodd",
  d: "M10.1 1.08A14.75 14.75 0 00.26 15.01a14.73 14.73 0 0022.16 12.74l8.27 3.94a.75.75 0 001-1l-3.94-8.27A14.75 14.75 0 0010.1 1.08zM1.76 15.01a13.25 13.25 0 1124.5 6.97.75.75 0 00-.04.72l3.2 6.73-6.72-3.2a.75.75 0 00-.72.04A13.23 13.23 0 011.76 15zM13.38 7.9a1.31 1.31 0 112.63 0 1.31 1.31 0 01-2.63 0zm-1.13 5.07c0-.41.34-.75.75-.75h1.13c1.04 0 1.88.85 1.88 1.88v5.64c0 .84.67 1.51 1.5 1.51h1.13a.75.75 0 110 1.5h-1.13a3 3 0 01-3-3V14.1c0-.2-.17-.38-.38-.38H13a.75.75 0 01-.75-.75z",
  fill: "#000"
});

var InfoIcon = function InfoIcon(props) {
  return _react.default.createElement("svg", _extends({
    width: "32",
    height: "32",
    viewBox: "0 0 32 32",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg",
    role: "presentation"
  }, props), props && props.title && _react.default.createElement("title", null, props.title), _ref8);
};

process.env.NODE_ENV !== "production" ? InfoIcon.propTypes = {
  title: _propTypes.default.string
} : void 0;
InfoIcon.defaultProps = {
  title: 'info'
};