"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.array.reverse.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.assign.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.split.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.iconCase = exports.prerenderIcon = exports.prepareIcon = exports.calcSize = exports.getIconNameFromComponent = exports.default = exports.iconPropTypes = exports.ValidIconSizes = exports.ListDefaultIconSizes = exports.DefaultIconSizes = exports.DefaultIconSize = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _errorHelper = require("../../shared/error-helper");

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var DefaultIconSize = 16;
exports.DefaultIconSize = DefaultIconSize;
var DefaultIconSizes = {
  default: 16,
  medium: 24
};
exports.DefaultIconSizes = DefaultIconSizes;
var ListDefaultIconSizes = [['default', 16], ['medium', 24]];
exports.ListDefaultIconSizes = ListDefaultIconSizes;
var ValidIconSizes = ['small', 'default', 'medium', 'large', 'x-large', 'xx-large'];
exports.ValidIconSizes = ValidIconSizes;

var iconPropTypes = _extends({
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  modifier: _propTypes.default.string,
  size: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string, _propTypes.default.oneOf(['default', 'medium', 'large'])])
}, _SpacingHelper.spacingPropTypes, {
  width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  height: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  border: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  color: _propTypes.default.string,
  inherit_color: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  alt: _propTypes.default.string,
  title: _propTypes.default.string,
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
});

exports.iconPropTypes = iconPropTypes;

var Icon = function (_React$PureComponent) {
  _inherits(Icon, _React$PureComponent);

  var _super = _createSuper(Icon);

  function Icon() {
    _classCallCheck(this, Icon);

    return _super.apply(this, arguments);
  }

  _createClass(Icon, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Icon.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.Icon);

      var _prepareIcon = prepareIcon(props, this.context),
          icon = _prepareIcon.icon,
          size = _prepareIcon.size,
          wrapperParams = _prepareIcon.wrapperParams,
          iconParams = _prepareIcon.iconParams,
          alt = _prepareIcon.alt;

      var IconContainer = prerenderIcon({
        icon: icon,
        size: size,
        alt: alt
      });
      if (!IconContainer) return _react.default.createElement(_react.default.Fragment, null);
      return _react.default.createElement("span", wrapperParams, _react.default.createElement(IconContainer, iconParams));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      var tag = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Icon.tagName;
      var inst = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Icon;
      var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Icon.defaultProps;
      (0, _componentHelper.registerElement)(tag, inst, props);
    }
  }, {
    key: "getIcon",
    value: function getIcon(props) {
      if (props.icon) {
        return props.icon;
      }

      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return Icon;
}(_react.default.PureComponent);

exports.default = Icon;
Icon.tagName = 'dnb-icon';
Icon.contextType = _Context.default;
Icon.defaultProps = {
  icon: null,
  modifier: null,
  size: null,
  width: null,
  height: null,
  border: null,
  color: null,
  inherit_color: true,
  alt: null,
  title: null,
  skeleton: null,
  attributes: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Icon.propTypes = _extends({}, iconPropTypes) : void 0;

var getIconNameFromComponent = function getIconNameFromComponent(icon) {
  var name = typeof icon === 'string' ? icon : icon && (icon.displayName || icon.name);

  if (/^data:image\//.test(name)) {
    return null;
  }

  return name;
};

exports.getIconNameFromComponent = getIconNameFromComponent;

var calcSize = function calcSize(props) {
  var icon = props.icon,
      size = props.size,
      width = props.width,
      height = props.height;
  var sizeAsInt = -1;
  var sizeAsString = null;

  if (!size || size === DefaultIconSize) {
    var name = getIconNameFromComponent(icon);
    var nameParts = String(name || '').split('_');

    if (nameParts.length > 1) {
      var lastPartOfIconName = nameParts.reverse()[0];
      var potentialSize = ListDefaultIconSizes.filter(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 1),
            key = _ref2[0];

        return key === lastPartOfIconName;
      }).reduce(function (acc, _ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            key = _ref4[0],
            value = _ref4[1];

        return key && value;
      }, null);

      if (potentialSize) {
        sizeAsInt = potentialSize;
      }

      if (ValidIconSizes.includes(lastPartOfIconName)) {
        sizeAsString = lastPartOfIconName;
      }
    } else {
      if (typeof icon === 'function') {
        var elem = icon();

        if (elem.props) {
          var _potentialSize = -1;

          if (elem.props.width) {
            _potentialSize = elem.props.width;
          }

          if (!_potentialSize && elem.props.viewBox) {
            _potentialSize = /[0-9]+ [0-9]+ ([0-9]+)/.exec(elem.props.viewBox)[1];
          }

          if (_potentialSize) {
            sizeAsInt = _potentialSize;
          }
        }
      }
    }
  } else if (typeof size === 'string' && !(parseFloat(size) > 0)) {
      sizeAsInt = ListDefaultIconSizes.filter(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 1),
            key = _ref6[0];

        return key === size;
      }).reduce(function (acc, _ref7) {
        var _ref8 = _slicedToArray(_ref7, 2),
            key = _ref8[0],
            value = _ref8[1];

        return key && value;
      }, -1);

      if (ValidIconSizes.includes(size)) {
        sizeAsString = size;
      }
    } else if (parseFloat(size) > 0) {
        sizeAsInt = ListDefaultIconSizes.filter(function (_ref9) {
          var _ref10 = _slicedToArray(_ref9, 2),
              key = _ref10[0],
              value = _ref10[1];

          return key && value === parseFloat(size);
        }).reduce(function (acc, _ref11) {
          var _ref12 = _slicedToArray(_ref11, 2),
              key = _ref12[0],
              value = _ref12[1];

          if (key && value) return value;
          return acc;
        }, -1);

        if (sizeAsInt === -1) {
          sizeAsInt = parseFloat(size);
          sizeAsString = 'custom-size';
        }
      }

  if (!sizeAsString && sizeAsInt > 0) {
    var potentialSizeAsString = ListDefaultIconSizes.reduce(function (acc, _ref13) {
      var _ref14 = _slicedToArray(_ref13, 2),
          key = _ref14[0],
          value = _ref14[1];

      if (key && value === sizeAsInt) {
        return key;
      }

      return acc;
    }, null);

    if (potentialSizeAsString) {
      sizeAsString = potentialSizeAsString;
    }
  }

  var _prepareIconParams = prepareIconParams({
    sizeAsString: sizeAsString,
    sizeAsInt: sizeAsInt,
    size: size,
    width: width,
    height: height
  }),
      isCustomSize = _prepareIconParams.sizeAsString,
      iconParams = _prepareIconParams.params;

  if (isCustomSize) {
    sizeAsString = isCustomSize;
  }

  if (!(sizeAsInt > 0)) {
    sizeAsInt = DefaultIconSize;
  }

  if (size === 'auto') {
    iconParams.width = '100%';
    iconParams.height = '100%';
    sizeAsString = 'auto';
  }

  return {
    iconParams: iconParams,
    sizeAsInt: sizeAsInt,
    sizeAsString: sizeAsString
  };
};

exports.calcSize = calcSize;

var prepareIconParams = function prepareIconParams(_ref15) {
  var sizeAsString = _ref15.sizeAsString,
      rest = _objectWithoutProperties(_ref15, ["sizeAsString"]);

  var size = rest.size,
      width = rest.width,
      height = rest.height,
      sizeAsInt = rest.sizeAsInt;
  var params = {};

  if (!sizeAsString && !(sizeAsInt > 0) && parseFloat(size) > -1) {
    params.width = params.height = parseFloat(size);
  } else if (sizeAsString === 'custom-size') {
    params.width = params.height = parseFloat(sizeAsInt);
  }

  if (parseFloat(width) > -1) {
    sizeAsString = 'custom-size';
    params.width = parseFloat(width);
  }

  if (parseFloat(height) > -1) {
    sizeAsString = 'custom-size';
    params.height = parseFloat(height);
  }

  (0, _componentHelper.validateDOMAttributes)({}, params);
  return {
    params: params,
    sizeAsString: sizeAsString
  };
};

var prepareIcon = function prepareIcon(props, context) {
  var icon = props.icon,
      size = props.size,
      width = props.width,
      height = props.height,
      border = props.border,
      color = props.color,
      inherit_color = props.inherit_color,
      modifier = props.modifier,
      alt = props.alt,
      title = props.title,
      skeleton = props.skeleton,
      _className = props.class,
      className = props.className,
      attributes = _objectWithoutProperties(props, ["icon", "size", "width", "height", "border", "color", "inherit_color", "modifier", "alt", "title", "skeleton", "class", "className"]);

  var _calcSize = calcSize({
    icon: icon,
    size: size,
    width: width,
    height: height
  }),
      sizeAsString = _calcSize.sizeAsString,
      iconParams = _calcSize.iconParams;

  if (color) {
    iconParams.color = color;
  }

  var label = icon ? getIconNameFromComponent(icon) : null;
  var wrapperParams = (0, _componentHelper.validateDOMAttributes)(props, _extends({
    role: alt ? 'img' : 'presentation',
    alt: alt,
    'aria-label': label ? label.replace(/_/g, ' ') + ' icon' : null,
    title: title
  }, attributes));

  if (!alt && typeof wrapperParams['aria-hidden'] === 'undefined') {
    wrapperParams['aria-hidden'] = true;
  }

  wrapperParams.className = (0, _classnames.default)('dnb-icon', sizeAsString ? "dnb-icon--".concat(sizeAsString) : "dnb-icon--default", (0, _SkeletonHelper.createSkeletonClass)(null, skeleton, context), (0, _SpacingHelper.createSpacingClasses)(props), _className, className, modifier && "dnb-icon--".concat(modifier), (0, _componentHelper.isTrue)(border) && 'dnb-icon--border', (0, _componentHelper.isTrue)(inherit_color) && 'dnb-icon--inherit-color');
  var iconToRender = Icon.getIcon(props);

  if (typeof iconToRender.defaultProps !== 'undefined') {
    iconToRender = _react.default.createElement(iconToRender, (0, _componentHelper.validateDOMAttributes)({}, {
      color: color,
      icon: icon,
      size: size,
      width: width,
      height: height
    }));
  }

  return _extends({}, props, {
    icon: iconToRender,
    alt: alt,
    iconParams: iconParams,
    wrapperParams: wrapperParams
  });
};

exports.prepareIcon = prepareIcon;

var prerenderIcon = function prerenderIcon() {
  var _ref16 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      icon = _ref16.icon,
      _ref16$size = _ref16.size,
      size = _ref16$size === void 0 ? null : _ref16$size,
      _ref16$listOfIcons = _ref16.listOfIcons,
      listOfIcons = _ref16$listOfIcons === void 0 ? null : _ref16$listOfIcons,
      _ref16$alt = _ref16.alt,
      alt = _ref16$alt === void 0 ? null : _ref16$alt;

  if (typeof icon === 'string' && /^data:image\//.test(icon)) {
    return function () {
      return _react.default.createElement("img", {
        src: icon,
        alt: alt || 'no-alt'
      });
    };
  }

  if (typeof icon === 'function') {
    var elem = icon();

    if (_react.default.isValidElement(elem)) {
      return icon;
    }

    return elem;
  }

  if (_react.default.isValidElement(icon) || Array.isArray(icon)) {
    return function () {
      return icon;
    };
  }

  try {
    icon = iconCase(icon);

    if (size && DefaultIconSizes[size] && size !== 'default' && !(parseFloat(size) > 0) && !icon.includes(size)) {
      icon = "".concat(icon, "_").concat(size);
    }

    var mod = (listOfIcons.dnbIcons ? listOfIcons.dnbIcons : listOfIcons)[icon];
    return mod && mod.default ? mod.default : mod;
  } catch (e) {
    new _errorHelper.ErrorHandler("Icon '".concat(icon, "' did not exist!"));
    return null;
  }
};

exports.prerenderIcon = prerenderIcon;

var iconCase = function iconCase(name) {
  return name.replace(/((?!^)[A-Z])/g, '_$1').toLowerCase().replace(/^[0-9]/g, '$1').replace(/[^a-z0-9_]/gi, '_');
};

exports.iconCase = iconCase;