"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement("span", {
  className: "dnb-line-title__mask",
  "aria-hidden": "true"
});

var _ref2 = _react.default.createElement("span", {
  className: "dnb-line-title__line",
  "aria-hidden": "true"
});

var LineTitle = function (_React$PureComponent) {
  _inherits(LineTitle, _React$PureComponent);

  var _super = _createSuper(LineTitle);

  function LineTitle() {
    _classCallCheck(this, LineTitle);

    return _super.apply(this, arguments);
  }

  _createClass(LineTitle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          tag = _this$props.tag,
          modifier = _this$props.modifier,
          className = _this$props.className,
          _className = _this$props.class;
      var content = LineTitle.getContent(this.props);
      var params = {
        className: (0, _classnames.default)('dnb-line-title', className, _className, modifier && "dnb-line-title--".concat(modifier))
      };
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      var Tag = "".concat(tag);
      return _react.default.createElement(Tag, params, _react.default.createElement("span", {
        className: "dnb-line-title__title dnb-typo-light"
      }, _ref, _react.default.createElement("span", {
        className: "dnb-line-title__text"
      }, content)), _ref2);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(LineTitle.tagName, LineTitle, LineTitle.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (typeof props.content === 'string') {
        return props.content;
      }

      return (0, _componentHelper.processChildren)(props);
    }
  }]);

  return LineTitle;
}(_react.default.PureComponent);

exports.default = LineTitle;
LineTitle.tagName = 'dnb-line-title';
LineTitle.defaultProps = {
  content: null,
  modifier: null,
  tag: 'h2',
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? LineTitle.propTypes = {
  content: _propTypes.default.string,
  modifier: _propTypes.default.string,
  tag: _propTypes.default.string,
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func])
} : void 0;