"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.object.freeze.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "CloseButton", {
  enumerable: true,
  get: function get() {
    return _ModalContent.CloseButton;
  }
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Suffix = require("../../shared/helpers/Suffix");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../space/SpacingHelper");

var _Button = require("../button/Button");

var _HelpButtonInstance = _interopRequireDefault(require("../help-button/HelpButtonInstance"));

var _ModalContent = _interopRequireWildcard(require("./ModalContent"));

var _ModalInner = _interopRequireDefault(require("./ModalInner"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Modal = function (_React$PureComponent) {
  _inherits(Modal, _React$PureComponent);

  var _super = _createSuper(Modal);

  function Modal(props) {
    var _this;

    _classCallCheck(this, Modal);

    _this = _super.call(this, props);
    _this.state = {
      hide: false,
      modalActive: false,
      _listenForPropChanges: true
    };

    _this.toggleOpenClose = function () {
      var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var showModal = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (event && event.preventDefault) {
        event.preventDefault();
      }

      var toggleNow = function toggleNow() {
        var modalActive = typeof showModal === 'boolean' ? showModal : !_this.state.modalActive;
        _this.isInTransition = true;

        var doItNow = function doItNow() {
          _this.setState({
            hide: false,
            modalActive: modalActive,
            _listenForPropChanges: false
          }, function () {
            _this.isInTransition = false;

            _this.handleSideEffects();
          });
        };

        if (modalActive === false && !(0, _componentHelper.isTrue)(_this.props.no_animation)) {
          _this.setState({
            hide: true,
            _listenForPropChanges: false
          });

          clearTimeout(_this._closeTimeout);
          _this._closeTimeout = setTimeout(doItNow, parseFloat(_this.props.animation_duration));
        } else {
          doItNow();
        }
      };

      var waitBeforeOpen = function waitBeforeOpen() {
        var delay = parseFloat(_this.props.open_delay);

        if (delay > 0 && !(0, _componentHelper.isTrue)(_this.props.no_animation)) {
          clearTimeout(_this._openTimeout);
          _this._openTimeout = setTimeout(toggleNow, delay);
        } else {
          toggleNow();
        }
      };

      var open_modal = _this.props.open_modal;

      if (typeof open_modal === 'function') {
        var fn = open_modal(waitBeforeOpen, _assertThisInitialized(_this));

        if (fn) {
          _this._onUnmount.push(fn);
        }
      } else {
        waitBeforeOpen();
      }
    };

    _this.handleSideEffects = function () {
      var modalActive = _this.state.modalActive;

      if (typeof document !== 'undefined') {
        try {
          document.body.setAttribute('data-dnb-modal-active', modalActive ? 'true' : 'false');
        } catch (e) {
          (0, _componentHelper.warn)('Modal: Error on set "data-dnb-modal-active" by using element.setAttribute()', e);
        }
      }

      if (modalActive) {
        if (typeof _this.props.close_modal === 'function') {
          var fn = _this.props.close_modal(function () {
            _this.toggleOpenClose(null, false);
          }, _assertThisInitialized(_this));

          if (fn) {
            _this._onUnmount.push(fn);
          }
        }
      } else if (modalActive === false) {
        if (_this._triggerRef && _this._triggerRef.current) {
          _this._triggerRef.current.focus({
            preventScroll: true
          });
        }

        if ((_this.props.open_state === 'opened' || _this.props.open_state === true) && _this.activeElement) {
          try {
            _this.activeElement.focus({
              preventScroll: true
            });

            _this.activeElement = null;
          } catch (e) {}
        }
      }
    };

    _this.open = function (e) {
      _this.toggleOpenClose(e, true);
    };

    _this.close = function (event) {
      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        ifIsLatest: true
      },
          ifIsLatest = _ref.ifIsLatest,
          triggeredBy = _ref.triggeredBy;

      var prevent_close = _this.props.prevent_close;

      if ((0, _componentHelper.isTrue)(prevent_close)) {
        var id = _this._id;
        (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_close_prevent', {
          id: id,
          event: event,
          triggeredBy: triggeredBy,
          close: function close(e) {
            _this.toggleOpenClose(e, false);
          }
        });
      } else {
        if (ifIsLatest) {
          var list = (0, _ModalContent.getListOfModalRoots)();

          if (list.length > 1) {
            var last = (0, _ModalContent.getListOfModalRoots)(-1);

            if (last !== _assertThisInitialized(_this)) {
              return;
            }
          }
        }

        _this.toggleOpenClose(event, false);
      }
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this._triggerRef = _react.default.createRef();
    _this._onUnmount = [];
    return _this;
  }

  _createClass(Modal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.openBasedOnStateUpdate();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._onUnmount.forEach(function (fn) {
        if (typeof fn === 'function') {
          fn();
        }
      });

      clearTimeout(this._openTimeout);
      clearTimeout(this._closeTimeout);
      clearTimeout(this._sideEffectsTimeout);
      clearTimeout(this._tryToOpenTimeout);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.openBasedOnStateUpdate();
    }
  }, {
    key: "openBasedOnStateUpdate",
    value: function openBasedOnStateUpdate() {
      var _this$state = this.state,
          hide = _this$state.hide,
          modalActive = _this$state.modalActive;

      if (!this.activeElement && typeof document !== 'undefined') {
        this.activeElement = document.activeElement;
      }

      if (!this.isInTransition && !hide && !modalActive && (this.props.open_state === 'opened' || this.props.open_state === true)) {
        this.toggleOpenClose(null, true);
      } else if (!this.isInTransition && hide && modalActive && (this.props.open_state === 'closed' || this.props.open_state === false)) {
        this.toggleOpenClose(null, false);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, Modal.defaultProps, this.context.getTranslation(this.props).Modal, this.context.FormRow, this.context.Modal);

      var root_id = props.root_id,
          content_id = props.content_id,
          id = props.id,
          open_state = props.open_state,
          open_delay = props.open_delay,
          disabled = props.disabled,
          spacing = props.spacing,
          labelled_by = props.labelled_by,
          focus_selector = props.focus_selector,
          trigger = props.trigger,
          trigger_attributes = props.trigger_attributes,
          trigger_hidden = props.trigger_hidden,
          trigger_disabled = props.trigger_disabled,
          trigger_variant = props.trigger_variant,
          trigger_text = props.trigger_text,
          trigger_title = props.trigger_title,
          trigger_size = props.trigger_size,
          trigger_icon = props.trigger_icon,
          trigger_icon_position = props.trigger_icon_position,
          trigger_class = props.trigger_class,
          rest = _objectWithoutProperties(props, ["root_id", "content_id", "id", "open_state", "open_delay", "disabled", "spacing", "labelled_by", "focus_selector", "trigger", "trigger_attributes", "trigger_hidden", "trigger_disabled", "trigger_variant", "trigger_text", "trigger_title", "trigger_size", "trigger_icon", "trigger_icon_position", "trigger_class"]);

      var _this$state2 = this.state,
          hide = _this$state2.hide,
          modalActive = _this$state2.modalActive;
      var modal_content = Modal.getContent(typeof this.props.children === 'function' ? Object.freeze(_extends({}, this.props, {
        close: this.close
      })) : this.props);

      var render = function render(suffixProps) {
        var modalProps = {};
        var triggerAttributes = trigger_attributes ? _extends({}, trigger_attributes) : {};

        for (var prop in props) {
          if (prop.includes('trigger_') && props[prop] !== null) {
            var name = String(prop).replace('trigger_', '');

            if (name !== 'props' && prop !== 'element') {
              triggerAttributes[name] = props[prop];
            }
          }
        }

        var isHelpButton = !(0, _componentHelper.isTrue)(trigger_hidden) && (!!suffixProps || !(trigger_text && trigger_variant !== 'tertiary') && (!(triggerAttributes.icon || trigger_icon) || ['question', 'information'].includes(triggerAttributes.icon || trigger_icon)));

        if ((0, _componentHelper.isTrue)(disabled)) {
          triggerAttributes.disabled = true;
        }

        if (triggerAttributes.id) {
          _this2._id = triggerAttributes.id;
        }

        if (!rest.title && triggerAttributes.title) {
          modalProps.title = triggerAttributes.title;
        } else if (!rest.title && isHelpButton && suffixProps) {
            modalProps.title = _this2.context.translation.HelpButton.title;
          }

        if (isHelpButton) {
          triggerAttributes.title = props['aria-label'] || triggerAttributes.title || props.title || modalProps.title;
        } else {
          triggerAttributes['aria-roledescription'] = null;
        }

        var TriggerButton = trigger ? trigger : _HelpButtonInstance.default;
        return _react.default.createElement(_react.default.Fragment, null, TriggerButton && !(0, _componentHelper.isTrue)(trigger_hidden) && _react.default.createElement(TriggerButton, _extends({
          id: _this2._id,
          onClick: _this2.toggleOpenClose
        }, triggerAttributes, {
          innerRef: _this2._triggerRef,
          className: (0, _classnames.default)('dnb-modal__trigger', (0, _SpacingHelper.createSpacingClasses)(props), triggerAttributes.class, triggerAttributes.className)
        })), modalActive && modal_content && _react.default.createElement(ModalRoot, _extends({}, rest, {
          id: _this2._id,
          root_id: root_id,
          content_id: content_id || "dnb-modal-".concat(_this2._id),
          labelled_by: labelled_by,
          focus_selector: focus_selector,
          modal_content: modal_content,
          spacing: spacing,
          closeModal: _this2.close,
          hide: hide,
          toggleOpenClose: _this2.toggleOpenClose
        }, modalProps)));
      };

      return _react.default.createElement(_Suffix.SuffixContext.Consumer, null, render);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Modal.tagName, Modal, Modal.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (typeof props.modal_content === 'string') {
        return props.modal_content;
      } else if (typeof props.modal_content === 'function') {
        return props.modal_content(props);
      }

      return (0, _componentHelper.processChildren)(props);
    }
  }, {
    key: "insertModalRoot",
    value: function insertModalRoot(id) {
      if (typeof window === 'undefined') {
        return false;
      }

      try {
        id = "dnb-modal-".concat(id || 'root');
        window.__modalRoot = document.getElementById(id);

        if (!window.__modalRoot) {
          window.__modalRoot = document.createElement('div');

          window.__modalRoot.setAttribute('id', id);

          document.body.insertBefore(window.__modalRoot, document.body.firstChild);
        }
      } catch (e) {
        (0, _componentHelper.warn)('Modal: Could not insert dnb-modal-root', e);
      }

      return window.__modalRoot;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.open_state !== state._open_state) {
          switch (props.open_state) {
            case 'opened':
            case true:
              state.hide = false;

              if ((0, _componentHelper.isTrue)(props.no_animation)) {
                state.modalActive = true;
              }

              break;

            case 'closed':
            case false:
              state.hide = true;

              if ((0, _componentHelper.isTrue)(props.no_animation)) {
                state.modalActive = false;
              }

              break;
          }
        }
      }

      state._listenForPropChanges = true;
      state._open_state = props.open_state;
      return state;
    }
  }]);

  return Modal;
}(_react.default.PureComponent);

exports.default = Modal;
Modal.tagName = 'dnb-modal';
Modal.contextType = _Context.default;
Modal.Inner = _ModalInner.default;
Modal.defaultProps = {
  id: null,
  root_id: 'root',
  mode: 'modal',
  focus_selector: null,
  labelled_by: null,
  title: null,
  disabled: null,
  spacing: true,
  open_delay: null,
  content_id: null,
  close_title: 'Lukk',
  hide_close_button: false,
  prevent_close: false,
  prevent_core_style: false,
  animation_duration: 300,
  no_animation: false,
  no_animation_on_mobile: false,
  fullscreen: 'auto',
  min_width: null,
  max_width: null,
  align_content: null,
  container_placement: null,
  open_state: null,
  direct_dom_return: false,
  class: null,
  className: null,
  children: null,
  on_open: null,
  on_close: null,
  on_close_prevent: null,
  open_modal: null,
  close_modal: null,
  trigger: null,
  trigger_attributes: null,
  trigger_hidden: false,
  trigger_disabled: null,
  trigger_variant: 'secondary',
  trigger_text: null,
  trigger_title: null,
  trigger_size: null,
  trigger_icon: null,
  trigger_icon_position: 'left',
  trigger_class: null,
  overlay_class: null,
  content_class: null,
  modal_content: null
};
process.env.NODE_ENV !== "production" ? Modal.propTypes = _extends({
  id: _propTypes.default.string,
  root_id: _propTypes.default.string,
  mode: _propTypes.default.oneOf(['modal', 'drawer']),
  focus_selector: _propTypes.default.string,
  labelled_by: _propTypes.default.string,
  title: _propTypes.default.node,
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  spacing: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  open_delay: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  content_id: _propTypes.default.string,
  close_title: _propTypes.default.string,
  hide_close_button: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_close: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_core_style: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  animation_duration: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_animation_on_mobile: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  fullscreen: _propTypes.default.oneOf(['auto', true, false, 'true', 'false']),
  min_width: _propTypes.default.string,
  max_width: _propTypes.default.string,
  align_content: _propTypes.default.oneOf(['left', 'center', 'centered', 'right']),
  container_placement: _propTypes.default.oneOf(['left', 'right', 'top', 'bottom']),
  open_state: _propTypes.default.oneOfType([_propTypes.default.oneOf(['opened', 'closed']), _propTypes.default.bool]),
  direct_dom_return: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  on_open: _propTypes.default.func,
  on_close: _propTypes.default.func,
  on_close_prevent: _propTypes.default.func,
  open_modal: _propTypes.default.func,
  close_modal: _propTypes.default.func,
  trigger: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  trigger_attributes: _propTypes.default.object,
  trigger_hidden: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  trigger_disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  trigger_variant: _Button.buttonVariantPropType.variant,
  trigger_text: _propTypes.default.string,
  trigger_title: _propTypes.default.string,
  trigger_size: _propTypes.default.string,
  trigger_icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  trigger_icon_position: _propTypes.default.oneOf(['left', 'right']),
  trigger_class: _propTypes.default.string,
  overlay_class: _propTypes.default.string,
  content_class: _propTypes.default.string,
  modal_content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func])
}) : void 0;

var ModalRoot = function (_React$PureComponent2) {
  _inherits(ModalRoot, _React$PureComponent2);

  var _super2 = _createSuper(ModalRoot);

  function ModalRoot() {
    var _this3;

    _classCallCheck(this, ModalRoot);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _this3.state = {
      isMounted: false
    };
    return _this3;
  }

  _createClass(ModalRoot, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!(0, _componentHelper.isTrue)(this.props.direct_dom_return)) {
        Modal.insertModalRoot(this.props.root_id);

        try {
          if (!this.portalElem) {
            this.portalElem = document.createElement('div');
            this.portalElem.className = 'dnb-modal-root__inner';
          }

          if (this.portalElem && typeof window !== 'undefined' && window.__modalRoot) {
            window.__modalRoot.appendChild(this.portalElem);
          }
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }

        this.setState({
          isMounted: true
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      try {
        if (this.portalElem && typeof window !== 'undefined' && window.__modalRoot && window.__modalRoot.removeChild) {
          window.__modalRoot.removeChild(this.portalElem);

          this.portalElem = null;
        }
      } catch (e) {
        (0, _componentHelper.warn)(e);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          direct_dom_return = _this$props.direct_dom_return,
          props = _objectWithoutProperties(_this$props, ["children", "direct_dom_return"]);

      if ((0, _componentHelper.isTrue)(direct_dom_return)) {
        return _react.default.createElement(_ModalContent.default, props, children);
      }

      if (this.portalElem && typeof window !== 'undefined' && window.__modalRoot && this.state.isMounted) {
        return _reactDom.default.createPortal(_react.default.createElement(_ModalContent.default, props, children), this.portalElem);
      }

      return null;
    }
  }]);

  return ModalRoot;
}(_react.default.PureComponent);

ModalRoot.defaultProps = {
  id: null,
  root_id: null,
  direct_dom_return: false,
  children: null
};
process.env.NODE_ENV !== "production" ? ModalRoot.propTypes = {
  id: _propTypes.default.string,
  root_id: _propTypes.default.string,
  direct_dom_return: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func])
} : void 0;