import * as React from 'react';
export type NotificationNotificationAmount = string | number;
export type NotificationChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface NotificationProps extends React.HTMLProps<HTMLElement> {
  notification_amount?: NotificationNotificationAmount;
  title_text?: string;
  class?: string;
  className?: string;
  children?: NotificationChildren;
}
export default class Notification extends React.Component<
  NotificationProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
