"use strict";

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

var _Ul = _interopRequireDefault(require("./Ul"));

var _Ol = _interopRequireDefault(require("./Ol"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Li = function Li() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var className = _ref.className,
      p = _objectWithoutProperties(_ref, ["className"]);

  if (Array.isArray(p.children)) {
    p.children.forEach(function (Comp) {
      if (Comp && (Comp.type === _Ul.default || Comp.type === _Ol.default)) {
        className = (0, _classnames.default)(className, 'is-nested');
      }
    });
  }

  return _react.default.createElement(_Element.default, _extends({
    is: "li"
  }, p, {
    className: className
  }));
};

Li.tagName = 'dnb-li';
process.env.NODE_ENV !== "production" ? Li.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string
}) : void 0;
Li.defaultProps = {
  className: null
};
var _default = Li;
exports.default = _default;