"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _ref = _react.default.createElement("path", {
  d: "M23.25 9.89976L12.273 20.8777C9.63697 23.5138 5.36309 23.5138 2.72704 20.8777C0.0909862 18.2417 0.0909862 13.9678 2.72704 11.3318L11.743 2.31678C12.8729 1.14697 14.546 0.677822 16.1193 1.08964C17.6926 1.50146 18.9213 2.73016 19.3331 4.30349C19.745 5.87682 19.2758 7.54993 18.106 8.67976L9.09103 17.6997C8.20831 18.5526 6.80497 18.5406 5.93693 17.6728C5.0689 16.8051 5.05648 15.4017 5.90903 14.5188L14.925 5.49977",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function paperclip_medium(props) {
  return _react.default.createElement("svg", _extends({
    width: 24,
    height: 24,
    viewBox: "0 0 24 24",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

var _default = paperclip_medium;
exports.default = _default;