import * as React from 'react';
export type DescriptionListData = string | any[];
export type DescriptionListChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DescriptionListProps
  extends React.HTMLProps<HTMLElement> {
  data: DescriptionListData;
  info?: string;
  class?: string;
  className?: string;
  children?: DescriptionListChildren;
}
export default class DescriptionList extends React.Component<
  DescriptionListProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
