"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _Input = _interopRequireDefault(require("../../components/input/Input"));

var _IconPrimary = _interopRequireDefault(require("../../components/icon-primary/IconPrimary"));

var _Button = _interopRequireDefault(require("../../components/button/Button"));

var _Logo = _interopRequireDefault(require("../../components/logo/Logo"));

var _Notification = _interopRequireDefault(require("../../components/notification/Notification"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref2 = _react.default.createElement(_Logo.default, {
  height: 80
});

var _ref3 = _react.default.createElement(_Logo.default, {
  height: 80
});

var _ref4 = _react.default.createElement("div", {
  className: "dnb-main-nav__item"
}, _react.default.createElement(_Button.default, {
  variant: "secondary",
  text: "Logg ut"
}));

var MainNav = function (_React$PureComponent) {
  _inherits(MainNav, _React$PureComponent);

  var _super = _createSuper(MainNav);

  function MainNav(props) {
    var _this;

    _classCallCheck(this, MainNav);

    _this = _super.call(this, props);
    _this.state = {
      isSubNavActive: false
    };

    _this.toggleNavHandler = function () {
      var isSubNavActive = !_this.state.isSubNavActive;

      _this.setState({
        isSubNavActive: isSubNavActive
      });

      if (_this._innerRef) {
        _this._innerRef.current.setAttribute('tabindex', isSubNavActive ? '0' : '-1');

        if (isSubNavActive) {
          _this._innerRef.current.focus();
        }
      }
    };

    _this._innerRef = _react.default.createRef();
    return _this;
  }

  _createClass(MainNav, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.setState({
        isSubNavActive: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _params;

      var _this$props = this.props,
          baseurl = _this$props.baseurl,
          notification_amount = _this$props.notification_amount,
          className = _this$props.className,
          _className = _this$props.class;
      var data = MainNav.getData(this.props);
      var params = (_params = {
        role: 'navigation'
      }, _defineProperty(_params, 'aria-label', 'Main Menu'), _defineProperty(_params, 'data-nav-active', this.state.isSubNavActive), _defineProperty(_params, "className", (0, _classnames.default)('dnb-main-nav', className, _className)), _params);
      (0, _componentHelper.validateDOMAttributes)(this.props, params);
      return _react.default.createElement("nav", params, _react.default.createElement("div", {
        className: "dnb-main-nav__inner"
      }, _react.default.createElement("div", {
        className: "dnb-main-nav__inner__inner"
      }, _react.default.createElement("div", {
        className: "dnb-main-nav__left"
      }, _react.default.createElement("div", {
        className: "dnb-main-nav__item"
      }, _react.default.createElement(MainNavTrigger, {
        text: "Meny",
        onTrigger: this.toggleNavHandler
      })), _ref), _react.default.createElement("div", {
        className: "dnb-main-nav__item dnb-main-nav__logo"
      }, baseurl && _react.default.createElement("a", {
        href: baseurl,
        title: "Links back to front page"
      }, _ref2) || _ref3), _react.default.createElement("div", {
        className: "dnb-main-nav__right"
      }, _react.default.createElement("div", {
        className: "dnb-main-nav__item"
      }, notification_amount && _react.default.createElement(_Notification.default, {
        notification_amount: notification_amount,
        title_text: "Du har ".concat(notification_amount, " notifications")
      })), _ref4)), _react.default.createElement("div", {
        className: "dnb-main-nav__nav"
      }, _react.default.createElement("div", {
        className: "dnb-main-nav__nav__inner"
      }, _ref5, _react.default.createElement("div", {
        className: "dnb-main-nav__links dnb-width-limit dnb-tab-focus",
        tabIndex: "-1",
        ref: this._innerRef
      }, data.length > 0 && _react.default.createElement("ul", {
        className: "dnb-grid dnb-grid--gutters dnb-grid--center"
      }, data.map(function (_ref6, i) {
        var title = _ref6.title,
            url = _ref6.url;
        return _react.default.createElement("li", {
          key: "mn".concat(i),
          className: "dnb-grid__cell"
        }, _react.default.createElement("a", {
          href: url,
          className: "dnb-main-nav__link",
          tabIndex: "-1"
        }, _react.default.createElement("span", null, title)));
      })))))));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(MainNav.tagName, MainNav, MainNav.defaultProps);
    }
  }, {
    key: "getData",
    value: function getData(props) {
      var res = [];
      if (props.data) res = props.data;else res = (0, _componentHelper.processChildren)(props);
      if (typeof res === 'string') return res[0] === '[' ? JSON.parse(res) : [];
      return res || [];
    }
  }]);

  return MainNav;
}(_react.default.PureComponent);

exports.default = MainNav;
MainNav.tagName = 'dnb-main-nav';
MainNav.defaultProps = {
  data: [],
  baseurl: '/uilib/demos',
  notification_amount: 0,
  class: null,
  className: null,
  children: null
};
process.env.NODE_ENV !== "production" ? MainNav.propTypes = {
  data: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array]),
  baseurl: _propTypes.default.string,
  notification_amount: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;

var _ref7 = _react.default.createElement("span", {
  className: "dnb-main-nav-trigger__icon"
}, _react.default.createElement(_IconPrimary.default, {
  icon: "hamburger"
}));

var MainNavTrigger = function MainNavTrigger(props) {
  var text = props.text,
      className = props.className,
      modifier = props.modifier;
  var params = {
    className: (0, _classnames.default)('dnb-main-nav-trigger', className, modifier && "dnb-main-nav-trigger--".concat(modifier))
  };

  var onTriggerHandle = function onTriggerHandle() {
    if (typeof props.onTrigger === 'function') {
      props.onTrigger();
    }
  };

  return _react.default.createElement("button", _extends({
    onClick: onTriggerHandle
  }, params), _ref7, _react.default.createElement("span", {
    className: "dnb-main-nav-trigger__text"
  }, text));
};

process.env.NODE_ENV !== "production" ? MainNavTrigger.propTypes = {
  text: _propTypes.default.string,
  className: _propTypes.default.string,
  modifier: _propTypes.default.string,
  onTrigger: _propTypes.default.func
} : void 0;
MainNavTrigger.defaultProps = {
  text: null,
  className: null,
  modifier: null,
  onTrigger: null
};

var Search = function Search(props) {
  return _react.default.createElement(_Input.default, _extends({
    type: "search",
    id: "nav_search",
    label: "Label text",
    placeholder: "S\xF8k"
  }, props));
},
    _ref5 = _react.default.createElement("div", {
  className: "dnb-mobile-exclusive"
}, _react.default.createElement(Search, {
  id: "nav_search_mobile"
})),
    _ref = _react.default.createElement("div", {
  className: "dnb-main-nav__item dnb-hide-on-mobile"
}, _react.default.createElement(Search, null));