"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _ref = _react.default.createElement("title", null, "Hengel\xE5s");

var SVG = function SVG(props) {
  return _react.default.createElement("svg", _extends({}, props, {
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }), _ref, _react.default.createElement("path", {
    d: "M6.75 9.75V6C6.75 4.60761 7.30312 3.27226 8.28769 2.28769C9.27226 1.30312 10.6076 0.75 12 0.75C13.3924 0.75 14.7277 1.30312 15.7123 2.28769C16.6969 3.27226 17.25 4.60761 17.25 6V9.75M12 15V18M5.25 9.75H18.75C19.5784 9.75 20.25 10.4216 20.25 11.25V21.75C20.25 22.5784 19.5784 23.25 18.75 23.25H5.25C4.42157 23.25 3.75 22.5784 3.75 21.75V11.25C3.75 10.4216 4.42157 9.75 5.25 9.75Z",
    stroke: props.stroke,
    strokeWidth: "1.5",
    strokeLinecap: "round",
    strokeLinejoin: "round"
  }));
};

process.env.NODE_ENV !== "production" ? SVG.propTypes = {
  stroke: _propTypes.default.string,
  width: _propTypes.default.string,
  height: _propTypes.default.string,
  viewBox: _propTypes.default.string
} : void 0;
SVG.defaultProps = {
  stroke: '#FBF6EC',
  width: '24',
  height: '24',
  viewBox: '0 0 24 24'
};
var _default = SVG;
exports.default = _default;