import * as React from 'react';
export type RangeSliderChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface RangeSliderProps extends React.HTMLProps<HTMLElement> {
  label_text: string;
  range_min: number;
  range_max: number;
  range_val: number;
  range_step: number;
  range_output_description: string;
  range_output_extra_information: string;
  range_trigger_text: string;
  range_modal_text: string;
  class?: string;
  className?: string;
  children?: RangeSliderChildren;
}
export default class RangeSlider extends React.Component<
  RangeSliderProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
