import * as React from 'react';
export type SummaryTableChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface SummaryTableProps extends React.HTMLProps<HTMLElement> {
  prev_href?: string;
  next_href?: string;
  prev_text?: string;
  next_text?: string;
  prev_title?: string;
  next_title?: string;
  class?: string;
  className?: string;
  children?: SummaryTableChildren;
  render_left_content?: (...args: any[]) => any;
  render_right_content?: (...args: any[]) => any;
}
export default class SummaryTable extends React.Component<
  SummaryTableProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
