"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.number.constructor.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareDefaultProps = exports.registerElement = exports.registeredElements = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _errorHelper = require("./error-helper");

var _customElementPolyfill = _interopRequireDefault(require("./custom-element-polyfill"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var isTest = process.env.NODE_ENV === 'test';
var hasPolyfill = isTest;
var registeredElements = typeof window !== 'undefined' && (window.registeredElements = window.registeredElements || []) || [];
exports.registeredElements = registeredElements;

var registerElement = function registerElement(tagName, ReactComponent) {
  var propNames = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  var _ref = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
      _ref$attributesExclud = _ref.attributesExcludelist,
      attributesExcludelist = _ref$attributesExclud === void 0 ? ['id'] : _ref$attributesExclud;

  if (!tagName) tagName = ReactComponent.displayName || ReactComponent.name;
  if (registeredElements.indexOf(tagName) !== -1) return;
  registeredElements.push(tagName);

  if (typeof document === 'undefined' || typeof window === 'undefined') {
    return null;
  }

  if (!hasPolyfill) {
    hasPolyfill = true;
    (0, _customElementPolyfill.default)(window);
  }

  if (propNames) {
    propNames = prepareDefaultProps(propNames);
  }

  var HtmlClass = function (_HTMLElement) {
    _inherits(HtmlClass, _HTMLElement);

    var _super = _createSuper(HtmlClass);

    function HtmlClass(props) {
      var _this;

      _classCallCheck(this, HtmlClass);

      _this = _super.call(this, props);
      _this._elementRef = _react.default.createRef();
      _this._customMethodes = {};
      _this._customEvents = [];
      _this._isConnected = false;
      _this._props = {};
      return _this;
    }

    _createClass(HtmlClass, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        this.updateChildren();
        this.renderElement();
        this._isConnected = true;
      }
    }, {
      key: "attributeChangedCallback",
      value: function attributeChangedCallback(attrName, oldAttr, newAttr) {
        if (!this._isConnected || oldAttr === newAttr) {
          return false;
        }

        this.renderElement();
        return newAttr;
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        if (!isTest) {
          _reactDom.default.unmountComponentAtNode(this);
        }

        if (this._children) delete this._children;
        if (this._isConnected) delete this._isConnected;
        if (this._elementRef) delete this._elementRef;
        if (this._customMethodes) delete this._customMethodes;
        if (this._customEvents) delete this._customEvents;
        this._props = null;
        this._ref = null;
      }
    }, {
      key: "updateChildren",
      value: function updateChildren() {
        this._children = [];
        var i,
            cn = this.childNodes,
            v;

        for (i = cn.length; i--;) {
          v = toVdom(cn[i]);

          if (v) {
            this._children.push(v);
          }
        }
      }
    }, {
      key: "connectEvents",
      value: function connectEvents() {
        var props = {};

        for (var i = this.attributes.length; i--;) {
          props[this.attributes[i].name] = this.attributes[i].value;
        }

        if (props.events) {
          props.event = props.events;
          delete props.events;
        }

        var events = [].concat(_toConsumableArray(props.event ? props.event.split(',') : []), _toConsumableArray(Object.entries(props).map(function (_ref2) {
          var _ref3 = _slicedToArray(_ref2, 2),
              key = _ref3[0],
              value = _ref3[1];

          if (key && /^(on_|on[A-Z]|render_)/.test(key)) {
            return key + '=' + value;
          }

          return null;
        }).filter(Boolean)));

        if (events.length > 0) {
          events.forEach(function (eventDef) {
            var _eventDef$split = eventDef.split('='),
                _eventDef$split2 = _slicedToArray(_eventDef$split, 2),
                type = _eventDef$split2[0],
                func = _eventDef$split2[1];

            type = EVENT_TRANSLATIONS[type] || type;

            props[type] = function () {
              try {
                var _func$split = func.split('.'),
                    _func$split2 = _slicedToArray(_func$split, 2),
                    scope = _func$split2[0],
                    fn = _func$split2[1];

                fn = fn ? window[scope][fn] : window[scope];

                for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = arguments[_key];
                }

                var component = fn.apply(scope, [].concat(args));

                if (component instanceof HTMLElement) {
                  var children = [],
                      cn = component.childNodes,
                      a = component.attributes,
                      _props = {};

                  for (var _i2 = cn.length; _i2--;) {
                    children.push(toVdom(cn[_i2]));
                  }

                  for (var _i3 = a.length; _i3--;) {
                    _props[PROP_TRANSLATIONS[a[_i3].name] || a[_i3].name] = a[_i3].value;
                  }

                  var nodeName = component.nodeName.toLowerCase();
                  component.remove();
                  return _react.default.createElement(nodeName, _props, children);
                }

                return component;
              } catch (error) {
                new _errorHelper.ErrorHandler("The '".concat(type, "' event has failed. '").concat(func, "' has to exist on a 'window' scope!"), error);
              }
            };
          });
          delete props.event;
        }

        return props;
      }
    }, {
      key: "setProps",
      value: function setProps(props, value) {
        if (typeof props === 'string') {
          props = _defineProperty({}, props, value);
        }

        return this.renderElement(props);
      }
    }, {
      key: "getRef",
      value: function getRef() {
        return this._ref;
      }
    }, {
      key: "addEvent",
      value: function addEvent(eventName, eventCallback) {
        var _this2 = this,
            _this$_customEvents;

        var eventWrapper = function eventWrapper(event) {
          return eventCallback.apply(_this2, [event]);
        };

        (_this$_customEvents = this._customEvents) === null || _this$_customEvents === void 0 ? void 0 : _this$_customEvents.push({
          eventName: eventName,
          eventCallback: eventCallback,
          eventWrapper: eventWrapper
        });
        return eventWrapper;
      }
    }, {
      key: "removeEvent",
      value: function removeEvent(eventId) {
        var removeCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        this._customEvents = this._customEvents.reduce(function (accumulator, current) {
          if (removeCallback) {
            var eventWrapper = current.eventCallback;

            if (eventWrapper !== removeCallback) {
              accumulator.push(current);
            }
          } else {
            var _eventWrapper = current.eventWrapper;

            if (_eventWrapper !== eventId) {
              accumulator.push(current);
            }
          }

          return accumulator;
        }, []);
      }
    }, {
      key: "fireEvent",
      value: function fireEvent(eventName) {
        var _this3 = this;

        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        this._customEvents.forEach(function (_ref4) {
          var name = _ref4.eventName,
              eventCallback = _ref4.eventCallback;

          if (name === eventName && typeof eventCallback === 'function') {
            eventCallback.apply(_this3, [].concat(args));
          }
        });
      }
    }, {
      key: "renderElement",
      value: function renderElement() {
        var _this4 = this;

        var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        props = _extends({}, this._props, this.connectEvents(), props);

        for (var p in props) {
          if (props[p] === 'true') {
            props[p] = true;
          } else if (props[p] === 'false') {
            props[p] = false;
          } else if (typeof props[p] !== 'undefined' && props[p] !== null && !isNaN(Number(props[p]))) {
            props[p] = Number(props[p]);
          }
        }

        for (var i = attributesExcludelist.length; i--;) {
          if (props[attributesExcludelist[i]]) {
            this.removeAttribute(attributesExcludelist[i]);
          }
        }

        if (this._children && this._children.length > 0) {
          props.children = this._children;
        }

        if (this._elementRef) {
          props.ref = this._elementRef;
        }

        if (!props.custom_element) {
          props.custom_element = this;
        }

        if (!props.custom_method) {
          props.custom_method = function (methodName, methodFunc) {
            _this4[methodName] = _this4._customMethodes[methodName] = methodFunc;
          };
        }

        this._props = props;
        this._ref = _react.default.createElement(ReactComponent, props);

        _reactDom.default.render(this._ref, this);

        return this;
      }
    }], [{
      key: "observedAttributes",
      get: function get() {
        return propNames || [];
      }
    }]);

    return HtmlClass;
  }(_wrapNativeSuper(HTMLElement));

  return window.customElements.define(tagName, HtmlClass);
};

exports.registerElement = registerElement;

var filterProps = function filterProps(key) {
  return key && !/[A-Z]/.test(key) && !/children/.test(key);
};

var prepareDefaultProps = function prepareDefaultProps(defaultProps) {
  return Array.isArray(defaultProps) ? defaultProps.filter(filterProps) : Object.entries(defaultProps || {}).reduce(function (props, _ref5) {
    var _ref6 = _slicedToArray(_ref5, 1),
        key = _ref6[0];

    props.push(key);
    return props;
  }, []).filter(filterProps);
};

exports.prepareDefaultProps = prepareDefaultProps;

var toVdom = function toVdom(elem) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  if (elem.nodeType === 3) return elem.nodeValue;
  if (elem.nodeType !== 1) return null;
  var children = [],
      props = {},
      i = 0,
      a = elem.attributes,
      cn = elem.childNodes;

  for (i = a.length; i--;) {
    props[a[i].name] = a[i].value;
  }

  for (i = cn.length; i--;) {
    children[i] = toVdom(cn[i]);
  }

  props.key = "key".concat(Math.random() * 1000);
  return _react.default.createElement(name || elem.nodeName.toLowerCase(), props, children);
};

var PROP_TRANSLATIONS = {
  class: 'className',
  for: 'htmlFor'
};
var EVENT_TRANSLATIONS = {
  onclick: 'onClick'
};