"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ErrorHandler = ErrorHandler;
exports.ERROR_FATAL = exports.ERROR_HARMLESS = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var ERROR_HARMLESS = 100;
exports.ERROR_HARMLESS = ERROR_HARMLESS;
var ERROR_FATAL = 500;
exports.ERROR_FATAL = ERROR_FATAL;

function ErrorHandler(error) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    message: null
  },
      message = _ref.message;

  var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ERROR_HARMLESS;

  if (_typeof(error) === 'object') {
    message = error.message;
  }

  this.err = new Error("".concat(error, "\n\n").concat(message));

  if (code === ERROR_FATAL) {
    throw this.err;
  } else {
    console.log(this.err);
  }
}