import * as React from 'react';
export type DatePickerAddonShortcuts = any[] | ((...args: any[]) => any);
export type DatePickerAddonRenderElement =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DatePickerAddonProps
  extends React.HTMLProps<HTMLElement> {
  shortcuts?: DatePickerAddonShortcuts;
  renderElement?: DatePickerAddonRenderElement;
}
export default class DatePickerAddon extends React.Component<
  DatePickerAddonProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
