import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _extends from "@babel/runtime/helpers/esm/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import Context from '../../shared/Context';
import { extendPropsWithContext } from '../../shared/component-helper';
import DefaultIcon, { iconPropTypes, DefaultIconSize, prerenderIcon, prepareIcon } from '../icon/Icon';
import * as primary_icons from '../../icons/primary_icons.js';
import * as primary_icons_medium from '../../icons/primary_icons_medium.js';

var icons = _extends({}, primary_icons, primary_icons_medium);

export { DefaultIconSize };

var IconPrimary = function (_React$PureComponent) {
  _inherits(IconPrimary, _React$PureComponent);

  var _super = _createSuper(IconPrimary);

  function IconPrimary() {
    _classCallCheck(this, IconPrimary);

    return _super.apply(this, arguments);
  }

  _createClass(IconPrimary, [{
    key: "render",
    value: function render() {
      var _this$context;

      var props = extendPropsWithContext(this.props, IconPrimary.defaultProps, {
        skeleton: (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.skeleton
      }, this.context.FormRow, this.context.Icon, this.context.IconPrimary);

      var _prepareIcon = prepareIcon(props, this.context),
          icon = _prepareIcon.icon,
          size = _prepareIcon.size,
          wrapperParams = _prepareIcon.wrapperParams,
          iconParams = _prepareIcon.iconParams,
          alt = _prepareIcon.alt;

      var IconContainer = prerenderIcon({
        icon: icon,
        size: size,
        alt: alt,
        listOfIcons: icons
      });
      if (!IconContainer) return React.createElement(React.Fragment, null);
      return React.createElement("span", wrapperParams, React.createElement(IconContainer, iconParams));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      DefaultIcon.enableWebComponent(IconPrimary.tagName, IconPrimary);
    }
  }, {
    key: "getIcon",
    value: function getIcon(props) {
      return DefaultIcon.getIcon(props);
    }
  }]);

  return IconPrimary;
}(React.PureComponent);

IconPrimary.tagName = 'dnb-icon-primary';
IconPrimary.contextType = Context;
IconPrimary.defaultProps = _extends({}, DefaultIcon.defaultProps);
export { IconPrimary as default };
process.env.NODE_ENV !== "production" ? IconPrimary.propTypes = _extends({}, iconPropTypes) : void 0;