import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';

var _ref = React.createElement("span", {
  className: "dnb-line-title__mask",
  "aria-hidden": "true"
});

var _ref2 = React.createElement("span", {
  className: "dnb-line-title__line",
  "aria-hidden": "true"
});

var LineTitle = function (_React$PureComponent) {
  _inherits(LineTitle, _React$PureComponent);

  var _super = _createSuper(LineTitle);

  function LineTitle() {
    _classCallCheck(this, LineTitle);

    return _super.apply(this, arguments);
  }

  _createClass(LineTitle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          tag = _this$props.tag,
          modifier = _this$props.modifier,
          className = _this$props.className,
          _className = _this$props.class;
      var content = LineTitle.getContent(this.props);
      var params = {
        className: classnames('dnb-line-title', className, _className, modifier && "dnb-line-title--".concat(modifier))
      };
      validateDOMAttributes(this.props, params);
      var Tag = "".concat(tag);
      return React.createElement(Tag, params, React.createElement("span", {
        className: "dnb-line-title__title dnb-typo-light"
      }, _ref, React.createElement("span", {
        className: "dnb-line-title__text"
      }, content)), _ref2);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(LineTitle.tagName, LineTitle, LineTitle.defaultProps);
    }
  }, {
    key: "getContent",
    value: function getContent(props) {
      if (typeof props.content === 'string') {
        return props.content;
      }

      return processChildren(props);
    }
  }]);

  return LineTitle;
}(React.PureComponent);

LineTitle.tagName = 'dnb-line-title';
LineTitle.defaultProps = {
  content: null,
  modifier: null,
  tag: 'h2',
  class: null,
  className: null,
  children: null
};
export { LineTitle as default };
process.env.NODE_ENV !== "production" ? LineTitle.propTypes = {
  content: PropTypes.string,
  modifier: PropTypes.string,
  tag: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;