import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

var Code = function Code(p) {
  return React.createElement(E, _extends({
    is: "code"
  }, p));
};

Code.tagName = 'dnb-code';
process.env.NODE_ENV !== "production" ? Code.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Code.defaultProps = {
  children: null
};
export default Code;