import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import H from './H';

var H1 = function H1(props) {
  return React.createElement(H, _extends({
    is: "h1"
  }, props));
};

H1.tagName = 'dnb-h1';
process.env.NODE_ENV !== "production" ? H1.propTypes = _extends({}, spacingPropTypes, {
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  children: PropTypes.node
}) : void 0;
H1.defaultProps = {
  level: null,
  size: 'xx-large',
  children: null
};
export default H1;