import * as React from 'react';
export type TooltipWithEventsShowDelay = string | number;
export type TooltipWithEventsTarget =
  | string
  | Object
  | ((...args: any[]) => any)
  | React.ReactNode;
export type TooltipWithEventsChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TooltipWithEventsProps
  extends React.HTMLProps<HTMLElement> {
  className?: string;
  internal_id?: string;
  show_delay?: TooltipWithEventsShowDelay;
  target?: TooltipWithEventsTarget;
  children?: TooltipWithEventsChildren;
}
export default class TooltipWithEvents extends React.Component<
  TooltipWithEventsProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
