import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Blockquote = p => React.createElement(E, _extends({
  is: "blockquote",
  skeleton_method: "font-only"
}, p));

Blockquote.tagName = 'dnb-blockquote';
process.env.NODE_ENV !== "production" ? Blockquote.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Blockquote.defaultProps = {
  children: null
};
export default Blockquote;