import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Div = p => React.createElement(E, _extends({
  is: "div",
  skeleton_method: "shape"
}, p));

Div.tagName = 'dnb-div';
process.env.NODE_ENV !== "production" ? Div.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Div.defaultProps = {
  children: null
};
export default Div;