import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Dt = (p = {}) => React.createElement(E, _extends({
  is: "dt"
}, p));

Dt.tagName = 'dnb-dt';
process.env.NODE_ENV !== "production" ? Dt.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Dt.defaultProps = {
  children: null
};
export default Dt;