import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import H from './H';

const H2 = props => React.createElement(H, _extends({
  is: "h2"
}, props));

H2.tagName = 'dnb-h2';
process.env.NODE_ENV !== "production" ? H2.propTypes = _extends({}, spacingPropTypes, {
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  children: PropTypes.node
}) : void 0;
H2.defaultProps = {
  level: null,
  size: 'large',
  children: null
};
export default H2;