import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import H from './H';

const H6 = props => React.createElement(H, _extends({
  is: "h6"
}, props));

H6.tagName = 'dnb-h6';
process.env.NODE_ENV !== "production" ? H6.propTypes = _extends({}, spacingPropTypes, {
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  children: PropTypes.node
}) : void 0;
H6.defaultProps = {
  level: null,
  size: 'x-small',
  children: null
};
export default H6;