import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M3 10.5L8 5.5L13 10.5",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function chevron_up(props) {
  return React.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default chevron_up;