import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M1 15L5.97777 10.0223M1 15H4.11111M1 15V11.8889M10.0222 5.97777L15 1M15 1V4.11111M15 1H11.8889M1 1L5.97777 5.97777M1 1V4.11111M1 1H4.11111M10.0222 10.0223L15 15M15 15H11.8889M15 15V11.8889",
  stroke: "black",
  strokeWidth: 1.5,
  strokeMiterlimit: 10,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function fullscreen(props) {
  return React.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default fullscreen;