import { enableWebComponents as enableComponents } from './components/lib';
import { enableWebComponents as enablePatterns } from './patterns/lib';
export * from './components/lib';
export * from './patterns/lib';
let webComponentsAreEnabled = false;
export const enableWebComponents = () => {
  if (webComponentsAreEnabled) return false;
  webComponentsAreEnabled = true;
  enableComponents();
  enablePatterns();
};