import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes, createSpacingClasses } from '../space/SpacingHelper';

var CustomContent = function (_React$PureComponent) {
  _inherits(CustomContent, _React$PureComponent);

  var _super = _createSuper(CustomContent);

  function CustomContent() {
    _classCallCheck(this, CustomContent);

    return _super.apply(this, arguments);
  }

  _createClass(CustomContent, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          displayName = _this$props.displayName,
          title = _this$props.title,
          hash = _this$props.hash,
          selected = _this$props.selected,
          disabled = _this$props.disabled,
          className = _this$props.className,
          _className = _this$props.class,
          rest = _objectWithoutProperties(_this$props, ["children", "displayName", "title", "hash", "selected", "disabled", "className", "class"]);

      return React.createElement("div", {
        className: classnames('dnb-tabs__content__inner', createSpacingClasses(rest), className, _className)
      }, children);
    }
  }]);

  return CustomContent;
}(React.PureComponent);

CustomContent.defaultProps = {
  displayName: 'CustomContent',
  title: null,
  hash: null,
  selected: null,
  disabled: null,
  className: null,
  class: null
};
export { CustomContent as default };
process.env.NODE_ENV !== "production" ? CustomContent.propTypes = _extends({
  displayName: PropTypes.string,
  title: PropTypes.oneOfType([PropTypes.object, PropTypes.node, PropTypes.func]),
  hash: PropTypes.string,
  selected: PropTypes.oneOfType([PropTypes.string, PropTypes.bool]),
  disabled: PropTypes.oneOfType([PropTypes.string, PropTypes.bool])
}, spacingPropTypes, {
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  class: PropTypes.string
}) : void 0;