import * as React from 'react';
export type TooltipContainerTargetElement =
  | string
  | ((...args: any[]) => any)
  | Object
  | React.ReactNode;
export type TooltipContainerActive = string | boolean;
export type TooltipContainerAnimatePosition = string | boolean;
export type TooltipContainerChildren =
  | string
  | ((...args: any[]) => any)
  | React.ReactNode;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TooltipContainerProps
  extends React.HTMLProps<HTMLElement> {
  internal_id?: string;
  targetElement?: TooltipContainerTargetElement;
  active?: TooltipContainerActive;
  position?: string;
  arrow?: string;
  align?: string;
  animate_position?: TooltipContainerAnimatePosition;
  useHover?: boolean;
  attributes?: Object;
  children?: TooltipContainerChildren;
}
export default class TooltipContainer extends React.Component<
  TooltipContainerProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
