import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import H from './H';

var H4 = function H4(props) {
  return React.createElement(H, _extends({
    is: "h4"
  }, props));
};

H4.tagName = 'dnb-h4';
process.env.NODE_ENV !== "production" ? H4.propTypes = _extends({}, spacingPropTypes, {
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  children: PropTypes.node
}) : void 0;
H4.defaultProps = {
  level: null,
  size: 'basis',
  children: null
};
export default H4;