import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

var Lead = function Lead(p) {
  return React.createElement(E, _extends({
    is: "p"
  }, p));
};

Lead.tagName = 'dnb-lead';
process.env.NODE_ENV !== "production" ? Lead.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Lead.defaultProps = {
  children: null
};
export default Lead;