import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M5 19H19M3.35714 23H20.6429C21.9447 23 23 21.8635 23 20.4615V3.53846C23 2.13651 21.9447 1 20.6429 1H3.35714C2.05533 1 1 2.13651 1 3.53846V20.4615C1 21.8635 2.05533 23 3.35714 23Z",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function minimize_medium(props) {
  return React.createElement("svg", _extends({
    width: 24,
    height: 24,
    viewBox: "0 0 24 24",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default minimize_medium;