import * as React from 'react';
export type FormSummaryDescriptionListData = string | any[];
export type FormSummaryChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FormSummaryProps extends React.HTMLProps<HTMLElement> {
  title?: string;
  text?: string;
  descriptionListData?: FormSummaryDescriptionListData;
  descriptionListInfo?: string;
  class?: string;
  className?: string;
  children?: FormSummaryChildren;
}
export default class FormSummary extends React.Component<
  FormSummaryProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
