import * as React from 'react';
export type FormChildren = React.ReactNode | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FormProps extends React.HTMLProps<HTMLElement> {
  class?: string;
  range_val?: string;
  className?: string;
  children?: FormChildren;
}
export default class Form extends React.Component<FormProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
