import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import SummaryTable from './SummaryTable';
import Button from '../../components/button/Button';

var _ref = React.createElement("div", {
  className: "example-box"
}, React.createElement(SummaryTable, {
  prev_href: "?prev",
  next_href: "?next"
}));

var _ref2 = React.createElement("h3", null, "Custom left nav content");

var _ref3 = React.createElement("div", {
  className: "dnb-summary-table__item"
}, React.createElement(Button, {
  text: "Lagre",
  title: "Lagre",
  icon_position: "left",
  variant: "secondary",
  icon: "save"
}));

var _ref4 = React.createElement("div", {
  className: "dnb-summary-table__item"
}, React.createElement(Button, {
  text: "Avbryt",
  title: "Avbryt",
  icon_position: "left",
  variant: "secondary",
  icon: "close"
}));

var Example = function (_React$PureComponent) {
  _inherits(Example, _React$PureComponent);

  var _super = _createSuper(Example);

  function Example() {
    _classCallCheck(this, Example);

    return _super.apply(this, arguments);
  }

  _createClass(Example, [{
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, _ref, React.createElement("div", {
        className: "example-box"
      }, React.createElement(SummaryTable, {
        render_left_content: function render_left_content() {
          return _ref2;
        }
      }, _ref3, _ref4)));
    }
  }]);

  return Example;
}(React.PureComponent);

export { Example };
export default Example;