import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { registerElement, validateDOMAttributes, processChildren } from '../../shared/component-helper';

var ViewTitle = function (_React$PureComponent) {
  _inherits(ViewTitle, _React$PureComponent);

  var _super = _createSuper(ViewTitle);

  function ViewTitle() {
    _classCallCheck(this, ViewTitle);

    return _super.apply(this, arguments);
  }

  _createClass(ViewTitle, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          Component = _this$props.tag,
          className = _this$props.className,
          _className = _this$props.class;
      var text = ViewTitle.getText(this.props);
      var params = {
        className: classnames('dnb-view-title', className, _className)
      };
      validateDOMAttributes(this.props, params);
      return React.createElement(Component, params, text);
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(ViewTitle.tagName, ViewTitle, ViewTitle.defaultProps);
    }
  }, {
    key: "getText",
    value: function getText(props) {
      if (typeof props.text === 'string') {
        return props.text;
      }

      return processChildren(props);
    }
  }]);

  return ViewTitle;
}(React.PureComponent);

ViewTitle.tagName = 'dnb-view-title';
ViewTitle.defaultProps = {
  text: null,
  tag: 'h1',
  class: null,
  className: null,
  children: null
};
export { ViewTitle as default };
process.env.NODE_ENV !== "production" ? ViewTitle.propTypes = {
  text: PropTypes.string,
  tag: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;