import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M1 14L15 14M1 8L15 8M1 2L15 2",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round"
});

function hamburger(props) {
  return React.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default hamburger;