import { enableWebComponents as enableComponents } from './components/lib';
import { enableWebComponents as enablePatterns } from './patterns/lib';
export * from './components/lib';
export * from './patterns/lib';
var webComponentsAreEnabled = false;
export var enableWebComponents = function enableWebComponents() {
  if (webComponentsAreEnabled) return false;
  webComponentsAreEnabled = true;
  enableComponents();
  enablePatterns();
};