import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import { registerElement, validateDOMAttributes } from '../../shared/component-helper';

var FieldsetDescription = function (_React$PureComponent) {
  _inherits(FieldsetDescription, _React$PureComponent);

  var _super = _createSuper(FieldsetDescription);

  function FieldsetDescription() {
    _classCallCheck(this, FieldsetDescription);

    return _super.apply(this, arguments);
  }

  _createClass(FieldsetDescription, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          text = _this$props.text,
          className = _this$props.className,
          _className = _this$props.class;
      var params = {
        className: "dnb-fieldset-description ".concat(className || _className || '')
      };
      validateDOMAttributes(this.props, params);
      return React.createElement("div", params, React.createElement("p", {
        className: "dnb-fieldset-description__text"
      }, text));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      registerElement(FieldsetDescription.tagName, FieldsetDescription, FieldsetDescription.defaultProps);
    }
  }]);

  return FieldsetDescription;
}(React.PureComponent);

FieldsetDescription.tagName = 'dnb-fieldset-description';
FieldsetDescription.defaultProps = {
  text: null,
  class: null,
  className: null,
  children: null
};
export { FieldsetDescription as default };
process.env.NODE_ENV !== "production" ? FieldsetDescription.propTypes = {
  text: PropTypes.string,
  class: PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.string, PropTypes.node, PropTypes.func])
} : void 0;