import _taggedTemplateLiteral from "@babel/runtime/helpers/esm/taggedTemplateLiteral";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

var _templateObject;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import MainNav from './MainNav';
import styled from '@emotion/styled';

var Example = function (_React$PureComponent) {
  _inherits(Example, _React$PureComponent);

  var _super = _createSuper(Example);

  function Example() {
    _classCallCheck(this, Example);

    return _super.apply(this, arguments);
  }

  _createClass(Example, [{
    key: "render",
    value: function render() {
      return React.createElement(React.Fragment, null, React.createElement(MainNav, {
        data: [{
          title: 'Title 1',
          url: '?url1'
        }, {
          title: 'Title 2',
          url: '?url2'
        }, {
          title: 'Title 3',
          url: '?url3'
        }, {
          title: 'Title 4',
          url: '?url4'
        }, {
          title: 'Title 5',
          url: '?url5'
        }, {
          title: 'Title 6',
          url: '?url6'
        }],
        notification_amount: "3",
        baseurl: "https://www.dnb.no"
      }));
    }
  }]);

  return Example;
}(React.PureComponent);

var Wrapper = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  position: relative;\n  z-index: 2;\n"])));
export { Example };

var _ref = React.createElement(Wrapper, null, React.createElement(Example, null));

export default function StyledExample() {
  return _ref;
}