"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.find.js");

require("core-js/modules/es.array.find-index.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.index-of.js");

require("core-js/modules/es.array.splice.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _componentHelper = require("../../shared/component-helper");

var _IconPrimary = _interopRequireDefault(require("../../components/icon-primary/IconPrimary"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _AccordionContext = _interopRequireDefault(require("./AccordionContext"));

var _SpacingHelper = require("../space/SpacingHelper");

var _SkeletonHelper = require("../skeleton/SkeletonHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function AccordionHeaderTitle(_ref) {
  var children = _ref.children,
      rest = _objectWithoutProperties(_ref, ["children"]);

  return _react.default.createElement("span", {
    className: (0, _classnames.default)('dnb-accordion__header__title', (0, _SpacingHelper.createSpacingClasses)(rest))
  }, children);
}

process.env.NODE_ENV !== "production" ? AccordionHeaderTitle.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  children: _propTypes.default.node
}) : void 0;
AccordionHeaderTitle.defaultProps = {
  children: null
};

function AccordionHeaderDescription(_ref2) {
  var children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, ["children"]);

  return children ? _react.default.createElement("span", {
    className: (0, _classnames.default)('dnb-accordion__header__description', (0, _SpacingHelper.createSpacingClasses)(rest))
  }, children) : null;
}

process.env.NODE_ENV !== "production" ? AccordionHeaderDescription.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  children: _propTypes.default.node
}) : void 0;
AccordionHeaderDescription.defaultProps = {
  children: null
};

function AccordionHeaderContainer(_ref3) {
  var children = _ref3.children,
      rest = _objectWithoutProperties(_ref3, ["children"]);

  return children ? _react.default.createElement("span", {
    className: (0, _classnames.default)('dnb-accordion__header__container', (0, _SpacingHelper.createSpacingClasses)(rest))
  }, children) : null;
}

process.env.NODE_ENV !== "production" ? AccordionHeaderContainer.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  children: _propTypes.default.node
}) : void 0;
AccordionHeaderContainer.defaultProps = {
  children: null
};

function AccordionHeaderIcon(_ref4) {
  var icon = _ref4.icon,
      rest = _objectWithoutProperties(_ref4, ["icon"]);

  return _react.default.createElement("span", {
    className: "dnb-accordion__header__icon"
  }, _react.default.createElement(_IconPrimary.default, _extends({}, rest, {
    icon: icon || 'chevron-down',
    "aria-hidden": true
  })));
}

process.env.NODE_ENV !== "production" ? AccordionHeaderIcon.propTypes = {
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  size: _propTypes.default.string
} : void 0;
AccordionHeaderIcon.defaultProps = {
  icon: null,
  size: 'medium'
};

var AccordionHeader = function (_React$PureComponent) {
  _inherits(AccordionHeader, _React$PureComponent);

  var _super = _createSuper(AccordionHeader);

  function AccordionHeader(props) {
    var _this;

    _classCallCheck(this, AccordionHeader);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch ((0, _keycode.default)(event)) {
        case 'enter':
        case 'space':
          event.preventDefault();

          _this.onClickHandler(event);

          break;
      }
    };

    _this.onClickHandler = function (event) {
      var _this$context = _this.context,
          id = _this$context.id,
          group = _this$context.group;

      if (_this.canClick()) {
        var expanded = !_this.context.expanded;

        _this.context.callOnChange({
          id: id,
          group: group,
          expanded: expanded,
          event: event
        });

        _this.setState({
          hadClick: true
        });
      }
    };

    _this.onMouseOverHandler = function () {
      _this.setState({
        hover: true
      });
    };

    _this.onMouseOutHander = function () {
      _this.setState({
        hover: false,
        hadClick: false
      });
    };

    _this.state = {};
    return _this;
  }

  _createClass(AccordionHeader, [{
    key: "canClick",
    value: function canClick() {
      var _this$context2 = this.context,
          expanded = _this$context2.expanded,
          allow_close_all = _this$context2.allow_close_all,
          group = _this$context2.group;
      return !group || group && !expanded || (0, _componentHelper.isTrue)(allow_close_all);
    }
  }, {
    key: "render",
    value: function render() {
      var props = (0, _componentHelper.extendPropsWithContext)(this.props, AccordionHeader.defaultProps, this.context);
      var id = props.id,
          left_component = props.left_component,
          expanded = props.expanded,
          title = props.title,
          description = props.description,
          element = props.element,
          heading = props.heading,
          heading_level = props.heading_level,
          icon = props.icon,
          icon_size = props.icon_size,
          disabled = props.disabled,
          skeleton = props.skeleton;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          _left_component = _this$props.left_component,
          _expanded = _this$props.expanded,
          _title = _this$props.title,
          _description = _this$props.description,
          _icon = _this$props.icon,
          _icon_size = _this$props.icon_size,
          _disabled = _this$props.disabled,
          rest = _objectWithoutProperties(_this$props, ["children", "className", "left_component", "expanded", "title", "description", "icon", "icon_size", "disabled"]);

      var _this$state = this.state,
          hover = _this$state.hover,
          hadClick = _this$state.hadClick;
      var icon_position = props.icon_position;
      var defaultParts = [_react.default.createElement(AccordionHeaderIcon, {
        key: "icon",
        icon: icon,
        size: icon_size
      }), _react.default.createElement(AccordionHeaderContainer, {
        key: "container"
      }, left_component), _react.default.createElement(AccordionHeaderTitle, {
        key: "title"
      }, title || (Array.isArray(children) ? children.filter(function (cur) {
        return !_react.default.isValidElement(cur);
      }) : children)), _react.default.createElement(AccordionHeaderDescription, {
        key: "description"
      }, description)];

      if (Array.isArray(children)) {
        var removeParts = [];
        children.forEach(function (cur) {
          if (_react.default.isValidElement(cur)) {
            var part = defaultParts.find(function (c) {
              return c.type === cur.type;
            });

            if (part) {
              removeParts.push(part);
            }

            defaultParts.push(cur);
          }
        });
        removeParts.forEach(function (part) {
          var index = defaultParts.findIndex(function (c) {
            return c === part;
          });

          if (index > -1) {
            defaultParts.splice(index, 1);
          }
        });
      }

      var partsToRender = [];
      var wrapperParts = [];

      var wrapperComp = _react.default.createElement("span", {
        className: "dnb-accordion__header__wrapper",
        key: "wrapper"
      }, wrapperParts);

      defaultParts.forEach(function (part) {
        if (_react.default.isValidElement(part) && (part.type === AccordionHeaderTitle || part.type === AccordionHeaderDescription)) {
          wrapperParts.push(part);

          if (partsToRender.findIndex(function (c) {
            return c === wrapperComp;
          }) === -1) {
            partsToRender.push(wrapperComp);
          }
        } else {
          partsToRender.push(part);
        }
      });

      if (icon_position === null) {
        var iconIndex = partsToRender.findIndex(function (c) {
          return c.type === AccordionHeaderIcon;
        });

        if (iconIndex > 1) {
          icon_position = 'right';
        }

        if (left_component) {
          icon_position = 'right';
        }
      }

      var headerParams = _extends({
        id: "".concat(id, "-header"),
        'aria-controls': "".concat(id, "-content"),
        'aria-expanded': this.context.expanded,
        role: 'button',
        tabIndex: '0',
        className: (0, _classnames.default)('dnb-accordion__header', (0, _SkeletonHelper.createSkeletonClass)('font', skeleton, this.context), (0, _SpacingHelper.createSpacingClasses)(rest), className, icon_position && "dnb-accordion__header__icon--".concat(icon_position), hover && hadClick && 'dnb-accordion--hover', !this.canClick() && 'dnb-accordion__header--prevent-click', description && 'dnb-accordion__header--description'),
        disabled: disabled
      }, rest);

      if (disabled || (0, _componentHelper.isTrue)(skeleton)) {
        headerParams.tabIndex = '-1';
        headerParams.disabled = true;
        headerParams['aria-disabled'] = true;
      } else {
        headerParams.onClick = this.onClickHandler;
        headerParams.onKeyDown = this.onKeyDownHandler;
        headerParams.onMouseOver = this.onMouseOverHandler;
        headerParams.onMouseOut = this.onMouseOutHander;
      }

      (0, _SkeletonHelper.skeletonDOMAttributes)(headerParams, skeleton, this.context);
      (0, _componentHelper.validateDOMAttributes)(this.props, headerParams);
      var Element = 'div';

      if ((0, _componentHelper.isTrue)(heading)) {
        headerParams.role = 'heading';
        headerParams['aria-level'] = heading_level ? String(heading_level) : 'h2';
      } else if (heading) {
        headerParams.role = null;
        Element = heading;
      } else if (element) {
        headerParams.role = null;
        Element = element;
      }

      return _react.default.createElement(Element, headerParams, partsToRender);
    }
  }]);

  return AccordionHeader;
}(_react.default.PureComponent);

exports.default = AccordionHeader;
AccordionHeader.contextType = _AccordionContext.default;
AccordionHeader.defaultProps = {
  id: null,
  title: null,
  description: null,
  left_component: null,
  element: null,
  heading: null,
  heading_level: null,
  icon: null,
  icon_position: null,
  icon_size: 'medium',
  disabled: null,
  skeleton: null,
  className: null,
  children: null
};
AccordionHeader.Container = AccordionHeaderContainer;
AccordionHeader.Icon = AccordionHeaderIcon;
AccordionHeader.Title = AccordionHeaderTitle;
AccordionHeader.Description = AccordionHeaderDescription;
process.env.NODE_ENV !== "production" ? AccordionHeader.propTypes = _extends({
  title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  description: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  left_component: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  element: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  heading: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  heading_level: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  icon_size: _propTypes.default.string,
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func])
}) : void 0;