"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.fill.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getViews = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _addMonths = _interopRequireDefault(require("date-fns/addMonths"));

var _subMonths = _interopRequireDefault(require("date-fns/subMonths"));

var _DatePickerCalendar = _interopRequireDefault(require("./DatePickerCalendar"));

var _DatePickerContext = _interopRequireDefault(require("./DatePickerContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DatePickerRange = function (_React$PureComponent) {
  _inherits(DatePickerRange, _React$PureComponent);

  var _super = _createSuper(DatePickerRange);

  function DatePickerRange() {
    var _this;

    _classCallCheck(this, DatePickerRange);

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(_args));

    _this.onSelectHandler = function (args) {
      _this.context.callOnChangeHandler(args);

      _this.props.onChange && _this.props.onChange(_extends({
        hidePicker: !_this.props.isRange
      }, args));
    };

    _this.callOnNav = function () {
      _this.props.onNav && _this.props.onNav(_this.context.views);
    };

    _this.setNavState = function (state) {
      _this.context.updateState(state);
    };

    _this.onNext = function (_ref) {
      var nr = _ref.nr;

      var views = _this.context.views.map(function (c) {
        if (c.nr === nr) {
          var month = (0, _addMonths.default)(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr === 0 ? 'start' : 'end', "Month"), month));

          return _extends({}, c, {
            month: month
          });
        }

        if (_this.props.isLink && c.nr === 1) {
          var _month = (0, _addMonths.default)(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr !== 0 ? 'start' : 'end', "Month"), _month));

          return _extends({}, c, {
            month: _month
          });
        }

        return c;
      });

      _this.context.setViews(views, _this.callOnNav);
    };

    _this.onPrev = function (_ref2) {
      var nr = _ref2.nr;

      var views = _this.context.views.map(function (c) {
        if (c.nr === nr) {
          var month = (0, _subMonths.default)(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr === 0 ? 'start' : 'end', "Month"), month));

          return _extends({}, c, {
            month: month
          });
        }

        if (_this.props.isLink && c.nr === 1) {
          var _month2 = (0, _subMonths.default)(c.month, 1);

          _this.setNavState(_defineProperty({
            nr: nr
          }, "".concat(nr !== 0 ? 'start' : 'end', "Month"), _month2));

          return _extends({}, c, {
            month: _month2
          });
        }

        return c;
      });

      _this.context.setViews(views, _this.callOnNav);
    };

    _this.onHover = function (hoverDate) {
      _this.context.updateState({
        hoverDate: hoverDate
      });
    };

    return _this;
  }

  _createClass(DatePickerRange, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          id = _this$props.id,
          props = _objectWithoutProperties(_this$props, ["id"]);

      return _react.default.createElement("div", {
        className: "dnb-date-picker__views"
      }, this.context.views.map(function (calendar, i) {
        return _react.default.createElement(_DatePickerCalendar.default, _extends({
          key: calendar.nr,
          id: "".concat(id, "-").concat(i, "-")
        }, props, calendar, {
          onSelect: _this2.onSelectHandler,
          onHover: _this2.onHover,
          onPrev: _this2.onPrev,
          onNext: _this2.onNext
        }));
      }));
    }
  }]);

  return DatePickerRange;
}(_react.default.PureComponent);

exports.default = DatePickerRange;
DatePickerRange.contextType = _DatePickerContext.default;
DatePickerRange.defaultProps = {
  id: null,
  isRange: null,
  isLink: null,
  isSync: null,
  onlyMonth: null,
  hideNav: null,
  views: null,
  onChange: null,
  onNav: null
};
process.env.NODE_ENV !== "production" ? DatePickerRange.propTypes = {
  id: _propTypes.default.string,
  isRange: _propTypes.default.bool,
  isLink: _propTypes.default.bool,
  isSync: _propTypes.default.bool,
  onlyMonth: _propTypes.default.bool,
  hideNav: _propTypes.default.bool,
  views: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.arrayOf(_propTypes.default.object)]),
  onChange: _propTypes.default.func,
  onNav: _propTypes.default.func
} : void 0;

var getViews = function getViews(state, isRange) {
  return (Array.isArray(state.views) ? state.views : Array(isRange ? 2 : state.views).fill(1)).map(function (view, nr) {
    return _extends({}, view, {
      month: getMonthView(state, nr),
      nr: nr
    });
  });
};

exports.getViews = getViews;

var getMonthView = function getMonthView(state, nr) {
  if ((state.startMonth || state.startDate) && nr === 0) {
    return state.startMonth || state.startDate;
  }

  if ((state.endMonth || state.endDate) && nr === 1) {
    return state.endMonth || state.endDate;
  }

  return (0, _addMonths.default)(getFallbackMonth(state), nr);
};

var getFallbackMonth = function getFallbackMonth(state) {
  return state.startMonth || state.startDate || new Date();
};