"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Accordion", {
  enumerable: true,
  get: function get() {
    return _Accordion.default;
  }
});
Object.defineProperty(exports, "Autocomplete", {
  enumerable: true,
  get: function get() {
    return _Autocomplete.default;
  }
});
Object.defineProperty(exports, "Button", {
  enumerable: true,
  get: function get() {
    return _Button.default;
  }
});
Object.defineProperty(exports, "Checkbox", {
  enumerable: true,
  get: function get() {
    return _Checkbox.default;
  }
});
Object.defineProperty(exports, "DatePicker", {
  enumerable: true,
  get: function get() {
    return _DatePicker.default;
  }
});
Object.defineProperty(exports, "Dropdown", {
  enumerable: true,
  get: function get() {
    return _Dropdown.default;
  }
});
Object.defineProperty(exports, "FormLabel", {
  enumerable: true,
  get: function get() {
    return _FormLabel.default;
  }
});
Object.defineProperty(exports, "FormRow", {
  enumerable: true,
  get: function get() {
    return _FormRow.default;
  }
});
Object.defineProperty(exports, "FormSet", {
  enumerable: true,
  get: function get() {
    return _FormSet.default;
  }
});
Object.defineProperty(exports, "FormStatus", {
  enumerable: true,
  get: function get() {
    return _FormStatus.default;
  }
});
Object.defineProperty(exports, "GlobalError", {
  enumerable: true,
  get: function get() {
    return _GlobalError.default;
  }
});
Object.defineProperty(exports, "GlobalStatus", {
  enumerable: true,
  get: function get() {
    return _GlobalStatus.default;
  }
});
Object.defineProperty(exports, "Heading", {
  enumerable: true,
  get: function get() {
    return _Heading.default;
  }
});
Object.defineProperty(exports, "HelpButton", {
  enumerable: true,
  get: function get() {
    return _HelpButton.default;
  }
});
Object.defineProperty(exports, "Icon", {
  enumerable: true,
  get: function get() {
    return _Icon.default;
  }
});
Object.defineProperty(exports, "IconPrimary", {
  enumerable: true,
  get: function get() {
    return _IconPrimary.default;
  }
});
Object.defineProperty(exports, "Input", {
  enumerable: true,
  get: function get() {
    return _Input.default;
  }
});
Object.defineProperty(exports, "InputMasked", {
  enumerable: true,
  get: function get() {
    return _InputMasked.default;
  }
});
Object.defineProperty(exports, "LineTitle", {
  enumerable: true,
  get: function get() {
    return _LineTitle.default;
  }
});
Object.defineProperty(exports, "Logo", {
  enumerable: true,
  get: function get() {
    return _Logo.default;
  }
});
Object.defineProperty(exports, "Modal", {
  enumerable: true,
  get: function get() {
    return _Modal.default;
  }
});
Object.defineProperty(exports, "Notification", {
  enumerable: true,
  get: function get() {
    return _Notification.default;
  }
});
Object.defineProperty(exports, "Number", {
  enumerable: true,
  get: function get() {
    return _Number.default;
  }
});
Object.defineProperty(exports, "Pagination", {
  enumerable: true,
  get: function get() {
    return _Pagination.default;
  }
});
Object.defineProperty(exports, "ProgressIndicator", {
  enumerable: true,
  get: function get() {
    return _ProgressIndicator.default;
  }
});
Object.defineProperty(exports, "Radio", {
  enumerable: true,
  get: function get() {
    return _Radio.default;
  }
});
Object.defineProperty(exports, "Section", {
  enumerable: true,
  get: function get() {
    return _Section.default;
  }
});
Object.defineProperty(exports, "Skeleton", {
  enumerable: true,
  get: function get() {
    return _Skeleton.default;
  }
});
Object.defineProperty(exports, "Slider", {
  enumerable: true,
  get: function get() {
    return _Slider.default;
  }
});
Object.defineProperty(exports, "Space", {
  enumerable: true,
  get: function get() {
    return _Space.default;
  }
});
Object.defineProperty(exports, "StepIndicator", {
  enumerable: true,
  get: function get() {
    return _StepIndicator.default;
  }
});
Object.defineProperty(exports, "Switch", {
  enumerable: true,
  get: function get() {
    return _Switch.default;
  }
});
Object.defineProperty(exports, "Tabs", {
  enumerable: true,
  get: function get() {
    return _Tabs.default;
  }
});
Object.defineProperty(exports, "Textarea", {
  enumerable: true,
  get: function get() {
    return _Textarea.default;
  }
});
Object.defineProperty(exports, "ToggleButton", {
  enumerable: true,
  get: function get() {
    return _ToggleButton.default;
  }
});
Object.defineProperty(exports, "Tooltip", {
  enumerable: true,
  get: function get() {
    return _Tooltip.default;
  }
});
exports.enableWebComponents = exports.getComponents = void 0;

var _componentHelper = require("../shared/component-helper");

var _Accordion = _interopRequireDefault(require("./accordion/Accordion"));

var _Autocomplete = _interopRequireDefault(require("./autocomplete/Autocomplete"));

var _Button = _interopRequireDefault(require("./button/Button"));

var _Checkbox = _interopRequireDefault(require("./checkbox/Checkbox"));

var _DatePicker = _interopRequireDefault(require("./date-picker/DatePicker"));

var _Dropdown = _interopRequireDefault(require("./dropdown/Dropdown"));

var _FormLabel = _interopRequireDefault(require("./form-label/FormLabel"));

var _FormRow = _interopRequireDefault(require("./form-row/FormRow"));

var _FormSet = _interopRequireDefault(require("./form-set/FormSet"));

var _FormStatus = _interopRequireDefault(require("./form-status/FormStatus"));

var _GlobalError = _interopRequireDefault(require("./global-error/GlobalError"));

var _GlobalStatus = _interopRequireDefault(require("./global-status/GlobalStatus"));

var _Heading = _interopRequireDefault(require("./heading/Heading"));

var _HelpButton = _interopRequireDefault(require("./help-button/HelpButton"));

var _Icon = _interopRequireDefault(require("./icon/Icon"));

var _IconPrimary = _interopRequireDefault(require("./icon-primary/IconPrimary"));

var _Input = _interopRequireDefault(require("./input/Input"));

var _InputMasked = _interopRequireDefault(require("./input-masked/InputMasked"));

var _LineTitle = _interopRequireDefault(require("./line-title/LineTitle"));

var _Logo = _interopRequireDefault(require("./logo/Logo"));

var _Modal = _interopRequireDefault(require("./modal/Modal"));

var _Notification = _interopRequireDefault(require("./notification/Notification"));

var _Number = _interopRequireDefault(require("./number/Number"));

var _Pagination = _interopRequireDefault(require("./pagination/Pagination"));

var _ProgressIndicator = _interopRequireDefault(require("./progress-indicator/ProgressIndicator"));

var _Radio = _interopRequireDefault(require("./radio/Radio"));

var _Section = _interopRequireDefault(require("./section/Section"));

var _Skeleton = _interopRequireDefault(require("./skeleton/Skeleton"));

var _Slider = _interopRequireDefault(require("./slider/Slider"));

var _Space = _interopRequireDefault(require("./space/Space"));

var _StepIndicator = _interopRequireDefault(require("./step-indicator/StepIndicator"));

var _Switch = _interopRequireDefault(require("./switch/Switch"));

var _Tabs = _interopRequireDefault(require("./tabs/Tabs"));

var _Textarea = _interopRequireDefault(require("./textarea/Textarea"));

var _ToggleButton = _interopRequireDefault(require("./toggle-button/ToggleButton"));

var _Tooltip = _interopRequireDefault(require("./tooltip/Tooltip"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getComponents = function getComponents() {
  return {
    Accordion: _Accordion.default,
    Autocomplete: _Autocomplete.default,
    Button: _Button.default,
    Checkbox: _Checkbox.default,
    DatePicker: _DatePicker.default,
    Dropdown: _Dropdown.default,
    FormLabel: _FormLabel.default,
    FormRow: _FormRow.default,
    FormSet: _FormSet.default,
    FormStatus: _FormStatus.default,
    GlobalError: _GlobalError.default,
    GlobalStatus: _GlobalStatus.default,
    Heading: _Heading.default,
    HelpButton: _HelpButton.default,
    Icon: _Icon.default,
    IconPrimary: _IconPrimary.default,
    Input: _Input.default,
    InputMasked: _InputMasked.default,
    LineTitle: _LineTitle.default,
    Logo: _Logo.default,
    Modal: _Modal.default,
    Notification: _Notification.default,
    Number: _Number.default,
    Pagination: _Pagination.default,
    ProgressIndicator: _ProgressIndicator.default,
    Radio: _Radio.default,
    Section: _Section.default,
    Skeleton: _Skeleton.default,
    Slider: _Slider.default,
    Space: _Space.default,
    StepIndicator: _StepIndicator.default,
    Switch: _Switch.default,
    Tabs: _Tabs.default,
    Textarea: _Textarea.default,
    ToggleButton: _ToggleButton.default,
    Tooltip: _Tooltip.default
  };
};

exports.getComponents = getComponents;
var webComponentsAreEnabled = false;

var enableWebComponents = function enableWebComponents() {
  if (webComponentsAreEnabled) return false;
  webComponentsAreEnabled = true;
  var components = getComponents();

  for (var c in components) {
    if (components[c] && components[c].tagName) {
      (0, _componentHelper.registerElement)(components[c].tagName, components[c], components[c].defaultProps);
    }
  }
};

exports.enableWebComponents = enableWebComponents;