import * as React from 'react';

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface InnerProps extends React.HTMLProps<HTMLElement> {
  /**
   * Give the inner content wrapper a class name (maps to `dnb-modal__content__inner`).
   */
  className?: string;
}
declare const Inner: React.FC<InnerProps>;
export default Inner;
