"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.find-index.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/web.dom-collections.for-each.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfinityLoadButton = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _componentHelper = require("../../shared/component-helper");

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _PaginationHelpers = require("./PaginationHelpers");

var _PaginationContext = _interopRequireDefault(require("./PaginationContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var InfinityScroller = function (_React$PureComponent) {
  _inherits(InfinityScroller, _React$PureComponent);

  var _super = _createSuper(InfinityScroller);

  function InfinityScroller(_props, context) {
    var _this;

    _classCallCheck(this, InfinityScroller);

    _this = _super.call(this, _props);

    _this.startup = function () {
      var _this$context$paginat = _this.context.pagination,
          startupPage = _this$context$paginat.startupPage,
          startup_count = _this$context$paginat.startup_count;
      var startupCount = parseFloat(startup_count);

      for (var i = 0, newPageNo; i < startupCount; ++i) {
        newPageNo = startupPage + i;

        _this.getNewContent(newPageNo, {
          position: 'after',
          skipObserver: newPageNo < startupCount
        }, {
          isStartup: i === 0
        });
      }
    };

    _this.getNewContent = function (newPageNo) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
          _ref$isStartup = _ref.isStartup,
          isStartup = _ref$isStartup === void 0 ? false : _ref$isStartup;

      var _this$context$paginat2 = _this.context.pagination,
          pageCount = _this$context$paginat2.pageCount,
          endInfinity = _this$context$paginat2.endInfinity;

      if (newPageNo > pageCount) {
        return endInfinity();
      }

      var exists = _this.context.pagination.items.findIndex(function (obj) {
        return obj.pageNo === newPageNo;
      }) > -1;

      if (exists) {
        return;
      }

      var items = _this.context.pagination.prefillItems(newPageNo, props);

      _this.context.pagination.setItems(items, function () {
        return _this.callEventHandler(newPageNo, {
          isStartup: isStartup
        });
      });
    };

    _this.hideIndicator = (0, _componentHelper.isTrue)(context.pagination.hide_progress_indicator);
    _this.useLoadButton = (0, _componentHelper.isTrue)(context.pagination.use_load_button);
    _this.lastElement = _react.default.createRef();
    _this.callOnUnmount = [];
    return _this;
  }

  _createClass(InfinityScroller, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this._startupTimeout);
      clearTimeout(this._bufferTimeout);
      this.callOnUnmount.forEach(function (f) {
        return typeof f === 'function' && f();
      });
    }
  }, {
    key: "waitForReachedTime",
    value: function waitForReachedTime(fn) {
      this.callbackBuffer = this.callbackBuffer || [];

      for (var _len = arguments.length, props = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        props[_key - 1] = arguments[_key];
      }

      this.callbackBuffer.push({
        fn: fn,
        props: props
      });
      this.callBuffer();
    }
  }, {
    key: "callBuffer",
    value: function callBuffer() {
      var _this2 = this;

      var minTime = this.context.pagination.minTime;
      var diff = this._lastCall > 0 ? new Date().getTime() - this._lastCall : 0;
      var waitTime = diff < minTime ? minTime : 0;
      clearTimeout(this._bufferTimeout);
      this._bufferTimeout = setTimeout(function () {
        if (_this2.callbackBuffer.length > 0) {
          _this2._lastCall = new Date().getTime();

          var _this2$callbackBuffer = _this2.callbackBuffer.shift(),
              fn = _this2$callbackBuffer.fn,
              props = _this2$callbackBuffer.props;

          fn.apply(void 0, _toConsumableArray(props));

          _this2.callBuffer();
        }
      }, waitTime);
    }
  }, {
    key: "callEventHandler",
    value: function callEventHandler(pageNo) {
      var _this3 = this;

      var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref2$isStartup = _ref2.isStartup,
          isStartup = _ref2$isStartup === void 0 ? false : _ref2$isStartup,
          _ref2$callOnEnd = _ref2.callOnEnd,
          callOnEnd = _ref2$callOnEnd === void 0 ? false : _ref2$callOnEnd,
          _ref2$onDispatch = _ref2.onDispatch,
          onDispatch = _ref2$onDispatch === void 0 ? null : _ref2$onDispatch;

      this.waitForReachedTime(function (_ref3) {
        var pageNo = _ref3.pageNo,
            isStartup = _ref3.isStartup;
        var context = _this3.context.pagination;

        var createEvent = function createEvent(eventName) {
          var ret = (0, _componentHelper.dispatchCustomElementEvent)(context, eventName, _extends({
            page: pageNo,
            pageNo: pageNo
          }, context));

          if (typeof onDispatch === 'function') {
            onDispatch();
          }

          if (typeof ret === 'function') {
            _this3.callOnUnmount.push(ret);
          }
        };

        if (callOnEnd) {
          createEvent('on_end');
        } else {
          if (isStartup) {
            createEvent('on_startup');
          } else {
            createEvent('on_change');
          }

          createEvent('on_load');
        }
      }, {
        pageNo: pageNo,
        isStartup: isStartup
      });
    }
  }, {
    key: "handleInfinityMarker",
    value: function handleInfinityMarker() {
      var _this4 = this;

      var children = this.props.children;
      var _this$context$paginat3 = this.context.pagination,
          lowerPage = _this$context$paginat3.lowerPage,
          upperPage = _this$context$paginat3.upperPage,
          pageCount = _this$context$paginat3.pageCount,
          hasEndedInfinity = _this$context$paginat3.hasEndedInfinity,
          parallelLoadCount = _this$context$paginat3.parallelLoadCount,
          fallback_element = _this$context$paginat3.fallback_element,
          marker_element = _this$context$paginat3.marker_element,
          indicator_element = _this$context$paginat3.indicator_element;

      var Marker = function Marker() {
        return _react.default.createElement(InteractionMarker, {
          pageNo: upperPage,
          markerElement: marker_element || fallback_element,
          onVisible: function onVisible(pageNo) {
            var _loop = function _loop(i, _newPageNo) {
              _newPageNo = pageNo + 1 + i;

              _this4.context.pagination.onPageUpdate(function () {
                _this4.context.pagination.setState({
                  upperPage: _newPageNo,
                  skipObserver: i + 1 < parallelLoadCount
                });
              });

              _this4.callEventHandler(_newPageNo);

              newPageNo = _newPageNo;
            };

            for (var i = 0, newPageNo; i < parallelLoadCount; ++i) {
              _loop(i, newPageNo);
            }
          }
        });
      };

      var LoadButton = function LoadButton() {
        return _react.default.createElement(InfinityLoadButton, {
          icon: "arrow_up",
          element: fallback_element,
          pressed_element: _react.default.createElement(_PaginationHelpers.PaginationIndicator, {
            indicator_element: indicator_element || fallback_element
          }),
          on_click: function on_click() {
            var newPageNo = lowerPage - 1;

            _this4.context.pagination.onPageUpdate(function () {
              _this4.context.pagination.setState({
                lowerPage: newPageNo
              });
            });

            _this4.callEventHandler(newPageNo);
          }
        });
      };

      return _react.default.createElement(_react.default.Fragment, null, lowerPage > 1 && _react.default.createElement(LoadButton, null), children, !hasEndedInfinity && (typeof pageCount === 'undefined' || upperPage < pageCount) && _react.default.createElement(Marker, null), !hasEndedInfinity && !this.hideIndicator && (typeof pageCount === 'undefined' || upperPage < pageCount) && _react.default.createElement(_PaginationHelpers.PaginationIndicator, {
        indicator_element: indicator_element || fallback_element
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$context$paginat4 = this.context.pagination,
          items = _this$context$paginat4.items,
          pageCount = _this$context$paginat4.pageCount,
          startupPage = _this$context$paginat4.startupPage,
          hasEndedInfinity = _this$context$paginat4.hasEndedInfinity,
          parallelLoadCount = _this$context$paginat4.parallelLoadCount,
          placeMakerBeforeContent = _this$context$paginat4.placeMakerBeforeContent,
          page_element = _this$context$paginat4.page_element,
          fallback_element = _this$context$paginat4.fallback_element,
          marker_element = _this$context$paginat4.marker_element,
          indicator_element = _this$context$paginat4.indicator_element;

      if (this.context.pagination.useMarkerOnly) {
        return this.handleInfinityMarker();
      }

      if (!(items && items.length > 0)) {
        clearTimeout(this._startupTimeout);
        this._startupTimeout = setTimeout(this.startup, 1);
        return null;
      }

      var Element = (0, _PaginationHelpers.preparePageElement)(page_element || _react.default.Fragment);
      return items.map(function (_ref4, idx) {
        var pageNo = _ref4.pageNo,
            hasContent = _ref4.hasContent,
            content = _ref4.content,
            ref = _ref4.ref,
            skipObserver = _ref4.skipObserver,
            ScrollElement = _ref4.ScrollElement;
        var isLastItem = idx === items.length - 1;
        var Elem = hasContent && ScrollElement || Element;

        var marker = hasContent && !_this5.useLoadButton && !skipObserver && !hasEndedInfinity && (typeof pageCount === 'undefined' || pageNo <= pageCount) && _react.default.createElement(InteractionMarker, {
          pageNo: pageNo,
          markerElement: marker_element || fallback_element,
          onVisible: function onVisible(pageNo) {
            for (var i = 0, _newPageNo2; i < parallelLoadCount; ++i) {
              _newPageNo2 = pageNo + 1 + i;

              _this5.getNewContent(_newPageNo2, {
                position: 'after',
                skipObserver: i + 1 < parallelLoadCount
              });
            }
          }
        });

        return _react.default.createElement(Elem, {
          key: pageNo,
          ref: ref
        }, hasContent && startupPage > 1 && pageNo > 1 && pageNo <= startupPage && _react.default.createElement(InfinityLoadButton, {
          element: fallback_element,
          icon: "arrow_up",
          on_click: function on_click(event) {
            return _this5.getNewContent(pageNo - 1, {
              position: 'before',
              skipObserver: true,
              event: event
            });
          }
        }), placeMakerBeforeContent && marker, content, !placeMakerBeforeContent && marker, (parallelLoadCount > 1 && idx > 0 ? isLastItem : true) && !hasContent && !_this5.hideIndicator && _react.default.createElement(_PaginationHelpers.PaginationIndicator, {
          indicator_element: indicator_element || fallback_element
        }), hasContent && _this5.useLoadButton && isLastItem && (typeof pageCount === 'undefined' || pageNo < pageCount) && _react.default.createElement(InfinityLoadButton, {
          element: fallback_element,
          icon: "arrow_down",
          on_click: function on_click(event) {
            return _this5.getNewContent(pageNo + 1, {
              position: 'after',
              skipObserver: true,
              ScrollElement: function ScrollElement(props) {
                return hasContent && _react.default.createElement(ScrollToElement, _extends({
                  page_element: page_element
                }, props));
              },
              event: event
            });
          }
        }));
      });
    }
  }]);

  return InfinityScroller;
}(_react.default.PureComponent);

exports.default = InfinityScroller;
InfinityScroller.contextType = _PaginationContext.default;
InfinityScroller.defaultProps = {
  children: null
};
process.env.NODE_ENV !== "production" ? InfinityScroller.propTypes = {
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func])
} : void 0;

var InteractionMarker = function (_React$PureComponent2) {
  _inherits(InteractionMarker, _React$PureComponent2);

  var _super2 = _createSuper(InteractionMarker);

  function InteractionMarker(props) {
    var _this6;

    _classCallCheck(this, InteractionMarker);

    _this6 = _super2.call(this, props);
    _this6.state = {
      isConnected: false
    };

    _this6.callReady = function () {
      var _this6$intersectionOb;

      (_this6$intersectionOb = _this6.intersectionObserver) === null || _this6$intersectionOb === void 0 ? void 0 : _this6$intersectionOb.disconnect();
      _this6.intersectionObserver = null;
      clearTimeout(_this6._readyTimeout);
      _this6._readyTimeout = setTimeout(function () {
        if (_this6._isMounted) {
          _this6.setState({
            isConnected: true
          });
        }

        _this6.props.onVisible(_this6.props.pageNo);
      }, 1);
    };

    if (typeof props.markerElement === 'function') {
      (0, _componentHelper.warn)('Pagination: Please use a string or React element e.g. marker_element="tr"');
    }

    _this6._ref = _react.default.createRef();

    if (typeof IntersectionObserver !== 'undefined') {
      _this6.intersectionObserver = new IntersectionObserver(function (entries) {
        var _entries = _slicedToArray(entries, 1),
            isIntersecting = _entries[0].isIntersecting;

        if (isIntersecting) {
          _this6.callReady();
        }
      });
    } else {
      (0, _componentHelper.warn)('Pagination is missing IntersectionObserver supported!');
    }

    return _this6;
  }

  _createClass(InteractionMarker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this._ref.current) {
        var _this$intersectionObs;

        this._isMounted = true;
        (_this$intersectionObs = this.intersectionObserver) === null || _this$intersectionObs === void 0 ? void 0 : _this$intersectionObs.observe(this._ref.current);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$intersectionObs2;

      this._isMounted = false;
      clearTimeout(this._readyTimeout);
      (_this$intersectionObs2 = this.intersectionObserver) === null || _this$intersectionObs2 === void 0 ? void 0 : _this$intersectionObs2.disconnect();
    }
  }, {
    key: "render",
    value: function render() {
      var markerElement = this.props.markerElement;

      if (this.state.isConnected || !this.intersectionObserver) {
        return null;
      }

      var Element = markerElement && (0, _PaginationHelpers.isTrElement)(markerElement) ? 'tr' : 'div';
      var ElementChild = markerElement && (0, _PaginationHelpers.isTrElement)(markerElement) ? 'td' : 'div';
      return _react.default.createElement(Element, {
        className: "dnb-pagination__marker dnb-table--ignore"
      }, _react.default.createElement(ElementChild, {
        className: "dnb-pagination__marker__inner",
        ref: this._ref
      }));
    }
  }]);

  return InteractionMarker;
}(_react.default.PureComponent);

InteractionMarker.defaultProps = {
  markerElement: null
};
process.env.NODE_ENV !== "production" ? InteractionMarker.propTypes = {
  pageNo: _propTypes.default.number.isRequired,
  onVisible: _propTypes.default.func.isRequired,
  markerElement: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string])
} : void 0;

var InfinityLoadButton = function (_React$PureComponent3) {
  _inherits(InfinityLoadButton, _React$PureComponent3);

  var _super3 = _createSuper(InfinityLoadButton);

  function InfinityLoadButton() {
    var _this7;

    _classCallCheck(this, InfinityLoadButton);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this7 = _super3.call.apply(_super3, [this].concat(args));
    _this7.state = {
      isPressed: false
    };

    _this7.onClickHandler = function (e) {
      _this7.setState({
        isPressed: true
      });

      if (typeof _this7.props.on_click === 'function') {
        _this7.props.on_click(e);
      }
    };

    return _this7;
  }

  _createClass(InfinityLoadButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          element = _this$props.element,
          icon = _this$props.icon;
      var Element = element;
      var ElementChild = (0, _PaginationHelpers.isTrElement)(Element) ? 'td' : 'div';
      return this.state.isPressed ? this.props.pressed_element : _react.default.createElement(Element, null, _react.default.createElement(ElementChild, {
        className: "dnb-pagination__loadbar"
      }, _react.default.createElement(_Button.default, {
        size: "medium",
        icon: icon,
        icon_position: "left",
        text: this.context.translation.Pagination.load_button_text,
        variant: "secondary",
        on_click: this.onClickHandler
      })));
    }
  }]);

  return InfinityLoadButton;
}(_react.default.PureComponent);

exports.InfinityLoadButton = InfinityLoadButton;
InfinityLoadButton.contextType = _Context.default;
InfinityLoadButton.defaultProps = {
  element: 'div',
  pressed_element: null,
  icon: 'arrow_down'
};
process.env.NODE_ENV !== "production" ? InfinityLoadButton.propTypes = {
  element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string]),
  pressed_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func]),
  icon: _propTypes.default.string.isRequired,
  on_click: _propTypes.default.func.isRequired
} : void 0;

var ScrollToElement = function (_React$PureComponent4) {
  _inherits(ScrollToElement, _React$PureComponent4);

  var _super4 = _createSuper(ScrollToElement);

  function ScrollToElement() {
    _classCallCheck(this, ScrollToElement);

    return _super4.apply(this, arguments);
  }

  _createClass(ScrollToElement, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var elem = _reactDom.default.findDOMNode(this);

      this.scrollToPage(elem);
    }
  }, {
    key: "scrollToPage",
    value: function scrollToPage(element) {
      if (element && typeof element.scrollIntoView === 'function') {
        element.scrollIntoView({
          block: 'nearest',
          behavior: 'smooth'
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          page_element = _this$props2.page_element,
          props = _objectWithoutProperties(_this$props2, ["page_element"]);

      var Element = (0, _PaginationHelpers.preparePageElement)(page_element || _react.default.Fragment);
      return _react.default.createElement(Element, props);
    }
  }]);

  return ScrollToElement;
}(_react.default.PureComponent);

ScrollToElement.defaultProps = {
  page_element: null
};
process.env.NODE_ENV !== "production" ? ScrollToElement.propTypes = {
  page_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.node, _propTypes.default.func, _propTypes.default.string])
} : void 0;