"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _componentHelper = require("../../shared/component-helper");

var _helpers = require("../../shared/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var StepItem = function (_React$PureComponent) {
  _inherits(StepItem, _React$PureComponent);

  var _super = _createSuper(StepItem);

  function StepItem(props) {
    var _this;

    _classCallCheck(this, StepItem);

    _this = _super.call(this, props);

    _this.onClickHandler = function (_ref) {
      var event = _ref.event,
          item = _ref.item,
          currentItem = _ref.currentItem;
      var _this$props = _this.props,
          use_navigation = _this$props.use_navigation,
          on_click = _this$props.on_click,
          setActimeItem = _this$props.setActimeItem;
      var params = {
        event: event,
        item: item,
        currentItem: currentItem
      };

      if ((0, _componentHelper.isTrue)(use_navigation) && typeof setActimeItem === 'function') {
        setActimeItem(currentItem);
      }

      var res = (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_click', params);

      if (typeof on_click === 'function' && res === false) {
        return;
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', params);

      if (_this._ref.current) {
        _this._ref.current.blur();
      }
    };

    _this._ref = _react.default.createRef();
    return _this;
  }

  _createClass(StepItem, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          activeItem = _this$props2.activeItem,
          currentItem = _this$props2.currentItem,
          countSteps = _this$props2.countSteps,
          is_active = _this$props2.is_active,
          is_current = _this$props2.is_current,
          _url = _this$props2.url,
          url_future = _this$props2.url_future,
          url_passed = _this$props2.url_passed,
          hide_numbers = _this$props2.hide_numbers,
          title = _this$props2.title,
          step_title = _this$props2.step_title,
          use_navigation = _this$props2.use_navigation,
          on_item_render = _this$props2.on_item_render,
          on_render = _this$props2.on_render,
          on_click = _this$props2.on_click,
          on_change = _this$props2.on_change,
          setActimeItem = _this$props2.setActimeItem,
          hasReached = _this$props2.hasReached,
          rest = _objectWithoutProperties(_this$props2, ["activeItem", "currentItem", "countSteps", "is_active", "is_current", "url", "url_future", "url_passed", "hide_numbers", "title", "step_title", "use_navigation", "on_item_render", "on_render", "on_click", "on_change", "setActimeItem", "hasReached"]);

      var hasPassedAndIsCurrent = (0, _componentHelper.isTrue)(is_active);
      var url = _url;

      if (_url) {
        if (currentItem > activeItem) {
          url = url_future;
          hasPassedAndIsCurrent = true;
        }

        if (url_passed && currentItem < activeItem) {
          url = url_passed;
          hasPassedAndIsCurrent = true;
        }
      }

      if (currentItem <= activeItem) {
        hasPassedAndIsCurrent = true;
      }

      if (hasReached.includes(currentItem)) {
        hasPassedAndIsCurrent = true;
      }

      var interactiveParams = _extends({}, rest);

      if (!hasPassedAndIsCurrent && currentItem > activeItem && !(0, _componentHelper.isTrue)(is_active)) {
        interactiveParams['disabled'] = true;
        interactiveParams['aria-disabled'] = true;
      }

      interactiveParams.className = "dnb-anchor dnb-step-indicator__item-content dnb-step-indicator__item-content--link" + (interactiveParams['disabled'] ? " dnb-anchor--no-style" : "");
      var aria = step_title.replace('%step', currentItem + 1).replace('%count', countSteps);

      var StepItemWrapper = function StepItemWrapper(props) {
        return _react.default.createElement(_react.default.Fragment, null, !(0, _componentHelper.isTrue)(hide_numbers) && _react.default.createElement("span", _extends({
          className: "dnb-step-indicator__item-content--number",
          "aria-label": aria
        }, props), "".concat(currentItem + 1, ". ")), _react.default.createElement("span", _extends({
          className: "dnb-step-indicator__item-content--text"
        }, props), title));
      };

      var itemComponent = _react.default.createElement(StepItemWrapper, null);

      var props = {
        StepItem: StepItemWrapper,
        itemComponent: itemComponent,
        params: rest,
        props: this.props
      };

      if (typeof on_render === 'function') {
        itemComponent = on_render(props);
      } else if (typeof on_item_render === 'function') {
        itemComponent = on_item_render(props);
      }

      var child = null;

      if ((0, _componentHelper.isTrue)(use_navigation)) {
        child = _react.default.createElement("button", _extends({
          type: "button",
          onClick: function onClick(event) {
            return _this2.onClickHandler({
              event: event,
              item: _this2.props,
              currentItem: currentItem
            });
          }
        }, interactiveParams, {
          ref: this._ref
        }), itemComponent);
      } else if (url) {
        child = _react.default.createElement("a", _extends({
          href: url,
          onClick: function onClick(event) {
            return _this2.onClickHandler({
              event: event,
              item: _this2.props,
              currentItem: currentItem
            });
          }
        }, interactiveParams), itemComponent);
      } else {
        var contentParams = {};

        if (_helpers.IS_MAC) {
          contentParams.role = 'text';
        }

        child = _react.default.createElement("span", _extends({
          className: "dnb-step-indicator__item-content dnb-step-indicator__item-content--static"
        }, contentParams), itemComponent);
      }

      var itemParams = {};

      if (currentItem === activeItem || (0, _componentHelper.isTrue)(is_current)) {
        itemParams['aria-current'] = 'step';
      }

      return _react.default.createElement("li", _extends({
        className: (0, _classnames.default)('dnb-step-indicator__item', (currentItem === activeItem || (0, _componentHelper.isTrue)(is_current)) && 'dnb-step-indicator--active', currentItem < activeItem && 'dnb-step-indicator--visited')
      }, itemParams), child);
    }
  }]);

  return StepItem;
}(_react.default.PureComponent);

exports.default = StepItem;
StepItem.defaultProps = {
  step_title: '%step',
  on_item_render: null,
  on_render: null,
  on_click: null,
  on_change: null,
  setActimeItem: null,
  hasReached: [],
  countSteps: null,
  hide_numbers: false,
  use_navigation: false,
  is_active: null,
  is_current: null,
  url: null,
  url_future: null,
  url_passed: null,
  activeItem: null
};
process.env.NODE_ENV !== "production" ? StepItem.propTypes = {
  title: _propTypes.default.string.isRequired,
  step_title: _propTypes.default.string,
  activeItem: _propTypes.default.number,
  currentItem: _propTypes.default.number.isRequired,
  hide_numbers: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  use_navigation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  on_item_render: _propTypes.default.func,
  on_render: _propTypes.default.func,
  on_click: _propTypes.default.func,
  on_change: _propTypes.default.func,
  setActimeItem: _propTypes.default.func,
  hasReached: _propTypes.default.array,
  countSteps: _propTypes.default.number,
  is_active: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  is_current: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  url: _propTypes.default.string,
  url_future: _propTypes.default.string,
  url_passed: _propTypes.default.string
} : void 0;