"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.function.name.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../../shared/component-helper");

var _AlignmentHelper = _interopRequireDefault(require("../../shared/AlignmentHelper"));

var _SpacingHelper = require("../space/SpacingHelper");

var _Radio = _interopRequireDefault(require("../radio/Radio"));

var _Checkbox = _interopRequireDefault(require("../checkbox/Checkbox"));

var _Button = _interopRequireDefault(require("../button/Button"));

var _FormLabel = _interopRequireDefault(require("../form-label/FormLabel"));

var _FormStatus = _interopRequireDefault(require("../form-status/FormStatus"));

var _ToggleButtonGroup = _interopRequireDefault(require("./ToggleButtonGroup"));

var _ToggleButtonGroupContext = _interopRequireDefault(require("./ToggleButtonGroupContext"));

var _Context = _interopRequireDefault(require("../../shared/Context"));

var _Suffix = _interopRequireDefault(require("../../shared/helpers/Suffix"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref3 = _react.default.createElement(_AlignmentHelper.default, null);

var ToggleButton = function (_React$PureComponent) {
  _inherits(ToggleButton, _React$PureComponent);

  var _super = _createSuper(ToggleButton);

  function ToggleButton(props, context) {
    var _this;

    _classCallCheck(this, ToggleButton);

    _this = _super.call(this, props);

    _this.onKeyDownHandler = function (event) {
      switch ((0, _keycode.default)(event)) {
        case 'enter':
          _this.onClickHandler(event);

          break;
      }
    };

    _this.onKeyUpHandler = function (event) {
      switch ((0, _keycode.default)(event)) {
        case 'enter':
          _this.onClickHandler(event);

          break;
      }
    };

    _this.onClickHandler = function (_ref) {
      var event = _ref.event;

      if ((0, _componentHelper.isTrue)(_this.props.readOnly)) {
        return event.preventDefault();
      }

      event.persist();

      if (!(0, _componentHelper.isTrue)(_this.context.multiselect) && _this.props.value === _this.context.value) {
        return;
      }

      var checked = !_this.state.checked;

      _this.setState({
        checked: checked,
        _listenForPropChanges: false
      });

      _this.callOnChange({
        checked: checked,
        event: event
      });

      if (_this._refButton.current && checked) {
        try {
          _this._refButton.current._ref.current.focus();
        } catch (e) {
          (0, _componentHelper.warn)(e);
        }
      }
    };

    _this.callOnChange = function (_ref2) {
      var checked = _ref2.checked,
          event = _ref2.event;
      var value = _this.props.value;

      if (_this.context.onChange) {
        _this.context.onChange({
          value: value,
          event: event
        });
      }

      (0, _componentHelper.dispatchCustomElementEvent)(_assertThisInitialized(_this), 'on_change', {
        checked: checked,
        value: value,
        event: event
      });
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this._refButton = _react.default.createRef();
    _this.state = {
      _listenForPropChanges: true
    };

    if (context.name && typeof props.value !== 'undefined') {
      if (typeof context.value !== 'undefined') {
        _this.state.checked = context.value === props.value;
        _this.state._listenForPropChanges = false;
      } else if (context.values && Array.isArray(context.values)) {
        _this.state.checked = context.values.includes(props.value);
        _this.state._listenForPropChanges = false;
      } else if (ToggleButton.parseChecked(props.checked)) {
        if (context.setContext) {
          if (context.multiselect) {
            context.setContext(function (tmp) {
              return {
                values: tmp && Array.isArray(tmp.values) ? [].concat(_toConsumableArray(tmp.values), [props.value]) : [props.value]
              };
            });
          } else {
            context.setContext({
              value: props.value
            });
          }
        }
      }
    }

    return _this;
  }

  _createClass(ToggleButton, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_Context.default.Consumer, null, function (context) {
        var _componentParams;

        var props = (0, _componentHelper.extendPropsWithContext)(_this2.props, ToggleButton.defaultProps, _this2.context, context.translation.ToggleButton, context.FormRow, context.ToggleButton);

        var status = props.status,
            status_state = props.status_state,
            status_animation = props.status_animation,
            global_status_id = props.global_status_id,
            suffix = props.suffix,
            label = props.label,
            label_direction = props.label_direction,
            label_sr_only = props.label_sr_only,
            text = props.text,
            title = props.title,
            readOnly = props.readOnly,
            className = props.className,
            _className = props.class,
            disabled = props.disabled,
            skeleton = props.skeleton,
            variant = props.variant,
            left_component = props.left_component,
            icon = props.icon,
            icon_size = props.icon_size,
            icon_position = props.icon_position,
            propValue = props.value,
            _id = props.id,
            _checked = props.checked,
            attributes = props.attributes,
            children = props.children,
            on_change = props.on_change,
            on_state_update = props.on_state_update,
            custom_method = props.custom_method,
            custom_element = props.custom_element,
            rest = _objectWithoutProperties(props, ["status", "status_state", "status_animation", "global_status_id", "suffix", "label", "label_direction", "label_sr_only", "text", "title", "readOnly", "className", "class", "disabled", "skeleton", "variant", "left_component", "icon", "icon_size", "icon_position", "value", "id", "checked", "attributes", "children", "on_change", "on_state_update", "custom_method", "custom_element"]);

        var checked = _this2.state.checked;

        if (!(0, _componentHelper.isTrue)(_this2.context.multiselect) && typeof _this2.context.value !== 'undefined') {
          var contextValue = _this2.context.value;

          if (typeof propValue === 'string' || typeof propValue === 'number') {
            checked = propValue === contextValue;
          } else if (typeof JSON !== 'undefined') {
            checked = JSON.stringify(propValue) === JSON.stringify(contextValue);
          }
        }

        var id = _this2._id;
        var showStatus = (0, _componentHelper.getStatusState)(status);
        var mainParams = {
          className: (0, _classnames.default)('dnb-toggle-button', (0, _SpacingHelper.createSpacingClasses)(props), className, _className, status && "dnb-toggle-button__status--".concat(status_state), checked && "dnb-toggle-button--checked", label_direction && "dnb-toggle-button--".concat(label_direction))
        };
        (0, _componentHelper.validateDOMAttributes)(_this2.props, rest);

        var buttonParams = _extends(_defineProperty({
          id: id,
          disabled: disabled,
          skeleton: skeleton,
          text: text || children,
          title: title,
          icon: icon,
          icon_size: icon_size,
          icon_position: icon_position
        }, 'aria-pressed', String(checked)), rest);

        var componentParams = (_componentParams = {
          checked: checked,
          disabled: disabled
        }, _defineProperty(_componentParams, 'aria-hidden', true), _defineProperty(_componentParams, "tabIndex", '-1'), _componentParams);

        if (status) {
          if (status_state === 'info') {
            componentParams.status_state = 'info';
          } else {
            componentParams.status = 'error';
          }
        }

        if (showStatus || suffix) {
          buttonParams['aria-describedby'] = (0, _componentHelper.combineDescribedBy)(buttonParams, showStatus ? id + '-status' : null, suffix ? id + '-suffix' : null);
        }

        if (readOnly) {
          buttonParams['aria-readonly'] = buttonParams.readOnly = true;
        }

        var leftComponent = null;

        switch (variant) {
          case 'radio':
            leftComponent = _react.default.createElement(_Radio.default, _extends({
              id: "".concat(id, "-radio")
            }, componentParams));
            break;

          case 'checkbox':
            leftComponent = _react.default.createElement(_Checkbox.default, _extends({
              id: "".concat(id, "-checkbox")
            }, componentParams));
            break;

          case 'default':
          default:
            leftComponent = left_component;
            break;
        }

        return _react.default.createElement("span", mainParams, label && _react.default.createElement(_FormLabel.default, {
          id: id + '-label',
          for_id: id,
          text: label,
          disabled: disabled,
          skeleton: skeleton,
          label_direction: label_direction,
          sr_only: label_sr_only
        }), _react.default.createElement("span", {
          className: "dnb-toggle-button__inner"
        }, showStatus && _react.default.createElement(_FormStatus.default, {
          id: id + '-form-status',
          global_status_id: global_status_id,
          label: label,
          text_id: id + '-status',
          text: status,
          status: status_state,
          animation: status_animation,
          skeleton: skeleton
        }), _react.default.createElement("span", {
          className: "dnb-toggle-button__shell"
        }, _ref3, _react.default.createElement(_Button.default, _extends({
          variant: "secondary",
          className: "dnb-toggle-button__button"
        }, buttonParams, {
          ref: _this2._refButton,
          onClick: _this2.onClickHandler,
          onKeyDown: _this2.onKeyDownHandler,
          onKeyUp: _this2.onKeyUpHandler
        }), leftComponent && _react.default.createElement("span", {
          className: "dnb-toggle-button__component"
        }, leftComponent)), suffix && _react.default.createElement(_Suffix.default, {
          className: "dnb-toggle-button__suffix",
          id: id + '-suffix',
          context: props
        }, suffix))));
      });
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(ToggleButton.tagName, ToggleButton, ToggleButton.defaultProps);
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (state._listenForPropChanges) {
        if (props.checked !== state._checked) {
          state.checked = ToggleButton.parseChecked(props.checked);
        }
      }

      state._listenForPropChanges = true;

      if (state.checked !== state.__checked) {
        (0, _componentHelper.dispatchCustomElementEvent)({
          props: props
        }, 'on_state_update', {
          checked: state.checked
        });
      }

      state._checked = props.checked;
      state.__checked = state.checked;
      return state;
    }
  }]);

  return ToggleButton;
}(_react.default.PureComponent);

exports.default = ToggleButton;
ToggleButton.Group = _ToggleButtonGroup.default;
ToggleButton.tagName = 'dnb-toggle-button';
ToggleButton.contextType = _ToggleButtonGroupContext.default;
ToggleButton.defaultProps = {
  text: null,
  label: null,
  label_direction: null,
  label_sr_only: null,
  title: null,
  checked: undefined,
  variant: null,
  left_component: null,
  disabled: null,
  skeleton: null,
  id: null,
  status: null,
  status_state: 'error',
  status_animation: null,
  global_status_id: null,
  suffix: null,
  value: '',
  icon: null,
  icon_position: 'right',
  icon_size: null,
  attributes: null,
  readOnly: false,
  class: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_change: null,
  on_state_update: null
};

ToggleButton.parseChecked = function (state) {
  return /true|on/.test(String(state));
};

process.env.NODE_ENV !== "production" ? ToggleButton.propTypes = _extends({
  text: _propTypes.default.string,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  label_direction: _propTypes.default.oneOf(['horizontal', 'vertical']),
  label_sr_only: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  title: _propTypes.default.string,
  checked: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  variant: _propTypes.default.oneOf(['default', 'checkbox', 'radio']),
  left_component: _propTypes.default.node,
  disabled: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skeleton: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  id: _propTypes.default.string,
  status: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool, _propTypes.default.func, _propTypes.default.node]),
  status_state: _propTypes.default.string,
  status_animation: _propTypes.default.string,
  global_status_id: _propTypes.default.string,
  suffix: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node]),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.object, _propTypes.default.array]),
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.func]),
  icon_position: _propTypes.default.oneOf(['left', 'right']),
  icon_size: _propTypes.default.string,
  attributes: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  readOnly: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  class: _propTypes.default.string,
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;