"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Code = function Code(p) {
  return _react.default.createElement(_Element.default, _extends({
    is: "code"
  }, p));
};

Code.tagName = 'dnb-code';
process.env.NODE_ENV !== "production" ? Code.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  children: _propTypes.default.node
}) : void 0;
Code.defaultProps = {
  children: null
};
var _default = Code;
exports.default = _default;