"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _H = _interopRequireDefault(require("./H"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var H3 = function H3(props) {
  return _react.default.createElement(_H.default, _extends({
    is: "h3"
  }, props));
};

H3.tagName = 'dnb-h3';
process.env.NODE_ENV !== "production" ? H3.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  level: _propTypes.default.string,
  size: _propTypes.default.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  children: _propTypes.default.node
}) : void 0;
H3.defaultProps = {
  level: null,
  size: 'medium',
  children: null
};
var _default = H3;
exports.default = _default;