"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.object.get-prototype-of.js");

require("core-js/modules/es.string.includes.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.StickyHelper = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _componentHelper = require("../shared/component-helper");

var _Element = _interopRequireDefault(require("./Element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var _ref = _react.default.createElement("tr", {
  className: "dnb-table__sticky-helper"
}, _react.default.createElement("td", null));

var StickyHelper = function StickyHelper() {
  return _ref;
};

exports.StickyHelper = StickyHelper;

var Table = function (_React$PureComponent) {
  _inherits(Table, _React$PureComponent);

  var _super = _createSuper(Table);

  function Table(props) {
    var _this;

    _classCallCheck(this, Table);

    _this = _super.call(this, props);

    _this.init = function () {
      if (_this._isMounted && (0, _componentHelper.isTrue)(_this.props.sticky)) {
        _this.enableStickyHeader();

        if (_this.intersectionObserver && _this._ref.current) {
          try {
            var tableElem = _this._ref.current;
            var trElem = tableElem.querySelector('thead > tr:first-of-type');
            trElem.classList.add('sticky');

            var tdElem = tableElem.querySelector('tbody > tr.dnb-table__sticky-helper > td:first-of-type') || _this.getTdElement(tableElem);

            if (tdElem) {
              var _this$intersectionObs;

              (_this$intersectionObs = _this.intersectionObserver) === null || _this$intersectionObs === void 0 ? void 0 : _this$intersectionObs.observe(tdElem);
            }
          } catch (e) {
            _this.stickyWarning(e);
          }
        }
      }
    };

    _this._ref = _react.default.createRef();
    return _this;
  }

  _createClass(Table, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true;

      if (document.readyState === 'complete') {
        this.init();
      } else if (typeof window !== 'undefined') {
        window.addEventListener('load', this.init);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$intersectionObs2;

      this._isMounted = false;

      if (typeof window !== 'undefined') {
        window.removeEventListener('load', this.init);
      }

      (_this$intersectionObs2 = this.intersectionObserver) === null || _this$intersectionObs2 === void 0 ? void 0 : _this$intersectionObs2.disconnect();
    }
  }, {
    key: "getTdElement",
    value: function getTdElement(e) {
      return e.querySelector('tbody > tr:not(.dnb-table__sticky-helper):first-of-type > td:first-of-type, tbody > .dnb-table__tr:first-of-type > .dnb-table__td:first-of-type');
    }
  }, {
    key: "getThElement",
    value: function getThElement(e) {
      return e.querySelector('thead > tr:first-of-type > th:first-of-type, thead > .dnb-table__tr:first-of-type > .dnb-table__th:first-of-type');
    }
  }, {
    key: "enableStickyHeader",
    value: function enableStickyHeader() {
      var _this2 = this;

      if (!(typeof window !== 'undefined' && typeof IntersectionObserver !== 'undefined' && this._ref.current)) {
        return;
      }

      var tableElem = this._ref.current;
      var trElem;
      var thElem;
      var tdElem;
      var thHeight = 80;
      var tdHeight = 64;
      var offsetTop = 0;

      try {
        trElem = tableElem.querySelector('thead > tr:first-of-type, thead > .dnb-table__tr:first-of-type');
        thElem = this.getThElement(tableElem);
        tdElem = this.getTdElement(tableElem);
        offsetTop = parseFloat(this.props.sticky_offset) || offsetTop;

        if (offsetTop > 0) {
          if (typeof this.props.sticky_offset === 'string' && String(this.props.sticky_offset).includes('em')) {
            offsetTop = offsetTop * 16;
          }

          trElem.style.top = this.props.sticky_offset;
        }

        thHeight = thElem && parseFloat(window.getComputedStyle(thElem).height) || thHeight;
        tdHeight = tdElem && parseFloat(window.getComputedStyle(tdElem).height) || tdHeight;
      } catch (e) {
        this.stickyWarning(e);
      }

      var marginTop = thHeight + tdHeight + offsetTop;
      this.intersectionObserver = new IntersectionObserver(function (entries) {
        var _entries = _slicedToArray(entries, 1),
            entry = _entries[0];

        try {
          if (entry.isIntersecting) {
            trElem.classList.remove('show-shadow');
          } else {
            trElem.classList.add('show-shadow');
          }
        } catch (e) {
          _this2.stickyWarning(e);
        }
      }, {
        rootMargin: "-".concat(marginTop, "px 0px 0px 0px")
      });
    }
  }, {
    key: "stickyWarning",
    value: function stickyWarning() {
      var e = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      (0, _componentHelper.warn)('Could not enable Sticky mode in table:', e);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          sticky = _this$props.sticky,
          props = _objectWithoutProperties(_this$props, ["sticky"]);

      return _react.default.createElement(_Element.default, _extends({
        is: "table"
      }, props, {
        ref: this._ref
      }));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(Table.tagName, Table, Table.defaultProps);
    }
  }]);

  return Table;
}(_react.default.PureComponent);

exports.default = Table;
Table.tagName = 'dnb-table';
Table.defaultProps = {
  sticky: false,
  sticky_offset: null,
  children: null
};
process.env.NODE_ENV !== "production" ? Table.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  sticky: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  sticky_offset: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  children: _propTypes.default.node
}) : void 0;
Table.StickyHelper = StickyHelper;