"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpacingHelper = require("../components/space/SpacingHelper");

var _Element = _interopRequireDefault(require("./Element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Td = function Td() {
  var p = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return _react.default.createElement(_Element.default, _extends({
    is: "td"
  }, p, {
    internalClass: "dnb-table__td",
    skeleton_method: "font-only"
  }));
};

Td.tagName = 'dnb-table__td';
process.env.NODE_ENV !== "production" ? Td.propTypes = _extends({}, _SpacingHelper.spacingPropTypes, {
  children: _propTypes.default.node
}) : void 0;
Td.defaultProps = {
  children: null
};
var _default = Td;
exports.default = _default;