"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Anchor", {
  enumerable: true,
  get: function get() {
    return _Anchor.default;
  }
});
Object.defineProperty(exports, "Blockquote", {
  enumerable: true,
  get: function get() {
    return _Blockquote.default;
  }
});
Object.defineProperty(exports, "Code", {
  enumerable: true,
  get: function get() {
    return _Code.default;
  }
});
Object.defineProperty(exports, "Dd", {
  enumerable: true,
  get: function get() {
    return _Dd.default;
  }
});
Object.defineProperty(exports, "Div", {
  enumerable: true,
  get: function get() {
    return _Div.default;
  }
});
Object.defineProperty(exports, "Dl", {
  enumerable: true,
  get: function get() {
    return _Dl.default;
  }
});
Object.defineProperty(exports, "Dt", {
  enumerable: true,
  get: function get() {
    return _Dt.default;
  }
});
Object.defineProperty(exports, "H", {
  enumerable: true,
  get: function get() {
    return _H.default;
  }
});
Object.defineProperty(exports, "H1", {
  enumerable: true,
  get: function get() {
    return _H2.default;
  }
});
Object.defineProperty(exports, "H2", {
  enumerable: true,
  get: function get() {
    return _H3.default;
  }
});
Object.defineProperty(exports, "H3", {
  enumerable: true,
  get: function get() {
    return _H4.default;
  }
});
Object.defineProperty(exports, "H4", {
  enumerable: true,
  get: function get() {
    return _H5.default;
  }
});
Object.defineProperty(exports, "H5", {
  enumerable: true,
  get: function get() {
    return _H6.default;
  }
});
Object.defineProperty(exports, "H6", {
  enumerable: true,
  get: function get() {
    return _H7.default;
  }
});
Object.defineProperty(exports, "Hr", {
  enumerable: true,
  get: function get() {
    return _Hr.default;
  }
});
Object.defineProperty(exports, "Img", {
  enumerable: true,
  get: function get() {
    return _Img.default;
  }
});
Object.defineProperty(exports, "Ingress", {
  enumerable: true,
  get: function get() {
    return _Ingress.default;
  }
});
Object.defineProperty(exports, "Lead", {
  enumerable: true,
  get: function get() {
    return _Lead.default;
  }
});
Object.defineProperty(exports, "Li", {
  enumerable: true,
  get: function get() {
    return _Li.default;
  }
});
Object.defineProperty(exports, "Link", {
  enumerable: true,
  get: function get() {
    return _Link.default;
  }
});
Object.defineProperty(exports, "Ol", {
  enumerable: true,
  get: function get() {
    return _Ol.default;
  }
});
Object.defineProperty(exports, "P", {
  enumerable: true,
  get: function get() {
    return _P.default;
  }
});
Object.defineProperty(exports, "Paragraph", {
  enumerable: true,
  get: function get() {
    return _Paragraph.default;
  }
});
Object.defineProperty(exports, "Span", {
  enumerable: true,
  get: function get() {
    return _Span.default;
  }
});
Object.defineProperty(exports, "Table", {
  enumerable: true,
  get: function get() {
    return _Table.default;
  }
});
Object.defineProperty(exports, "Td", {
  enumerable: true,
  get: function get() {
    return _Td.default;
  }
});
Object.defineProperty(exports, "Th", {
  enumerable: true,
  get: function get() {
    return _Th.default;
  }
});
Object.defineProperty(exports, "Tr", {
  enumerable: true,
  get: function get() {
    return _Tr.default;
  }
});
Object.defineProperty(exports, "Ul", {
  enumerable: true,
  get: function get() {
    return _Ul.default;
  }
});
exports.getElements = void 0;

var _Anchor = _interopRequireDefault(require("./Anchor"));

var _Blockquote = _interopRequireDefault(require("./Blockquote"));

var _Code = _interopRequireDefault(require("./Code"));

var _Dd = _interopRequireDefault(require("./Dd"));

var _Div = _interopRequireDefault(require("./Div"));

var _Dl = _interopRequireDefault(require("./Dl"));

var _Dt = _interopRequireDefault(require("./Dt"));

var _H = _interopRequireDefault(require("./H"));

var _H2 = _interopRequireDefault(require("./H1"));

var _H3 = _interopRequireDefault(require("./H2"));

var _H4 = _interopRequireDefault(require("./H3"));

var _H5 = _interopRequireDefault(require("./H4"));

var _H6 = _interopRequireDefault(require("./H5"));

var _H7 = _interopRequireDefault(require("./H6"));

var _Hr = _interopRequireDefault(require("./Hr"));

var _Img = _interopRequireDefault(require("./Img"));

var _Ingress = _interopRequireDefault(require("./Ingress"));

var _Lead = _interopRequireDefault(require("./Lead"));

var _Li = _interopRequireDefault(require("./Li"));

var _Link = _interopRequireDefault(require("./Link"));

var _Ol = _interopRequireDefault(require("./Ol"));

var _P = _interopRequireDefault(require("./P"));

var _Paragraph = _interopRequireDefault(require("./Paragraph"));

var _Span = _interopRequireDefault(require("./Span"));

var _Table = _interopRequireDefault(require("./Table"));

var _Td = _interopRequireDefault(require("./Td"));

var _Th = _interopRequireDefault(require("./Th"));

var _Tr = _interopRequireDefault(require("./Tr"));

var _Ul = _interopRequireDefault(require("./Ul"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getElements = function getElements() {
  return {
    Anchor: _Anchor.default,
    Blockquote: _Blockquote.default,
    Code: _Code.default,
    Dd: _Dd.default,
    Div: _Div.default,
    Dl: _Dl.default,
    Dt: _Dt.default,
    H: _H.default,
    H1: _H2.default,
    H2: _H3.default,
    H3: _H4.default,
    H4: _H5.default,
    H5: _H6.default,
    H6: _H7.default,
    Hr: _Hr.default,
    Img: _Img.default,
    Ingress: _Ingress.default,
    Lead: _Lead.default,
    Li: _Li.default,
    Link: _Link.default,
    Ol: _Ol.default,
    P: _P.default,
    Paragraph: _Paragraph.default,
    Span: _Span.default,
    Table: _Table.default,
    Td: _Td.default,
    Th: _Th.default,
    Tr: _Tr.default,
    Ul: _Ul.default
  };
};

exports.getElements = getElements;