"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.object.get-prototype-of.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _keycode = _interopRequireDefault(require("keycode"));

var _componentHelper = require("../../shared/component-helper");

var _SpacingHelper = require("../../components/space/SpacingHelper");

var _DrawerListContext = _interopRequireDefault(require("./DrawerListContext"));

var _DrawerListProvider = _interopRequireDefault(require("./DrawerListProvider"));

var _DrawerListPortal = _interopRequireDefault(require("./DrawerListPortal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propsToFilterOut = {
  on_show: null,
  on_hide: null,
  on_change: null,
  on_pre_change: null,
  on_resize: null,
  on_select: null,
  on_state_update: null,
  options_render: null,
  wrapper_element: null
};

var DrawerList = function (_React$PureComponent) {
  _inherits(DrawerList, _React$PureComponent);

  var _super = _createSuper(DrawerList);

  function DrawerList() {
    _classCallCheck(this, DrawerList);

    return _super.apply(this, arguments);
  }

  _createClass(DrawerList, [{
    key: "render",
    value: function render() {
      var _this$context;

      var hasProvider = (_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.drawerList;

      if (hasProvider) {
        return _react.default.createElement(DrawerListInstance, this.props);
      }

      return _react.default.createElement(_DrawerListProvider.default, _extends({}, this.props, {
        data: this.props.data || this.props.children
      }), _react.default.createElement(DrawerListInstance, this.props));
    }
  }], [{
    key: "enableWebComponent",
    value: function enableWebComponent() {
      (0, _componentHelper.registerElement)(DrawerList.tagName, DrawerList, DrawerList.defaultProps);
    }
  }]);

  return DrawerList;
}(_react.default.PureComponent);

exports.default = DrawerList;
DrawerList.tagName = 'dnb-drawer-list';
DrawerList.contextType = _DrawerListContext.default;
DrawerList.defaultProps = {
  id: null,
  role: 'listbox',
  cache_hash: null,
  triangle_position: 'left',
  scrollable: true,
  focusable: false,
  max_height: null,
  direction: 'auto',
  size: 'default',
  no_animation: false,
  no_scroll_animation: false,
  use_drawer_on_mobile: false,
  prevent_selection: false,
  action_menu: false,
  is_popup: false,
  align_drawer: 'left',
  wrapper_element: null,
  default_value: null,
  value: 'initval',
  skip_portal: null,
  prevent_close: false,
  keep_open: false,
  prevent_focus: false,
  fixed_position: false,
  independent_width: false,
  skip_keysearch: false,
  opened: null,
  class: null,
  data: null,
  prepared_data: null,
  raw_data: null,
  ignore_events: null,
  className: null,
  children: null,
  custom_element: null,
  custom_method: null,
  on_show: null,
  on_hide: null,
  on_change: null,
  on_pre_change: null,
  on_resize: null,
  on_select: null,
  on_state_update: null,
  options_render: null
};
process.env.NODE_ENV !== "production" ? DrawerList.propTypes = _extends({
  id: _propTypes.default.string,
  role: _propTypes.default.string,
  cache_hash: _propTypes.default.string,
  triangle_position: _propTypes.default.string,
  scrollable: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  focusable: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  direction: _propTypes.default.oneOf(['auto', 'top', 'bottom']),
  size: _propTypes.default.oneOf(['default', 'small', 'medium', 'large']),
  max_height: _propTypes.default.number,
  no_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  no_scroll_animation: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  use_drawer_on_mobile: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_selection: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  action_menu: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  is_popup: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  align_drawer: _propTypes.default.oneOf(['left', 'right']),
  options_render: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.func, _propTypes.default.node]),
  wrapper_element: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.func, _propTypes.default.node]),
  default_value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  skip_portal: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_close: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  independent_width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  fixed_position: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  keep_open: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  prevent_focus: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  skip_keysearch: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  opened: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  class: _propTypes.default.string,
  data: _propTypes.default.oneOfType([_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node, _propTypes.default.object]), _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]), _propTypes.default.shape({
    selected_value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
    content: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node, _propTypes.default.arrayOf(_propTypes.default.string)])
  })]))]),
  prepared_data: _propTypes.default.array,
  raw_data: _propTypes.default.oneOfType([_propTypes.default.array, _propTypes.default.object, _propTypes.default.func]),
  ignore_events: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool])
}, _SpacingHelper.spacingPropTypes, {
  className: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func, _propTypes.default.node, _propTypes.default.object, _propTypes.default.array]),
  custom_element: _propTypes.default.object,
  custom_method: _propTypes.default.func,
  on_show: _propTypes.default.func,
  on_hide: _propTypes.default.func,
  on_change: _propTypes.default.func,
  on_pre_change: _propTypes.default.func,
  on_resize: _propTypes.default.func,
  on_select: _propTypes.default.func,
  on_state_update: _propTypes.default.func
}) : void 0;

var DrawerListInstance = function (_React$PureComponent2) {
  _inherits(DrawerListInstance, _React$PureComponent2);

  var _super2 = _createSuper(DrawerListInstance);

  function DrawerListInstance(props, context) {
    var _this;

    _classCallCheck(this, DrawerListInstance);

    _this = _super2.call(this, props);

    _this.preventTab = function (e) {
      switch ((0, _keycode.default)(e)) {
        case 'tab':
          _this.context.drawerList.setHidden();

          break;

        case 'page down':
        case 'page up':
          e.preventDefault();
          break;
      }
    };

    _this.selectItemHandler = function (event) {
      var selected_item = parseFloat(event.currentTarget.getAttribute('data-item'));

      if (selected_item > -1) {
        _this.context.drawerList.selectItem(selected_item, {
          fireSelectEvent: true,
          event: event
        });
      }
    };

    _this._id = props.id || (0, _componentHelper.makeUniqueId)();
    _this.state = _this.state || {};
    context.drawerList.setState(Object.entries(propsToFilterOut).reduce(function (acc, _ref) {
      var _ref2 = _slicedToArray(_ref, 1),
          key = _ref2[0];

      if (props[key]) {
        acc[key] = props[key];
      }

      return acc;
    }, {}));
    context.drawerList.setState({
      triangle_position: props.triangle_position
    });
    return _this;
  }

  _createClass(DrawerListInstance, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = (0, _componentHelper.extendPropsWithContext)(this.props, DrawerList.defaultProps, this.context.getTranslation(this.props).DrawerList, this.context.FormRow, this.context.DrawerList);

      var role = props.role,
          align_drawer = props.align_drawer,
          fixed_position = props.fixed_position,
          use_drawer_on_mobile = props.use_drawer_on_mobile,
          independent_width = props.independent_width,
          scrollable = props.scrollable,
          focusable = props.focusable,
          size = props.size,
          no_animation = props.no_animation,
          no_scroll_animation = props.no_scroll_animation,
          prevent_selection = props.prevent_selection,
          action_menu = props.action_menu,
          is_popup = props.is_popup,
          inner_class = props.inner_class,
          ignore_events = props.ignore_events,
          options_render = props.options_render,
          className = props.className,
          _className = props.class,
          _cache_hash = props.cache_hash,
          _wrapper_element = props.wrapper_element,
          _triangle_position = props.triangle_position,
          _direction = props.direction,
          _max_height = props.max_height,
          _id = props.id,
          _data = props.data,
          _prepared_data = props.prepared_data,
          _raw_data = props.raw_data,
          _opened = props.opened,
          _value = props.value,
          children = props.children,
          attributes = _objectWithoutProperties(props, ["role", "align_drawer", "fixed_position", "use_drawer_on_mobile", "independent_width", "scrollable", "focusable", "size", "no_animation", "no_scroll_animation", "prevent_selection", "action_menu", "is_popup", "inner_class", "ignore_events", "options_render", "className", "class", "cache_hash", "wrapper_element", "triangle_position", "direction", "max_height", "id", "data", "prepared_data", "raw_data", "opened", "value", "children"]);

      var id = this._id;
      var _this$context$drawerL = this.context.drawerList,
          data = _this$context$drawerL.data,
          opened = _this$context$drawerL.opened,
          hidden = _this$context$drawerL.hidden,
          triangle_position = _this$context$drawerL.triangle_position,
          direction = _this$context$drawerL.direction,
          max_height = _this$context$drawerL.max_height,
          cache_hash = _this$context$drawerL.cache_hash,
          selected_item = _this$context$drawerL.selected_item,
          active_item = _this$context$drawerL.active_item,
          closestToTop = _this$context$drawerL.closestToTop,
          closestToBottom = _this$context$drawerL.closestToBottom,
          assignObservers = _this$context$drawerL.assignObservers,
          _refShell = _this$context$drawerL._refShell,
          _refTriangle = _this$context$drawerL._refTriangle,
          _refUl = _this$context$drawerL._refUl,
          usePortal = _this$context$drawerL.usePortal,
          _refRoot = _this$context$drawerL._refRoot;

      var mainParams = _extends({
        id: "".concat(id, "-drawer-list"),
        className: (0, _classnames.default)("dnb-drawer-list dnb-drawer-list--".concat(direction), (0, _componentHelper.isTrue)(independent_width) || (0, _componentHelper.isTrue)(action_menu) && 'dnb-drawer-list--independent-width', (0, _SpacingHelper.createSpacingClasses)(props), _className, className, opened && 'dnb-drawer-list--opened', hidden && 'dnb-drawer-list--hidden', triangle_position && "dnb-drawer-list--triangle-position-".concat(triangle_position), align_drawer && "dnb-drawer-list--".concat(align_drawer), size && "dnb-drawer-list--".concat(size), (0, _componentHelper.isTrue)(action_menu) && "dnb-drawer-list--action-menu", (0, _componentHelper.isTrue)(is_popup) && 'dnb-drawer-list--is-popup', (0, _componentHelper.isTrue)(scrollable) && 'dnb-drawer-list--scroll', (0, _componentHelper.isTrue)(no_scroll_animation) && 'dnb-drawer-list--no-scroll-animation', (0, _componentHelper.isTrue)(use_drawer_on_mobile) && 'dnb-drawer-list--mobile-view')
      }, attributes);

      var listParams = {
        id: "".concat(id, "-listbox"),
        className: (0, _classnames.default)('dnb-drawer-list__list', inner_class, (0, _componentHelper.isTrue)(no_animation) && 'dnb-drawer-list__list--no-animation')
      };
      var ulParams = {
        role: role,
        id: "".concat(id, "-ul"),
        'aria-expanded': opened,
        'aria-labelledby': "".concat(id, "-label"),
        tabIndex: '-1',
        style: {
          maxHeight: max_height > 0 ? "".concat(max_height, "rem") : null
        },
        ref: _refUl
      };

      if (!hidden && parseFloat(active_item) > -1) {
        ulParams['aria-activedescendant'] = "option-".concat(id, "-").concat(active_item);
      } else if (!(0, _componentHelper.isTrue)(prevent_selection) && !hidden && parseFloat(selected_item) > -1) {
        ulParams['aria-activedescendant'] = "option-".concat(id, "-").concat(selected_item);
      }

      if ((0, _componentHelper.isTrue)(focusable)) {
        ulParams.tabIndex = '0';
      }

      (0, _componentHelper.validateDOMAttributes)(this.props, mainParams);
      (0, _componentHelper.validateDOMAttributes)(null, listParams);
      (0, _componentHelper.validateDOMAttributes)(null, ulParams);

      _extends(this.context.drawerList.attributes, (0, _componentHelper.validateDOMAttributes)(null, attributes));

      var ignoreEvents = (0, _componentHelper.isTrue)(ignore_events);

      var Items = function Items() {
        return data.map(function (dataItem, i) {
          var _id = dataItem.__id;
          var hash = "option-".concat(id, "-").concat(_id, "-").concat(i);
          var liParams = {
            role: role === 'menu' ? 'menuitem' : 'option',
            'data-item': _id,
            id: "option-".concat(id, "-").concat(_id),
            hash: hash,
            className: (0, _classnames.default)(ignoreEvents || dataItem.ignore_events && 'ignore-events', dataItem.class_name, i === closestToTop && 'closest-to-top', i === closestToBottom && 'closest-to-bottom', i === 0 && 'first-of-type', i === data.length - 1 && 'last-of-type'),
            active: _id == active_item,
            selected: !dataItem.ignore_events && _id == selected_item,
            onClick: _this2.selectItemHandler,
            onKeyDown: _this2.preventTab
          };

          if (ignoreEvents) {
            liParams.active = null;
            liParams.selected = null;
            liParams.onClick = null;
            liParams.onKeyDown = null;
            liParams.className = (0, _classnames.default)(liParams.className, 'dnb-drawer-list__option--ignore');
          }

          return _react.default.createElement(DrawerList.Item, _extends({
            key: hash
          }, liParams), dataItem);
        });
      };

      var mainList = _react.default.createElement("span", _extends({}, mainParams, {
        ref: _refShell
      }), _react.default.createElement("span", listParams, hidden === false && data && data.length > 0 ? _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(DrawerList.Options, _extends({
        cache_hash: cache_hash + active_item + selected_item + closestToTop + closestToBottom + direction + max_height
      }, ulParams, {
        triangleRef: _refTriangle
      }), typeof options_render === 'function' ? options_render({
        data: data,
        Items: Items,
        Item: DrawerList.Item
      }) : _react.default.createElement(Items, null)), _react.default.createElement(OnMounted, {
        assignObservers: assignObservers
      })) : children && _react.default.createElement("span", {
        className: "dnb-drawer-list__content"
      }, children, _react.default.createElement("span", {
        className: "dnb-drawer-list__triangle",
        ref: _refTriangle
      }))));

      return _react.default.createElement("span", {
        className: 'dnb-drawer-list__root' + (usePortal ? " dnb-drawer-list__root--portal" : ""),
        ref: _refRoot
      }, usePortal ? _react.default.createElement(_DrawerListPortal.default, {
        id: this._id,
        rootRef: _refRoot,
        opened: hidden === false,
        include_owner_width: align_drawer === 'right',
        independent_width: (0, _componentHelper.isTrue)(independent_width),
        fixed_position: (0, _componentHelper.isTrue)(fixed_position),
        use_drawer_on_mobile: (0, _componentHelper.isTrue)(use_drawer_on_mobile)
      }, mainList) : mainList);
    }
  }]);

  return DrawerListInstance;
}(_react.default.PureComponent);

DrawerListInstance.defaultProps = DrawerList.defaultProps;
DrawerListInstance.contextType = _DrawerListContext.default;
process.env.NODE_ENV !== "production" ? DrawerListInstance.propTypes = DrawerList.propTypes : void 0;
DrawerList.Options = _react.default.memo(_react.default.forwardRef(function (props, ref) {
  var children = props.children,
      className = props.className,
      _className = props.class,
      _props$triangleRef = props.triangleRef,
      triangleRef = _props$triangleRef === void 0 ? null : _props$triangleRef,
      cache_hash = props.cache_hash,
      rest = _objectWithoutProperties(props, ["children", "className", "class", "triangleRef", "cache_hash"]);

  return _react.default.createElement("ul", _extends({
    className: (0, _classnames.default)('dnb-drawer-list__options', className, _className)
  }, rest, {
    ref: ref
  }), children, _react.default.createElement("li", {
    className: "dnb-drawer-list__triangle",
    "aria-hidden": true,
    ref: triangleRef
  }));
}), function (prevProps, nextProps) {
  if (!prevProps.cache_hash) {
    return null;
  }

  return prevProps.cache_hash === nextProps.cache_hash;
});
DrawerList.Options.displayName = 'DrawerList.Options';
DrawerList.Options.propTypes = {
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func]),
  className: _propTypes.default.string,
  class: _propTypes.default.string,
  triangleRef: _propTypes.default.object
};
DrawerList.Options.defaultProps = {
  children: null,
  className: null,
  class: null,
  triangleRef: null
};
DrawerList.Item = _react.default.forwardRef(function (props, ref) {
  var role = props.role,
      hash = props.hash,
      children = props.children,
      className = props.className,
      _className = props.class,
      on_click = props.on_click,
      selected = props.selected,
      active = props.active,
      value = props.value,
      rest = _objectWithoutProperties(props, ["role", "hash", "children", "className", "class", "on_click", "selected", "active", "value"]);

  var params = {
    className: (0, _classnames.default)(className, _className, 'dnb-drawer-list__option', selected && 'dnb-drawer-list__option--selected', active && 'dnb-drawer-list__option--focus'),
    role: role,
    tabIndex: selected ? '0' : '-1',
    'aria-selected': active
  };

  if (selected) {
    params['aria-current'] = true;
  }

  if (on_click) {
    params.onClick = function () {
      return (0, _componentHelper.dispatchCustomElementEvent)({
        props: _extends({}, props, {
          displayName: DrawerList.Item.displayName
        })
      }, 'on_click', _extends({
        selected: selected,
        value: value
      }, rest));
    };
  }

  return _react.default.createElement("li", _extends({}, params, rest, {
    ref: ref,
    key: 'li' + hash
  }), _react.default.createElement("span", {
    className: "dnb-drawer-list__option__inner"
  }, _react.default.createElement(ItemContent, {
    hash: hash
  }, children)));
});
DrawerList.Item.displayName = 'DrawerList.Item';
DrawerList.Item.propTypes = {
  role: _propTypes.default.string,
  hash: _propTypes.default.string,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func, _propTypes.default.object]).isRequired,
  className: _propTypes.default.string,
  class: _propTypes.default.string,
  on_click: _propTypes.default.func,
  selected: _propTypes.default.bool,
  active: _propTypes.default.bool,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
};
DrawerList.Item.defaultProps = {
  role: 'option',
  hash: '',
  className: null,
  class: null,
  on_click: null,
  selected: null,
  active: null,
  value: null
};

var ItemContent = function ItemContent(_ref3) {
  var hash = _ref3.hash,
      children = _ref3.children;

  if (Array.isArray(children.content || children)) {
    return (children.content || children).map(function (item, n) {
      return _react.default.createElement("span", {
        key: hash + n,
        className: "dnb-drawer-list__option__item"
      }, children.render ? children.render(item, hash + n) : item);
    });
  } else if (children.content) {
    return children.render ? children.render(children.content, hash) : children.content;
  }

  return children;
};

process.env.NODE_ENV !== "production" ? ItemContent.propTypes = {
  hash: _propTypes.default.string.isRequired,
  children: _propTypes.default.oneOfType([_propTypes.default.node, _propTypes.default.func, _propTypes.default.object]).isRequired
} : void 0;

DrawerList.HorizontalItem = function (_ref4) {
  var className = _ref4.className,
      props = _objectWithoutProperties(_ref4, ["className"]);

  return _react.default.createElement("span", _extends({
    className: (0, _classnames.default)('dnb-drawer-list__option__inner__item', className)
  }, props));
};

DrawerList.HorizontalItem.propTypes = {
  className: _propTypes.default.string
};
DrawerList.HorizontalItem.defaultProps = {
  className: null
};

var OnMounted = function (_React$PureComponent3) {
  _inherits(OnMounted, _React$PureComponent3);

  var _super3 = _createSuper(OnMounted);

  function OnMounted() {
    _classCallCheck(this, OnMounted);

    return _super3.apply(this, arguments);
  }

  _createClass(OnMounted, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.assignObservers();
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return OnMounted;
}(_react.default.PureComponent);

process.env.NODE_ENV !== "production" ? OnMounted.propTypes = {
  assignObservers: _propTypes.default.func.isRequired
} : void 0;