"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _ref = _react.default.createElement("path", {
  d: "M5.6666 3.86666L3.79993 2M4.73326 5.73333H3.79993M7.53326 2.93333V2M9.39993 4.8H12.1999C13.725 4.8 14.9999 6.07493 14.9999 7.59999C14.9999 9.12506 13.725 10.4 12.1999 10.4H9.39993M2.99992 8.17352L1.82002 9.35341C0.741633 10.4318 0.741633 12.2348 1.82002 13.3132C2.89841 14.3916 4.70145 14.3916 5.77984 13.3132L7.09307 12",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function broken_chain(props) {
  return _react.default.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

var _default = broken_chain;
exports.default = _default;