"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _ref = _react.default.createElement("path", {
  d: "M15.1758 6.72275L8.16236 13.7368C6.47813 15.4211 3.74745 15.4211 2.06322 13.7368C0.378991 12.0526 0.378991 9.32192 2.06322 7.63769L7.82373 1.87782C8.54561 1.13041 9.6146 0.830655 10.6198 1.09378C11.6251 1.3569 12.4101 2.14194 12.6732 3.14717C12.9363 4.15241 12.6366 5.2214 11.8892 5.94327L6.12931 11.7063C5.56533 12.2512 4.6687 12.2436 4.11409 11.6891C3.55949 11.1347 3.55156 10.2381 4.09627 9.67393L9.85678 3.9115",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function paperclip(props) {
  return _react.default.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

var _default = paperclip;
exports.default = _default;