"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  enableWebComponents: true
};
exports.enableWebComponents = void 0;

var _lib = require("./components/lib");

Object.keys(_lib).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _lib[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _lib[key];
    }
  });
});

var _lib2 = require("./patterns/lib");

Object.keys(_lib2).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _lib2[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _lib2[key];
    }
  });
});
var webComponentsAreEnabled = false;

var enableWebComponents = function enableWebComponents() {
  if (webComponentsAreEnabled) return false;
  webComponentsAreEnabled = true;
  (0, _lib.enableWebComponents)();
  (0, _lib2.enableWebComponents)();
};

exports.enableWebComponents = enableWebComponents;