import * as React from 'react';
export type FieldsetDescriptionChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface FieldsetDescriptionProps
  extends React.HTMLProps<HTMLElement> {
  text?: string;
  class?: string;
  className?: string;
  children?: FieldsetDescriptionChildren;
}
export default class FieldsetDescription extends React.Component<
  FieldsetDescriptionProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
