"use strict";

require("core-js/modules/es.symbol.js");

require("core-js/modules/es.symbol.description.js");

require("core-js/modules/es.symbol.iterator.js");

require("core-js/modules/es.array.concat.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.reduce.js");

require("core-js/modules/es.array.reverse.js");

require("core-js/modules/es.array.slice.js");

require("core-js/modules/es.object.entries.js");

require("core-js/modules/es.object.is-frozen.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.includes.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/es.string.match.js");

require("core-js/modules/es.string.replace.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isTouchDevice = isTouchDevice;
exports.defineNavigator = defineNavigator;
exports.convertStatusToStateOnly = convertStatusToStateOnly;
exports.getStatusState = getStatusState;
exports.combineLabelledBy = combineLabelledBy;
exports.combineDescribedBy = combineDescribedBy;
Object.defineProperty(exports, "registerElement", {
  enumerable: true,
  get: function get() {
    return _customElement.registerElement;
  }
});
exports.AnimateHeight = exports.InteractionInvalidation = exports.convertJsxToString = exports.warn = exports.isInsideScrollView = exports.roundToNearest = exports.isChildOfElement = exports.getPreviousSibling = exports.matchAll = exports.slugify = exports.makeUniqueId = exports.filterProps = exports.checkIfHasScrollbar = exports.DetectOutsideClickClass = exports.detectOutsideClick = exports.toKebabCase = exports.toSnakeCase = exports.toPascalCase = exports.toCamelCase = exports.dispatchCustomElementEvent = exports.isTrue = exports.extendPropsWithContext = exports.extend = exports.processChildren = exports.validateDOMAttributes = exports.PLATFORM_IOS = exports.PLATFORM_LINUX = exports.PLATFORM_WIN = exports.PLATFORM_MAC = void 0;

var _react = _interopRequireDefault(require("react"));

var _keycode = _interopRequireDefault(require("keycode"));

var _whatInput = _interopRequireDefault(require("what-input"));

var _customElement = require("./custom-element");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var PLATFORM_MAC = 'Mac|iPad|iPhone|iPod';
exports.PLATFORM_MAC = PLATFORM_MAC;
var PLATFORM_WIN = 'Win';
exports.PLATFORM_WIN = PLATFORM_WIN;
var PLATFORM_LINUX = 'Linux';
exports.PLATFORM_LINUX = PLATFORM_LINUX;
var PLATFORM_IOS = 'iOS|iPhone|iPad|iPod';
exports.PLATFORM_IOS = PLATFORM_IOS;

if (typeof process !== 'undefined' && process.env.NODE_ENV === 'test' && typeof window !== 'undefined') {
  window.IS_TEST = true;
}

_whatInput.default.specificKeys([9]);

defineNavigator();

function isTouchDevice() {
  if (typeof document !== 'undefined') {
    var intent = false;

    try {
      intent = document.documentElement.getAttribute('data-whatintent');
    } catch (e) {}

    return intent === 'touch';
  }

  return false;
}

function defineNavigator() {
  var handleNavigator = function handleNavigator() {
    if (typeof document === 'undefined' || typeof window === 'undefined' || typeof navigator === 'undefined') {
      return;
    }

    try {
      if (!(typeof window !== 'undefined' && window.IS_TEST)) {
        if (navigator.platform.match(new RegExp(PLATFORM_MAC)) !== null) {
          document.documentElement.setAttribute('data-os', 'mac');
        } else if (navigator.platform.match(new RegExp(PLATFORM_WIN)) !== null) {
          document.documentElement.setAttribute('data-os', 'win');
        } else if (navigator.platform.match(new RegExp(PLATFORM_LINUX)) !== null) {
          document.documentElement.setAttribute('data-os', 'linux');
        }
      } else {
        document.documentElement.setAttribute('data-os', 'other');
      }
    } catch (e) {
      warn(e);
    }

    document.removeEventListener('DOMContentLoaded', handleNavigator);
  };

  if (typeof document !== 'undefined' && document.readyState === 'loading') {
    document.addEventListener('DOMContentLoaded', handleNavigator);
  } else {
    handleNavigator();
  }
}

var validateDOMAttributes = function validateDOMAttributes(props, params) {
  if (props && props.attributes) {
    var attr = props.attributes;

    if (attr) {
      if (attr[0] === '{') attr = JSON.parse(attr);

      if (attr && _typeof(attr) === 'object') {
        Object.entries(attr).forEach(function (_ref) {
          var _ref2 = _slicedToArray(_ref, 2),
              key = _ref2[0],
              value = _ref2[1];

          _extends(params, _defineProperty({}, key, value));
        });
      }
    }
  }

  if (params.disabled === null || params.disabled === 'false') {
    delete params.disabled;
  }

  if (typeof params.space !== 'undefined') {
    delete params.space;
  }

  if (typeof params.top !== 'undefined') {
    delete params.top;
  }

  if (typeof params.right !== 'undefined') {
    delete params.right;
  }

  if (typeof params.bottom !== 'undefined') {
    delete params.bottom;
  }

  if (typeof params.left !== 'undefined') {
    delete params.left;
  }

  if (typeof params.no_collapse !== 'undefined') {
    delete params.no_collapse;
  } else if (params.disabled === 'true') {
      params.disabled = true;
    }

  if (params.disabled === true) {
    params['aria-disabled'] = true;
  }

  if (props && props.tabindex) {
    var tabIndex = props.tabindex;

    if (tabIndex === 'off') {
      tabIndex = '-1';
    }

    params['tabIndex'] = tabIndex;
  }

  if (params && _typeof(params) === 'object') {
    for (var i in params) {
      if (typeof params[i] === 'function' && !/(^[a-z]{1,}[A-Z]{1})/.test(i)) {
        delete params[i];
      } else if (params[i] === null || /[^a-z-]/i.test(i)) {
          delete params[i];
        }
    }
  }

  return params;
};

exports.validateDOMAttributes = validateDOMAttributes;

var processChildren = function processChildren(props) {
  if (!props) {
    return null;
  }

  if (typeof global !== 'undefined' && Array.isArray(global.registeredElements) && global.registeredElements.length > 0) {
    var cache = null;
    Object.entries(props).reverse().map(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          key = _ref4[0],
          cb = _ref4[1];

      if (key.includes('render_') && /^render_/.test(key)) {
        if (typeof cb === 'function') {
          if (cache) {
            if (Object.isFrozen(props)) {
              props = _extends({}, props);
            }

            props.children = cache;
          }

          return cache = _react.default.createElement(_react.default.Fragment, {
            key: key
          }, cb(props));
        }
      }

      return null;
    }).filter(Boolean);

    if (cache) {
      return cache;
    }
  }

  var res = typeof props.children === 'function' ? props.children(props) : props.children;

  if (Array.isArray(res)) {
    var onlyTexts = res.reduce(function (pV, cV) {
      if (typeof cV === 'string' || typeof cV === 'number') {
        pV.push(cV);
      }

      return pV;
    }, []);

    if (onlyTexts.length === res.length && onlyTexts.length > 0) {
      return onlyTexts.join('');
    }
  }

  return res;
};

exports.processChildren = processChildren;

var extend = function extend() {
  var first = {};

  for (var _len = arguments.length, objects = new Array(_len), _key = 0; _key < _len; _key++) {
    objects[_key] = arguments[_key];
  }

  var keepRef = objects[0];

  if (keepRef === true || keepRef === false) {
    objects.shift();

    if (keepRef) {
      first = objects.shift();
    }
  }

  return objects.reduce(function (acc1, object) {
    if (object) {
      acc1 = _extends(acc1, Object.entries(object).reduce(function (acc2, _ref5) {
        var _ref6 = _slicedToArray(_ref5, 2),
            key = _ref6[0],
            value = _ref6[1];

        if (value !== null) {
          if (_typeof(value) === 'object') {
            value = extend(acc1[key] || {}, value);

            if (Object.keys(value).length > 0) {
              acc2[key] = value;
            }
          } else {
            acc2[key] = value;
          }
        }

        return acc2;
      }, {}));
    }

    return acc1;
  }, first);
};

exports.extend = extend;

var extendPropsWithContext = function extendPropsWithContext(props) {
  var defaults = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  for (var _len2 = arguments.length, contexts = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
    contexts[_key2 - 2] = arguments[_key2];
  }

  var context = contexts.reduce(function (acc, cur) {
    if (cur) {
      acc = _extends({}, acc, cur);
    }

    return acc;
  }, {});
  return _extends({}, props, Object.entries(context).reduce(function (acc, _ref7) {
    var _ref8 = _slicedToArray(_ref7, 2),
        key = _ref8[0],
        value = _ref8[1];

    if (typeof props[key] !== 'undefined' && props[key] === defaults[key]) {
      acc[key] = value;
    }

    return acc;
  }, {}));
};

exports.extendPropsWithContext = extendPropsWithContext;

var isTrue = function isTrue(value) {
  if (value !== null && typeof value !== 'undefined' && (String(value) === 'true' || String(value) === '1')) {
    return true;
  }

  return false;
};

exports.isTrue = isTrue;

var dispatchCustomElementEvent = function dispatchCustomElementEvent(src, eventName, eventObjectOrig) {
  var ret = undefined;

  var eventObject = _extends({}, eventObjectOrig.event || {}, eventObjectOrig);

  if (eventObject && eventObject.attributes && eventObject.event) {
    var currentTarget = eventObject.event.currentTarget;

    if (currentTarget) {
      try {
        var dataset = _extends({}, currentTarget.dataset || {});

        var attributes = _extends({}, eventObject.attributes);

        for (var i in attributes) {
          if (/^data-/.test(i)) {
            dataset[String(i).replace(/^data-/, '')] = attributes[i];
          }
        }

        for (var _i2 in dataset) {
          if (eventObject.event.currentTarget.dataset) {
            eventObject.event.currentTarget.dataset[_i2] = dataset[_i2];
          }

          if (eventObject.event.target && eventObject.event.target.dataset) {
            eventObject.event.target.dataset[_i2] = dataset[_i2];
          }
        }
      } catch (e) {
        warn('Error on handling dataset:', e);
      }
    }
  }

  var props = src && src.props || src;

  if (props.custom_element) {
    if (typeof props.custom_element.fireEvent === 'function') {
      ret = props.custom_element.fireEvent(eventName, eventObject);
    }
  }

  if (eventName.includes('_')) {
    if (typeof props[eventName] === 'function') {
      var r = props[eventName].apply(src, [eventObject]);

      if (typeof r !== 'undefined') {
        ret = r;
      }
    }

    eventName = toCamelCase(eventName);

    if (typeof props[eventName] === 'function') {
      var _r = props[eventName].apply(src, [eventObject]);

      if (typeof _r !== 'undefined') {
        ret = _r;
      }
    }
  } else {
    if (typeof props[eventName] === 'function') {
      var _r2 = props[eventName].apply(src, [eventObject]);

      if (typeof _r2 !== 'undefined') {
        ret = _r2;
      }
    }

    eventName = toSnakeCase(eventName);

    if (typeof props[eventName] === 'function') {
      var _r3 = props[eventName].apply(src, [eventObject]);

      if (typeof _r3 !== 'undefined') {
        ret = _r3;
      }
    }
  }

  return ret;
};

exports.dispatchCustomElementEvent = dispatchCustomElementEvent;

var toCamelCase = function toCamelCase(s) {
  return s.split(/_/g).reduce(function (acc, cur, i) {
    return acc + (i === 0 ? cur : cur.replace(/(\w)(\w*)/g, function (g0, g1, g2) {
      return g1.toUpperCase() + g2.toLowerCase();
    }));
  }, '');
};

exports.toCamelCase = toCamelCase;

var toPascalCase = function toPascalCase(s) {
  return s.split(/_/g).reduce(function (acc, cur) {
    return acc + cur.replace(/(\w)(\w*)/g, function (g0, g1, g2) {
      return g1.toUpperCase() + g2.toLowerCase();
    });
  }, '');
};

exports.toPascalCase = toPascalCase;

var toSnakeCase = function toSnakeCase(str) {
  return str.replace(/\B[A-Z]/g, function (letter) {
    return "_".concat(letter);
  }).toLowerCase();
};

exports.toSnakeCase = toSnakeCase;

var toKebabCase = function toKebabCase(str) {
  return str.replace(/\B[A-Z]/g, function (letter) {
    return "-".concat(letter);
  }).toLowerCase();
};

exports.toKebabCase = toKebabCase;

var detectOutsideClick = function detectOutsideClick(ignoreElements, onSuccess, options) {
  return new DetectOutsideClickClass(ignoreElements, onSuccess, options);
};

exports.detectOutsideClick = detectOutsideClick;

var DetectOutsideClickClass = function () {
  function DetectOutsideClickClass(_ignoreElements, _onSuccess) {
    var _this = this;

    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, DetectOutsideClickClass);

    this.checkOutsideClick = function (_ref9) {
      var currentElement = _ref9.currentElement,
          ignoreElements = _ref9.ignoreElements;
      var onSuccess = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      try {
        if (typeof currentElement.tagName === 'undefined' || /html/i.test(currentElement.tagName)) {
            return;
          }

        if (checkIfHasScrollbar(currentElement)) {
          return;
        }

        for (var i = 0, elem, l = ignoreElements.length; i < l; ++i) {
          elem = currentElement;

          if (!ignoreElements[i]) {
            continue;
          }

          do {
            if (elem === ignoreElements[i]) {
              return;
            }

            elem = elem && elem.parentNode;
          } while (elem);
        }

        if (typeof onSuccess === 'function') {
          onSuccess();
        }
      } catch (e) {
        warn(e);
      }
    };

    if (!this.handleClickOutside && typeof document !== 'undefined' && typeof window !== 'undefined') {
      if (!Array.isArray(_ignoreElements)) {
        _ignoreElements = [_ignoreElements];
      }

      this.handleClickOutside = function (event) {
        _this.checkOutsideClick({
          currentElement: event.target,
          ignoreElements: _ignoreElements
        }, function () {
          return typeof _onSuccess === 'function' && _onSuccess({
            event: event
          });
        });
      };

      document.addEventListener('mousedown', this.handleClickOutside);

      this.keydownCallback = function (event) {
        var keyCode = (0, _keycode.default)(event);

        if (keyCode === 'esc') {
          window.removeEventListener('keydown', _this.keydownCallback);

          if (typeof _onSuccess === 'function') {
            _onSuccess({
              event: event
            });
          }
        }
      };

      window.addEventListener('keydown', this.keydownCallback);

      if (options.includedKeys) {
        this.keyupCallback = function (event) {
          var keyCode = (0, _keycode.default)(event);

          if (options.includedKeys.includes(keyCode) && typeof _this.handleClickOutside === 'function') {
            _this.handleClickOutside(event, function () {
              if (_this.keyupCallback) window.removeEventListener('keyup', _this.keyupCallback);
            });
          }
        };

        window.addEventListener('keyup', this.keyupCallback);
      }
    }
  }

  _createClass(DetectOutsideClickClass, [{
    key: "remove",
    value: function remove() {
      if (this.handleClickOutside && typeof document !== 'undefined') {
        document.removeEventListener('mousedown', this.handleClickOutside);
        this.handleClickOutside = null;
      }

      if (this.keydownCallback && typeof window !== 'undefined') {
        window.removeEventListener('keydown', this.keydownCallback);
        this.keydownCallback = null;
      }

      if (this.keyupCallback && typeof window !== 'undefined') {
        window.removeEventListener('keyup', this.keyupCallback);
        this.keyupCallback = null;
      }
    }
  }]);

  return DetectOutsideClickClass;
}();

exports.DetectOutsideClickClass = DetectOutsideClickClass;

var checkIfHasScrollbar = function checkIfHasScrollbar(elem) {
  return elem && (elem.scrollHeight > elem.offsetHeight || elem.scrollWidth > elem.offsetWidth) && overflowIsScrollable(elem);
};

exports.checkIfHasScrollbar = checkIfHasScrollbar;

var overflowIsScrollable = function overflowIsScrollable(elem) {
  var style = window.getComputedStyle(elem);
  return /scroll|auto/i.test(style.overflow + (style.overflowX || '') + (style.overflowY || ''));
};

var filterProps = function filterProps(props) {
  var remove = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var allowed = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (Array.isArray(remove)) {
    remove = remove.reduce(function (acc, key) {
      acc[key] = true;
      return acc;
    }, {});
  }

  if (Array.isArray(allowed)) {
    allowed = allowed.reduce(function (acc, key) {
      acc[key] = true;
      return acc;
    }, {});
  }

  return Object.entries(props).reduce(function (acc, _ref10) {
    var _ref11 = _slicedToArray(_ref10, 2),
        k = _ref11[0],
        v = _ref11[1];

    if (remove && typeof remove[k] === 'undefined' || allowed && typeof allowed[k] !== 'undefined') {
      acc[k] = v;
    }

    return acc;
  }, {});
};

exports.filterProps = filterProps;

var makeUniqueId = function makeUniqueId() {
  var prefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var length = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 8;
  return prefix + String(Math.random().toString(36).substr(2, length) + idIncrement++).slice(-length);
};

exports.makeUniqueId = makeUniqueId;
var idIncrement = 0;

var slugify = function slugify(s) {
  return String(s).toLowerCase().replace(/[^\w\s-]/g, '').replace(/[\s_-]+/g, '-').replace(/^-+|-+$/g, '');
};

exports.slugify = slugify;

var matchAll = function matchAll(string, regex) {
  if (typeof string.matchAll === 'function') {
    return Array.from(string.matchAll(regex));
  }

  var matches = [];
  var match;

  while (match = regex.exec(string)) {
    matches.push(match);
  }

  return matches;
};

exports.matchAll = matchAll;

var getPreviousSibling = function getPreviousSibling(className, element) {
  try {
    var contains = function contains(element) {
      return element && element.classList.contains(className);
    };

    if (contains(element)) {
      return element;
    }

    while ((element = element && element.parentElement) && !contains(element)) {
      ;
    }
  } catch (e) {
    warn(e);
  }

  return element;
};

exports.getPreviousSibling = getPreviousSibling;

var isChildOfElement = function isChildOfElement(element, target) {
  var cb = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  try {
    var contains = function contains(element) {
      if (cb) {
        var res = cb(element);

        if (typeof res === 'boolean') {
          return res;
        }
      }

      return element && element === target;
    };

    if (contains(element)) {
      return element;
    }

    while ((element = element && element.parentElement) && !contains(element)) {
      ;
    }
  } catch (e) {}

  return element;
};

exports.isChildOfElement = isChildOfElement;

var roundToNearest = function roundToNearest(num, target) {
  var diff = num % target;
  return diff > target / 2 ? num - diff + target : num - diff;
};

exports.roundToNearest = roundToNearest;

var isInsideScrollView = function isInsideScrollView(currentElement) {
  var returnElement = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var elem = getPreviousSibling('dnb-scroll-view', currentElement);

  if (returnElement) {
    return elem == window ? null : elem;
  }

  return elem == window ? false : Boolean(elem);
};

exports.isInsideScrollView = isInsideScrollView;

var warn = function warn() {
  if (typeof process !== 'undefined' && typeof console !== 'undefined' && process.env.NODE_ENV !== 'production' && typeof console.log === 'function') {
    var _console;

    for (var _len3 = arguments.length, e = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      e[_key3] = arguments[_key3];
    }

    (_console = console).log.apply(_console, ['Eufemia:'].concat(e));
  }
};

exports.warn = warn;

var convertJsxToString = function convertJsxToString(elements) {
  var separator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

  if (!Array.isArray(elements)) {
    elements = [elements];
  }

  var process = function process(word) {
    if (_react.default.isValidElement(word)) {
      if (typeof word.props.children === 'string') {
        word = word.props.children;
      } else if (Array.isArray(word.props.children)) {
        word = word.props.children.reduce(function (acc, word) {
          if (typeof word !== 'string') {
            word = process(word);
          }

          if (typeof word === 'string') {
            acc = acc + word;
          }

          return acc;
        }, '');
      } else {
        return null;
      }
    }

    return word;
  };

  return elements.map(function (word) {
    return process(word);
  }).filter(Boolean).join(separator);
};

exports.convertJsxToString = convertJsxToString;

var InteractionInvalidation = function () {
  function InteractionInvalidation() {
    _classCallCheck(this, InteractionInvalidation);

    this.bypassElement = null;
    this.bypassSelectors = [];
    return this;
  }

  _createClass(InteractionInvalidation, [{
    key: "setBypassElement",
    value: function setBypassElement(bypassElement) {
      if (bypassElement instanceof HTMLElement) {
        this.bypassElement = bypassElement;
      }

      return this;
    }
  }, {
    key: "setBypassSelector",
    value: function setBypassSelector(bypassSelector) {
      if (!Array.isArray(bypassSelector)) {
        bypassSelector = [bypassSelector];
      }

      this.bypassSelectors = bypassSelector;
      return this;
    }
  }, {
    key: "activate",
    value: function activate() {
      var targetElement = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (!this.nodesToInvalidate) {
        this._runInvalidaiton(targetElement);
      }
    }
  }, {
    key: "revert",
    value: function revert() {
      this._revertInvalidation();

      this.nodesToInvalidate = null;
    }
  }, {
    key: "_runInvalidaiton",
    value: function _runInvalidaiton(targetElement) {
      if (typeof document === 'undefined') {
          return;
        }

      this.nodesToInvalidate = this.getNodesToInvalidate(targetElement);

      if (Array.isArray(this.nodesToInvalidate)) {
        this.nodesToInvalidate.forEach(function (node) {
          try {
            if (node && typeof node._orig_tabindex === 'undefined' && node.hasAttribute('tabindex')) {
              node._orig_tabindex = node.getAttribute('tabindex');
            }

            if (node && typeof node._orig_ariahidden === 'undefined' && node.hasAttribute('aria-hidden')) {
              node._orig_ariahidden = node.getAttribute('aria-hidden');
            }

            node.setAttribute('tabindex', '-1');
            node.setAttribute('aria-hidden', 'true');
          } catch (e) {}
        });
      }
    }
  }, {
    key: "_revertInvalidation",
    value: function _revertInvalidation() {
      if (!this.nodesToInvalidate) {
        return;
      }

      this.nodesToInvalidate.forEach(function (node) {
        try {
          if (node && typeof node._orig_tabindex !== 'undefined') {
            node.setAttribute('tabindex', node._orig_tabindex);
            node._orig_tabindex = null;
            delete node._orig_tabindex;
          } else {
            node.removeAttribute('tabindex');
          }

          if (node && typeof node._orig_ariahidden !== 'undefined') {
            node.setAttribute('aria-hidden', node._orig_ariahidden);
            node._orig_ariahidden = null;
            delete node._orig_ariahidden;
          } else {
            node.removeAttribute('aria-hidden');
          }
        } catch (e) {}
      });
    }
  }, {
    key: "getNodesToInvalidate",
    value: function getNodesToInvalidate() {
      var targetElement = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (typeof document === 'undefined') {
        return;
      }

      if (typeof targetElement === 'string') {
        targetElement = document.querySelector(targetElement);
      }

      var skipTheseNodes = this.bypassSelectors && this.bypassSelectors.length > 0 ? Array.from((this.bypassElement || document).querySelectorAll(this.bypassSelectors ? this.bypassSelectors.map(function (s) {
        return "".concat(s, " *");
      }).join(', ') : '*')) : [];
      var rootSelector = targetElement ? '*' : 'html *';
      var elementSelector = this.bypassSelectors.map(function (s) {
        return ":not(".concat(s, ")");
      }).join('');
      var selector = "".concat(rootSelector, " ").concat(elementSelector, ":not(script):not(style):not(path)");
      return Array.from((targetElement || document.documentElement).querySelectorAll(selector)).filter(function (node) {
        return !skipTheseNodes.includes(node);
      });
    }
  }]);

  return InteractionInvalidation;
}();

exports.InteractionInvalidation = InteractionInvalidation;

var AnimateHeight = function () {
  function AnimateHeight() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, AnimateHeight);

    this.state = 'init';
    this.onStartStack = [];
    this.onEndStack = [];
    this.opts = opts;
  }

  _createClass(AnimateHeight, [{
    key: "setElem",
    value: function setElem(elem) {
      var _this$elem,
          _this2 = this;

      var container = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      this.elem = elem || typeof document !== 'undefined' && document.createElement('div');

      if (String((_this$elem = this.elem) === null || _this$elem === void 0 ? void 0 : _this$elem.nodeName).toLowerCase() === 'td') {
        this.elem = this.elem.parentElement;
      }

      this.container = container;

      if (this.container) {
        this.onResize = function () {
          clearTimeout(_this2.resizeTimeout);
          _this2.resizeTimeout = setTimeout(function () {
            return _this2.setContainerHeight();
          }, 300);
        };

        window.addEventListener('resize', this.onResize);
      }
    }
  }, {
    key: "removeEndEvents",
    value: function removeEndEvents() {
      if (this.onOpenEnd) {
        this.elem.removeEventListener('transitionend', this.onOpenEnd);
        this.onOpenEnd = null;
      }

      if (this.onAdjustEnd) {
        this.elem.removeEventListener('transitionend', this.onAdjustEnd);
        this.onAdjustEnd = null;
      }

      if (this.onCloseEnd) {
        this.elem.removeEventListener('transitionend', this.onCloseEnd);
        this.onCloseEnd = null;
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      this.removeEndEvents();
      this.isAnimating = false;
      this.onStartStack = null;
      this.onEndStack = null;
      this.stop();
      this.elem = null;
      this.state = 'init';

      if (this.onResize) {
        clearTimeout(this.resizeTimeout);
        window.removeEventListener('resize', this.onResize);
      }
    }
  }, {
    key: "getCloseHeight",
    value: function getCloseHeight() {
      return parseFloat(this.elem.clientHeight);
    }
  }, {
    key: "getOpenHeight",
    value: function getOpenHeight(state) {
      var currentHeight = window.getComputedStyle(this.elem).height;
      this.elem.parentElement.style.position = 'relative';
      this.elem.style.position = 'absolute';
      this.elem.style.visibility = 'hidden';
      this.elem.style.height = 'auto';
      var height = parseFloat(this.elem.clientHeight);
      this.elem.parentElement.style.position = '';
      this.elem.style.position = '';
      this.elem.style.visibility = '';

      switch (state) {
        case 'open':
          this.elem.style.height = this.state === 'init' ? '0' : currentHeight;
          break;
      }

      return height;
    }
  }, {
    key: "onStart",
    value: function onStart(fn) {
      this.onStartStack.push(fn);
    }
  }, {
    key: "onEnd",
    value: function onEnd(fn) {
      this.onEndStack.push(fn);
    }
  }, {
    key: "callOnStart",
    value: function callOnStart() {
      var _this3 = this;

      this.onStartStack.forEach(function (fn) {
        if (typeof fn === 'function') {
          fn(_this3.state);
        }
      });
    }
  }, {
    key: "callOnEnd",
    value: function callOnEnd() {
      var _this4 = this;

      this.isAnimating = false;
      this.removeEndEvents();
      this.resetSuppressAnimation();
      this.onEndStack.forEach(function (fn) {
        if (typeof fn === 'function') {
          fn(_this4.state);
        }
      });
    }
  }, {
    key: "start",
    value: function start(fromHeight, toHeight, _ref12) {
      var _this$opts,
          _this5 = this;

      var animate = _ref12.animate;

      if (animate === false || ((_this$opts = this.opts) === null || _this$opts === void 0 ? void 0 : _this$opts.animate) === false) {
        this.elem.style.height = "".concat(toHeight, "px");
        this.callOnStart();

        try {
          var event = new CustomEvent('transitionend');
          this.elem.dispatchEvent(event);
        } catch (e) {
          warn(e);
        }

        return;
      }

      if (typeof window !== 'undefined' && window.requestAnimationFrame) {
        this.stop();
        this.isAnimating = true;

        if (animate === false) {
          this.suppressAnimation();
        }

        this.callOnStart();
        this.reqId1 = window.requestAnimationFrame(function () {
          _this5.elem.style.height = "".concat(fromHeight, "px");

          if (_this5.container) {
            _this5.container.style.minHeight = "".concat(fromHeight, "px");
          }

          _this5.reqId2 = window.requestAnimationFrame(function () {
            _this5.elem.style.height = "".concat(toHeight, "px");

            _this5.setContainerHeight();
          });
        });
      }
    }
  }, {
    key: "setContainerHeight",
    value: function setContainerHeight() {
      if (this.container) {
        var contentElem = this.elem;

        if (contentElem.offsetHeight > 0) {
          this.container.style.minHeight = "".concat(contentElem.offsetHeight + contentElem.offsetTop, "px");
        }
      }
    }
  }, {
    key: "stop",
    value: function stop() {
      if (typeof window !== 'undefined' && window.requestAnimationFrame) {
        window.cancelAnimationFrame(this.reqId1);
        window.cancelAnimationFrame(this.reqId2);
      }
    }
  }, {
    key: "suppressAnimation",
    value: function suppressAnimation() {
      this.transitionDuration = window.getComputedStyle(this.elem).transitionDuration;
      this.elem.style.transitionDuration = '1ms';
    }
  }, {
    key: "resetSuppressAnimation",
    value: function resetSuppressAnimation() {
      if (this.transitionDuration) {
        this.elem.style.transitionDuration = this.transitionDuration;
        this.transitionDuration = null;
      }
    }
  }, {
    key: "adjustFrom",
    value: function adjustFrom() {
      if (!this.elem) {
        return;
      }

      var height = this.getCloseHeight();
      this.elem.style.height = "".concat(height, "px");
      return height;
    }
  }, {
    key: "adjustTo",
    value: function adjustTo(fromHeight) {
      var _this6 = this;

      var _ref13 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref13$animate = _ref13.animate,
          animate = _ref13$animate === void 0 ? true : _ref13$animate;

      if (!this.elem) {
        return;
      }

      var toHeight = this.getOpenHeight('open');
      this.state = 'adjusting';
      this.removeEndEvents();

      if (!this.onAdjustEnd) {
        this.elem.addEventListener('transitionend', this.onAdjustEnd = function () {
          if (_this6.elem) {
            _this6.elem.style.height = 'auto';
          }

          _this6.state = 'adjusted';

          _this6.callOnEnd();

          _this6.setContainerHeight();
        });
      }

      this.start(fromHeight, toHeight, {
        animate: animate
      });
    }
  }, {
    key: "open",
    value: function open() {
      var _this7 = this;

      var _ref14 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref14$animate = _ref14.animate,
          animate = _ref14$animate === void 0 ? true : _ref14$animate;

      if (!this.elem || this.state === 'opened' || this.state === 'opening') {
        return;
      }

      var height = this.getOpenHeight('open');
      this.state = 'opening';
      this.removeEndEvents();

      if (!this.onOpenEnd) {
        this.elem.addEventListener('transitionend', this.onOpenEnd = function () {
          if (_this7.elem) {
            _this7.elem.style.height = 'auto';
          }

          _this7.state = 'opened';

          _this7.callOnEnd();

          _this7.setContainerHeight();
        });
      }

      this.start(0, height, {
        animate: animate
      });
    }
  }, {
    key: "close",
    value: function close() {
      var _this8 = this;

      var _ref15 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref15$animate = _ref15.animate,
          animate = _ref15$animate === void 0 ? true : _ref15$animate;

      if (!this.elem || this.state === 'closed' || this.state === 'closing') {
        return;
      }

      var height = this.getCloseHeight();

      if (this.state === 'init') {
        height = this.getOpenHeight();
      }

      this.state = 'closing';
      this.removeEndEvents();

      if (!this.onCloseEnd) {
        this.elem.addEventListener('transitionend', this.onCloseEnd = function () {
          if (_this8.elem) {
            _this8.elem.style.visibility = 'hidden';
          }

          _this8.state = 'closed';

          _this8.callOnEnd();
        });
      }

      this.start(height, 0, {
        animate: animate
      });
    }
  }]);

  return AnimateHeight;
}();

exports.AnimateHeight = AnimateHeight;

function convertStatusToStateOnly(status, state) {
  return status ? state : null;
}

function getStatusState(status) {
  return status && status !== 'error' && status !== 'warn' && status !== 'info';
}

function combineLabelledBy() {
  for (var _len4 = arguments.length, params = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
    params[_key4] = arguments[_key4];
  }

  return combineAriaBy('aria-labelledby', params);
}

function combineDescribedBy() {
  for (var _len5 = arguments.length, params = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
    params[_key5] = arguments[_key5];
  }

  return combineAriaBy('aria-describedby', params);
}

function combineAriaBy(type, params) {
  params = params.map(function (cur) {
    if (cur && typeof cur[type] !== 'undefined') {
      cur = cur[type];
    }

    if (typeof cur !== 'string') {
      cur = null;
    }

    return cur;
  });
  params = params.filter(Boolean).join(' ');

  if (params === '') {
    params = undefined;
  }

  return params;
}