import * as React from 'react';

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DatePickerCalendarProps
  extends React.HTMLProps<HTMLElement> {
  id?: string;
  nr?: number;
  month?: Date;
  prevBtn?: boolean;
  nextBtn?: boolean;
  titleFormat?: string;
  dayOfWeekFormat?: string;
  firstDayOfWeek?: string;
  hideNav?: boolean;
  hideDays?: boolean;
  onlyMonth?: boolean;
  hideNextMonthWeek?: boolean;
  noAutofocus?: boolean;
  onHover?: (...args: any[]) => any;
  onSelect?: (...args: any[]) => any;
  onPrev?: (...args: any[]) => any;
  onNext?: (...args: any[]) => any;
  locale?: Object;
  rtl?: boolean;
  isRange?: boolean;
  resetDate?: boolean;
  onKeyDown?: (...args: any[]) => any;
}
export default class DatePickerCalendar extends React.Component<
  DatePickerCalendarProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
