import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';
import { setNextLevel } from '../components/heading/HeadingHelpers';

var H = function (_React$PureComponent) {
  _inherits(H, _React$PureComponent);

  var _super = _createSuper(H);

  function H(props) {
    var _this;

    _classCallCheck(this, H);

    _this = _super.call(this, props);

    if (props.level === 'use') {
      setNextLevel(parseFloat(props.is.substr(1)));
    }

    return _this;
  }

  _createClass(H, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          is = _this$props.is,
          level = _this$props.level,
          style_type = _this$props.style_type,
          size = _this$props.size,
          className = _this$props.className,
          props = _objectWithoutProperties(_this$props, ["is", "level", "style_type", "size", "className"]);

      if (style_type) {
        size = style_type;
      }

      return React.createElement(E, _extends({
        is: is,
        internalClass: classnames(className, size && "dnb-h--".concat(size))
      }, props));
    }
  }]);

  return H;
}(React.PureComponent);

H.defaultProps = {
  className: null,
  level: null,
  is: 'h1',
  size: 'xx-large',
  style_type: null,
  children: null
};
export { H as default };
process.env.NODE_ENV !== "production" ? H.propTypes = _extends({}, spacingPropTypes, {
  className: PropTypes.string,
  is: PropTypes.string,
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  style_type: PropTypes.string,
  children: PropTypes.node
}) : void 0;