import * as React from 'react';
export type DatePickerProviderMinDate = Date | string;
export type DatePickerProviderMaxDate = Date | string;
export type DatePickerProviderRange = boolean | string;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DatePickerProviderProps
  extends React.HTMLProps<HTMLElement> {
  min_date?: DatePickerProviderMinDate;
  max_date?: DatePickerProviderMaxDate;
  return_format?: string;
  range: DatePickerProviderRange;
  setReturnObject: (...args: any[]) => any;
  enhanceWithMethods?: Object;
  attributes?: Object;
  children: React.ReactNode;
}
export default class DatePickerProvider extends React.Component<
  DatePickerProviderProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
