import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Section from '../section/Section';
export default function Inner(_ref) {
  let {
    className
  } = _ref,
      props = _objectWithoutPropertiesLoose(_ref, ["className"]);

  return React.createElement(Section, _extends({
    style_type: "black-3",
    className: classnames('dnb-modal__wrapper__inner', className)
  }, props));
}
process.env.NODE_ENV !== "production" ? Inner.propTypes = {
  className: PropTypes.string
} : void 0;
Inner.defaultProps = {
  className: null
};