import * as React from 'react';
export type ProgressIndicatorCircularProgress = string | number;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ProgressIndicatorCircularProps
  extends React.HTMLProps<HTMLElement> {
  size?: string;
  visible?: boolean;
  complete?: boolean;
  progress?: ProgressIndicatorCircularProgress;
  maxOffset?: number;
  onComplete?: (...args: any[]) => any;
  callOnCompleteHandler?: (...args: any[]) => any;
}
export default class ProgressIndicatorCircular extends React.Component<
  ProgressIndicatorCircularProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
