import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Dd = (p = {}) => React.createElement(E, _extends({
  is: "dd"
}, p));

Dd.tagName = 'dnb-dd';
process.env.NODE_ENV !== "production" ? Dd.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Dd.defaultProps = {
  children: null
};
export default Dd;