import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Dl = p => React.createElement(E, _extends({
  is: "dl"
}, p, {
  skeleton: false
}));

Dl.tagName = 'dnb-dl';
process.env.NODE_ENV !== "production" ? Dl.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Dl.defaultProps = {
  children: null
};
export default Dl;