import * as React from 'react';
export type DtSpace =
  | string
  | number
  | boolean
  | {
      top?: string | number | boolean;
      right?: string | number | boolean;
      bottom?: string | number | boolean;
      left?: string | number | boolean;
    };
export type DtTop = string | number | boolean;
export type DtRight = string | number | boolean;
export type DtBottom = string | number | boolean;
export type DtLeft = string | number | boolean;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface DtProps extends React.HTMLProps<HTMLElement> {
  space?: DtSpace;
  top?: DtTop;
  right?: DtRight;
  bottom?: DtBottom;
  left?: DtLeft;
  children?: React.ReactNode;
}
declare const Dt: React.FC<DtProps>;
export default Dt;
