import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Span = p => React.createElement(E, _extends({
  is: "span"
}, p));

Span.tagName = 'dnb-span';
process.env.NODE_ENV !== "production" ? Span.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Span.defaultProps = {
  children: null
};
export default Span;