import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Th = (p = {}) => React.createElement(E, _extends({
  is: "th"
}, p, {
  internalClass: "dnb-table__th",
  skeleton_method: "font-only"
}));

Th.tagName = 'dnb-table__th';
process.env.NODE_ENV !== "production" ? Th.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Th.defaultProps = {
  children: null
};
export default Th;