import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

const Tr = (p = {}) => React.createElement(E, _extends({
  is: "tr"
}, p, {
  internalClass: "dnb-table__tr",
  skeleton_method: "font-only"
}));

Tr.tagName = 'dnb-table__tr';
process.env.NODE_ENV !== "production" ? Tr.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Tr.defaultProps = {
  children: null
};
export default Tr;