import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M4.5 11H11.5M2.5 14.502H13.5C14.3284 14.502 15 13.8304 15 13.002V3.00195C15 2.17353 14.3284 1.50195 13.5 1.50195H2.5C1.67157 1.50195 1 2.17353 1 3.00195V13.002C1 13.8304 1.67157 14.502 2.5 14.502Z",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function minimize(props) {
  return React.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default minimize;