import React from 'react';
import SummaryTable from './SummaryTable';
import Button from '../../components/button/Button';

var _ref = React.createElement("div", {
  className: "example-box"
}, React.createElement(SummaryTable, {
  prev_href: "?prev",
  next_href: "?next"
}));

var _ref2 = React.createElement("h3", null, "Custom left nav content");

var _ref3 = React.createElement("div", {
  className: "dnb-summary-table__item"
}, React.createElement(Button, {
  text: "Lagre",
  title: "Lagre",
  icon_position: "left",
  variant: "secondary",
  icon: "save"
}));

var _ref4 = React.createElement("div", {
  className: "dnb-summary-table__item"
}, React.createElement(Button, {
  text: "Avbryt",
  title: "Avbryt",
  icon_position: "left",
  variant: "secondary",
  icon: "close"
}));

class Example extends React.PureComponent {
  render() {
    return React.createElement(React.Fragment, null, _ref, React.createElement("div", {
      className: "example-box"
    }, React.createElement(SummaryTable, {
      render_left_content: () => _ref2
    }, _ref3, _ref4)));
  }

}

export { Example };
export default Example;