import * as React from 'react';
export type ViewTitleChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ViewTitleProps extends React.HTMLProps<HTMLElement> {
  text?: string;
  tag?: string;
  class?: string;
  className?: string;
  children?: ViewTitleChildren;
}
export default class ViewTitle extends React.Component<
  ViewTitleProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
