import * as React from 'react';
export type LineTitleChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface LineTitleProps extends React.HTMLProps<HTMLElement> {
  content?: string;
  modifier?: string;
  tag?: string;
  class?: string;
  className?: string;
  children?: LineTitleChildren;
}
export default class LineTitle extends React.Component<
  LineTitleProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
