import * as React from 'react';
export type TooltipPortalTarget = string | Object;
export type TooltipPortalHideDelay = string | number;

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface TooltipPortalProps extends React.HTMLProps<HTMLElement> {
  internal_id?: string;
  target: TooltipPortalTarget;
  active?: boolean;
  group?: string;
  hide_delay?: TooltipPortalHideDelay;
}
export default class TooltipPortal extends React.Component<
  TooltipPortalProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
