import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import H from './H';

var H5 = function H5(props) {
  return React.createElement(H, _extends({
    is: "h5"
  }, props));
};

H5.tagName = 'dnb-h5';
process.env.NODE_ENV !== "production" ? H5.propTypes = _extends({}, spacingPropTypes, {
  level: PropTypes.string,
  size: PropTypes.oneOf(['xx-large', 'x-large', 'large', 'medium', 'basis', 'small', 'x-small']),
  children: PropTypes.node
}) : void 0;
H5.defaultProps = {
  level: null,
  size: 'small',
  children: null
};
export default H5;