import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import PropTypes from 'prop-types';
import { spacingPropTypes } from '../components/space/SpacingHelper';
import E from './Element';

var Td = function Td() {
  var p = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return React.createElement(E, _extends({
    is: "td"
  }, p, {
    internalClass: "dnb-table__td",
    skeleton_method: "font-only"
  }));
};

Td.tagName = 'dnb-table__td';
process.env.NODE_ENV !== "production" ? Td.propTypes = _extends({}, spacingPropTypes, {
  children: PropTypes.node
}) : void 0;
Td.defaultProps = {
  children: null
};
export default Td;