import * as React from 'react';
export type ActionNavChildren =
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface ActionNavProps extends React.HTMLProps<HTMLElement> {
  prev_href?: string;
  next_href?: string;
  prev_text?: string;
  next_text?: string;
  prev_title?: string;
  next_title?: string;
  class?: string;
  className?: string;
  children?: ActionNavChildren;
}
export default class ActionNav extends React.Component<
  ActionNavProps,
  any
> {
  static defaultProps: object;
  render(): JSX.Element;
}
