import * as React from 'react';
export type MainNavData = string | any[];
export type MainNavNotificationAmount = string | number;
export type MainNavChildren = React.ReactNode | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface MainNavProps extends React.HTMLProps<HTMLElement> {
  data?: MainNavData;
  baseurl?: string;
  notification_amount?: MainNavNotificationAmount;
  class?: string;
  className?: string;
  children?: MainNavChildren;
}
export default class MainNav extends React.Component<MainNavProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
