import "core-js/modules/es.array.concat.js";
import _typeof from "@babel/runtime/helpers/esm/typeof";
export var ERROR_HARMLESS = 100;
export var ERROR_FATAL = 500;
export function ErrorHandler(error) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    message: null
  },
      message = _ref.message;

  var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ERROR_HARMLESS;

  if (_typeof(error) === 'object') {
    message = error.message;
  }

  this.err = new Error("".concat(error, "\n\n").concat(message));

  if (code === ERROR_FATAL) {
    throw this.err;
  } else {
    console.log(this.err);
  }
}