import { registerElement } from '../shared/component-helper';
import DrawerList from './drawer-list/DrawerList';
import ScrollView from './scroll-view/ScrollView';
export { DrawerList, ScrollView };
export var getFragments = function getFragments() {
  return {
    DrawerList: DrawerList,
    ScrollView: ScrollView
  };
};
var webFragmentsAreEnabled = false;
export var enableWebFragments = function enableWebFragments() {
  if (webFragmentsAreEnabled) return false;
  webFragmentsAreEnabled = true;
  var fragments = getFragments();

  for (var c in fragments) {
    if (fragments[c] && fragments[c].tagName) {
      registerElement(fragments[c].tagName, fragments[c], fragments[c].defaultProps);
    }
  }
};
export default {
  enableWebFragments: enableWebFragments
};