import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M0.75 21L23.25 21M0.75 12L23.25 12M0.75 3L23.25 3",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round"
});

function hamburger_medium(props) {
  return React.createElement("svg", _extends({
    width: 24,
    height: 24,
    viewBox: "0 0 24 24",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default hamburger_medium;