import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';

var _ref = React.createElement("path", {
  d: "M7.04545 10.1818H15M12.7727 12.4091L15 10.1818M15 10.1818L12.7727 7.95455M8.95455 5.72727H1M3.22727 7.95455L1 5.72727M1 5.72727L3.22727 3.5",
  stroke: "black",
  strokeWidth: 1.5,
  strokeLinecap: "round",
  strokeLinejoin: "round"
});

function transfer(props) {
  return React.createElement("svg", _extends({
    width: 16,
    height: 16,
    viewBox: "0 0 16 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, props), _ref);
}

export default transfer;