import * as React from 'react';
export type GridChildren =
  | string
  | React.ReactNode
  | ((...args: any[]) => any);

/**
 * NB: Do not change the docs (comments) in here. The docs are updated during build time by "generateTypes.js" and "fetchPropertiesFromDocs.js".
 */
export interface GridProps extends React.HTMLProps<HTMLElement> {
  class?: string;
  className?: string;
  children?: GridChildren;
}
export default class Grid extends React.Component<GridProps, any> {
  static defaultProps: object;
  render(): JSX.Element;
}
