import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
export default function AlignmentHelper(_ref) {
  var className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ["className", "children"]);

  return React.createElement("span", _extends({
    className: classnames('dnb-alignment-helper', className),
    "aria-hidden": true
  }, props), children);
}
process.env.NODE_ENV !== "production" ? AlignmentHelper.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string
} : void 0;
AlignmentHelper.defaultProps = {
  children: null,
  className: null
};